/*****************************************************
Chip type           : ATmega16
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd4x40.h>    
#include <stdio.h>
#include <math.h>
#include <define.h>
//def
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7 

#define BD_9600  0xCF
#define BD_57600 0x22

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)
#define RX_BUFFER_SIZE 34
#define TX_BUFFER_SIZE 8
#define true    1
#define false   0 
#define stop    0
#define run     1 
#define nuluj_tlac key_pressed=0x00;
#define _WDR #asm("wdr"); //reset watchdog

typedef unsigned char byte;

volatile unsigned char rx_wr_index,rx_rd_index,rx_counter;      
volatile unsigned char tx_wr_index,tx_rd_index,tx_counter;
//volatile char key; 
volatile unsigned int key_down,key_down0,key_pressed;
volatile unsigned char tx_buffer[TX_BUFFER_SIZE];
volatile unsigned char rx_buffer[RX_BUFFER_SIZE];
// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;         


volatile float meas_data[16],frekv=0;
volatile unsigned char rozsahy[2][3],polsek=0,sek=0,zob=1,
                       sek_m,read_enable=true,status=run,
                       status_harm=stop,k_harm=1,poslane=true;
#pragma warn-
eeprom volatile unsigned char e_zob,e_rozsahy[2][3];
#pragma warn+


//------------------------------------------------
#pragma used+
void send(unsigned char c)
{
while (!(UCSRA & DATA_REGISTER_EMPTY))  ;
UDR=c;
}
#pragma used-
//------------------------------------------------
// function used to define user characters
void define_char(byte flash *pc,byte char_code)
{
byte i,a;
_en1_msk=LCD_EN2;
a=(char_code<<3)|0x40;
for (i=0; i<8; i++) 
{                
_en1_msk=LCD_EN1;
lcd_write_byte(a,*pc);
_en1_msk=LCD_EN2;
lcd_write_byte(a++,*pc++);
}
}               
//------------------------------------------------

//------------------------------------------------
void co_sa_vypisuje()
{ char x,s[41];
//lcd_clear();
for (x=0;x<4;x++){
lcd_gotoxy(0,x);                               
lcd_putsf(text[zob][x]);
} 
_WDR;
}   


void posli_zob()
{unsigned char pom;
 
 pom=read_enable;
 read_enable=false;
 send(4);
 send(0x30);
 send(zob); 
 send(0xbb);
 read_enable=pom;
}



//------------------------------------------------ 
void vypis_rozsahy()
{ 
 char x,s[41];
lcd_clear();
lcd_putsf("L1     L2     L3");
lcd_gotoxy(20,1);
lcd_putsf("Voltage");
lcd_gotoxy(20,2);
lcd_putsf("Current");
for (x=0;x<2;x++)
 {
 
  sprintf(s,"%p  %p  %p",
  rozsahy_text[x][rozsahy[x][0]],
  rozsahy_text[x][rozsahy[x][1]],
  rozsahy_text[x][rozsahy[x][2]]);
  lcd_gotoxy(0,x+1);
  lcd_puts(s);     
 } 
}  
//------------------------------------------------
//-Prerusenie od casovaca 0-KLAVESNICA------------
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{ unsigned int key_inl; 

// row1=0;   
// #asm("nop");         
// key_inl=key_in;
// #asm("nop");
// key_down=(key_down&0xffffff00)|key_inl;
// row2=0;
// row1=1;     
// #asm("nop"); 
// key_inl=key_in;
// #asm("nop");
// key_down=(key_down&0xffff00ff)|(key_inl<<8);
// row3=0;    
// row2=1;
// #asm("nop");                                        
// key_inl=key_in;
// key_down=(key_down&0xff00ffff)|(key_inl<<16);
// row4=0;
// row3=1;
// #asm("nop");                                         
// key_inl=key_in;
// #asm("nop");
// key_down=(key_down&0x00ffffff)|(key_inl<<24);
// row4=1;     

 row1=0;   
 #asm("nop"); 
 key_inl=key_in;
 key_down=(key_down&0xff00)|key_inl;
 row1=1;
 #asm("nop");  
 row2=0;     
 #asm("nop"); 
  key_inl=key_in;
 key_down=(key_down&0x00ff)|(key_inl<<8);
 row2=1;
                                  
key_down=~key_down;
if (key_down!=key_down0)  //doslo k zmene key_down
 key_pressed=key_down & (key_down0 ^ key_down);   
else
 if (key_down==0x0) 
  polsek++ ; //ak je drzane stale to iste tlacidlo
key_down0=key_down;  
sek++;  
sek_m++;
if (sek==15)
 {
 // if ((read_enable==true)&&(poslane==true)) 
  if (read_enable==true)
   {  
    poslane=false;
    send(3);       
    send(0x10);  //0x10
    send(0xbb); 
   }
  sek=0;
 }   
 
}               
//------------------------------------------------
void vypis_namerane()
{ char x=0,y=0,s[41];
  volatile char temp_text[4][7];
      
 for  (x=0;x<4;x++){
y=x*4;
sprintf(temp_text[0],"%f",meas_data[y++]);
sprintf(temp_text[1],"%f",meas_data[y++]);
sprintf(temp_text[2],"%f",meas_data[y++]);
sprintf(temp_text[3],"%f",meas_data[y]); 
for (y=0;y<4;y++){
temp_text[y][6]=0;
if (temp_text[y][5]==0x2e) temp_text[y][5]=' '; //ak je na konci bodka tak nezobraz ju
}                    
//y=x*4;
sprintf(s,"%c=%s %c=%s %c=%s %c=%s ",
velic_text[zob][0][x],temp_text[0],
velic_text[zob][1][x],temp_text[1],
velic_text[zob][2][x],temp_text[2],
velic_text[zob][3][x],temp_text[3]
);         
lcd_gotoxy(0,x);                               
lcd_puts(s); 
}  
lcd_gotoxy(36,0);
lcd_putsf(status_text[status]);
lcd_gotoxy(36,1);
lcd_putsf(status_harm_text[status_harm]);
lcd_gotoxy(36,2);
if (status_harm==run)
  {     

   sprintf(temp_text[3],"k=%d ",k_harm); 
   if (k_harm>9) temp_text[3][4]=0;
   lcd_puts(temp_text[3]);
  }
else
  {
   lcd_putsf("    ");
  }    
lcd_gotoxy(36,3);
  if (frekv<1000) 
  {
   sprintf(temp_text[3],"%f",frekv);          
   if (temp_text[3][3]=='.') temp_text[3][3]=' ';
   }
  else 
  {
   sprintf(temp_text[3],"%f",frekv/1000);    
   if (temp_text[3][2]=='.') temp_text[3][2]=' ';\   
    temp_text[3][3]='k';        
  } 
  
 temp_text[3][4]=0;
if (temp_text[3][3]=='.') temp_text[3][3]=' ';
lcd_puts(temp_text[3]);
}
//------------------------------------------------
void process_RX_data()
{ unsigned char x=2,y=0,*ptr;
  int c,c2; 
  float f;
read_enable=false; 
poslane=true;
for (x=1;x<rx_buffer[0]-1;x++)
{ 
y^=rx_buffer[x];
}

if (y==rx_buffer[rx_buffer[0]-1])
{ 
if (rx_buffer[1]==1)  //nestavit zobrazovene veliciny
{  
 zob=rx_buffer[2];  
 //send(OK);
}
if (rx_buffer[1]==2)  //nestavit rozsahy
{
 ptr=rozsahy; 
  for (x=2;x<8;x++)
    {
     *ptr++=rx_buffer[x];
    } 
// send(OK);    
}
if (rx_buffer[1]==3) //namerane hodnoty pre prve dva riadky
{                            
  y=2;
  for (x=0;x<8;x++)
  {
   //spodne| vrchne |exponent
   c=rx_buffer[y++];
   c2=rx_buffer[y++]; 
   c=c|(c2<<8); 
   c2=rx_buffer[y++];                
   f=(c*exponenty[0][(c2&0b0000111)]*exponenty[1][(c2&0b01110000)>>4])/32767.0;
   meas_data[x]=f;   
  }   
  //send(OK);
}  
if (rx_buffer[1]==5) //namerane hodnoty pre prve dva riadky
{                            
  y=2;
  for (x=8;x<16;x++)
  {
   //spodne| vrchne |exponent
   c=rx_buffer[y++];
   c2=rx_buffer[y++];
   c=c|(c2<<8);                 
   c2=rx_buffer[y++];                
   f=(c*exponenty[0][(c2&0b0000111)]*exponenty[1][(c2&0b01110000)>>4])/32767.0;
   meas_data[x]=f;   
  } 

 } 
if (rx_buffer[1]==4)
{
 kontrast=rx_buffer[2];
 light=rx_buffer[3];

}       
if (rx_buffer[1]==8) //prijatie frekvencie
{
 c=rx_buffer[2];
 c2=rx_buffer[3];
 c=c|(c2<<8);
 frekv= (status_harm==stop)? 625000.0/(1.0*c):625000.0*k_harm/(1.0*c);
}       

}


 UCSRB|=0x80;  //interrupt RX on
 read_enable=true;
}

//------------------------------------------------
// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;

status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR ))==0)
   {
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == rx_buffer[0]) 
   {
    rx_wr_index=0;    
    UCSRB&=0b01111111;  //interrupt RX off
    process_RX_data();   
    }
   };   
}
//------------------------------------------------ 
void lcd_cursor_on(unsigned char x)
{     
    _en1_msk=LCD_EN2;
    _lcd_ready();
    _lcd_write_data(0xc);  
    _en1_msk=LCD_EN1;
    _lcd_ready();
    _lcd_write_data(0xc); 
    
  if (x==1){
    _en1_msk=LCD_EN1;
    _lcd_ready();
    _lcd_write_data(0xf);
   
    }
    if (x==2){
    _en1_msk=LCD_EN2;
    _lcd_ready();
    _lcd_write_data(0xf);
   
    }
}


//------------------------------------------------ 
void lcd_gotoxy_cursor(unsigned char x,unsigned char y)
{
 if (y<2)
  lcd_cursor_on(1);
  else
  lcd_cursor_on(2);
  lcd_gotoxy(x,y);
}

//------------------------------------------------        
                                                          
void nastav_zobrazenie()
{ unsigned char pom;                     
lcd_clear();        
pom=zob;
read_enable=false;
do
{
 co_sa_vypisuje();
 lcd_gotoxy(0,0);
 lcd_cursor_on(1);
 key_pressed=0;
 while(key_pressed==0)  _WDR;;
 if (key_pressed==kdisp)
 if (status_harm==run)
    zob= (zob==4)? 5:4;
   else  
     zob= (zob<3)? zob+1:0;
 }while ((key_pressed!=kesc)&&(key_pressed!=kenter)); 
 lcd_clear();
  if (key_pressed==kenter)
       { 
         send(4);
         send(0x30);  //0x30
         send(zob); 
         send(0xbb);
        } 
    else zob=pom;    
read_enable=true;
 lcd_cursor_on(3);
}

//------------------------------------------------        
void nastav_rozsahy()
{unsigned char posx=0,posy=0,*ptr_ram;
 unsigned char pom[2][3] ;
 
 for (posx=0;posx<3;posx++)
  for (posy=0;posy<4;posy++)  
  pom[posx][posy]=rozsahy[posx][posy];
  
  posx=0;posy=0;
  
 read_enable=false;
//------------rozsahy---------------------------  
            key_pressed=0x3;                   
            posx=0;
            posy=0;
            while ((key_pressed!=kesc)&&(key_pressed!=kenter))
            { 
              _WDR;
             if (key_pressed!=0)
             {  
               #asm("nop");                                          
               if (key_pressed==kright)
                if (posx<2) posx++;else posx=0;
                
                if (key_pressed==krang)        
                if (rozsahy[posy][posx]<4) rozsahy[posy][posx]++;
                 else  rozsahy[posy][posx]=0;     
                 
               if (key_pressed==kleft)
                if (posx>0) posx--;else posx=2;
            
               if ((key_pressed==kup)||(key_pressed==kdown))
                posy= (posy==0)? 1:0;
               key_pressed=0; 
        
             vypis_rozsahy(); 
             lcd_gotoxy_cursor(posx*7,posy+1);   
                            
             }
            }
//             ptr_ram=rozsahy;
//             ptr_eeprom=e_rozsahy;
//             for (posx=0;posx<6;posx++)               
//                 *ptr_eeprom++=*ptr_ram++;               
           lcd_cursor_on(3); 
           lcd_clear();                               

 if (key_pressed==kenter)
  { 
         send(9);
         send(4);
         send(rozsahy[1][0]);
         send(rozsahy[1][1]);
         send(rozsahy[1][2]);          
         send(rozsahy[0][0]);
         send(rozsahy[0][1]);
         send(rozsahy[0][2]); 
         send(0xbb); 
   }                 
   else
      for (posx=0;posx<3;posx++)
        for (posy=0;posy<4;posy++)  
         rozsahy[posx][posy]=pom[posx][posy];
  
   read_enable=true;  
key_pressed=0x0;                
}
//------------------------------------------------        

//------------------------------------------------        

void menu()
{ unsigned char pos=0,x,posy=0,*ptr_ram;
eeprom unsigned char *ptr_eeprom;
  char s[40];
  unsigned int per;
read_enable=false;  
 zaciatok:
 pos=0;     
 key_pressed=0x0; 
 lcd_clear();
 lcd_putchar(3);
 lcd_putsf("Ranges");
 lcd_gotoxy(1,1);
 lcd_putsf("Wattmeter restart");
 lcd_gotoxy(1,2);
 lcd_putsf("Automatic calibration");
 lcd_gotoxy(1,3);
 lcd_putsf("Display settings"); 
 
 while (key_pressed!=kesc){
 _WDR;
 if (key_pressed!=0){  
  #asm("nop");
  #asm("nop");
  #asm("nop");
//------------rozsahy---------------------------  
 if ((key_pressed==kright)&&(pos==0))
          {
            nastav_rozsahy();              
            goto zaciatok;
          }                                 
          
//---------veliciny-------------------------  
  if ((key_pressed==kright)&&(pos==1))
     {   
      lcd_clear();
      for(;;);
     }                                  
//--------------display-----------------------     
  if ((key_pressed==kright)&&(pos==3))
    {
     lcd_clear();
     posy=0;            
     goto pisper;
     while (key_pressed!=kesc)
       { _WDR;
          if ((key_pressed==kup) ||(key_pressed==kdown)){
            posy= (posy==0)? 1:0;                          
            goto pisper;
           }
          
          if ((key_pressed==kdisp)|| 
              ((key_down==kdisp)&&(polsek>10)))
           {
            if (posy==0) kontrast-=12;
             else light-=12;  
pisper:     polsek=0;            
            per=kontrast;
            per=100-(per*100)/256;
            sprintf(s,"Contrast   :%u%% ",per);
            lcd_gotoxy(0,0);
            lcd_puts(s);                     
            per=light;
            per=100-(per*100)/256;
            sprintf(s,"Back light :%u%%  ",per);
            lcd_gotoxy(0,1);
            lcd_puts(s);  
            lcd_gotoxy_cursor(12,posy);
            key_pressed=0x0;
           }
       }  
     goto zaciatok;  
    }
//-----kalibracia------------------------
      if ((key_pressed==kright)&&(pos==2))
      { 
        key_pressed=0;
        lcd_clear();
        lcd_putsf("Disconnect all terminals and short");
        lcd_gotoxy(0,1);
        lcd_putsf("circuit them,or connect them with ground");
        lcd_gotoxy(0,3);
        lcd_putsf("Press START key if done,or ESC to exit...");
        while (1){
         _WDR;
         if (key_pressed==kesc) goto zaciatok;
         if (key_pressed==kenter)
          {
           key_pressed=0;   
           send(3); //kolko bajtov sa posiela
           send(1); //zapis do premennej fcn 
           send(2); //fcn=3  => kalibracia
           lcd_clear();
           lcd_gotoxy(6,0);
           lcd_putsf("Calibrating is completed!");
           lcd_gotoxy(0,26);
           lcd_putsf("Press any key...");
           while (key_pressed==0) _WDR;;
           goto zaciatok;
           
          }
        }
       }
 
  if (key_pressed==kup) 
   if (pos>0) pos--;
    else pos=3; 
    
  if (key_pressed==kdown) 
   if (pos<3) pos++;
    else pos=0;    
     
  key_pressed=0x0;
 for (x=0;x<4;x++){   
  lcd_gotoxy(0,x);
  lcd_putchar(' ');  
  }
  lcd_gotoxy(0,pos);
  lcd_putchar(3);  
  } 
 }
lcd_cursor_on(3); //vypnutie kurzorov 
read_enable=true;
}                                               
//---------------------------------------------- 
// posle status a ktora harmonicka sa ma pocitat
void send_harm()
{ char st;
 st=read_enable;
 read_enable=false;
 send(4);
 send(5);
 send(status_harm);
 send(k_harm);
 read_enable=st;
}
//---------------------------------------------- 
void main(void)
{ char s[30];
unsigned char x,y,*ptr_ram;
eeprom unsigned char *ptr_eeprom;

 //inicializacia
 
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTA=0xFF;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;
// Port C initialization
// Func7=Out Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
// State7=0 State6=0 State5=T State4=T State3=T State2=T State1=0 State0=0 
PORTC=0x00;
DDRC=0xC3;
 // Port D initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T 
PORTD=0b11001101;
DDRD=0b00110010;
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x05;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Fast PWM top=00FFh
// OC1A output: non-Inv.
// OC1B output: non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0xA1;
TCCR1B=0x0a;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x10;
OCR1BH=0x00;
OCR1BL=0x80;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 57600 (Double Speed Mode)
UCSRA=0x02;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
//UBRRL=0x22;
UBRRL=19;
// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;              

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/1024k
#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif


// LCD module initialization
lcd_init();
define_char(char1,1);     //znak fi
// define_char(char2,2);  //  znak omega
define_char(char3,3);     //sipka 
define_char(char4,4);
define_char(char5,5);
define_char(char6,6);
// if (lcd==0) error|=lcd_err;
// Global enable interrupts
#asm("sei")
PORTC|=0b11000011;


key_down0=0x0;
key_down=key_down0;
key_pressed=0x0;  

//nacitanie nastaveni z EEPROM
// ptr_ram=velic_typ;
// ptr_eeprom=e_velic_typ;
// for (x=0;x<16;x++)               
//  *ptr_ram++=*ptr_eeprom++;
// ptr_ram=rozsahy;
// ptr_eeprom=e_rozsahy;
// for (x=0;x<6;x++)               
//  *ptr_ram++=*ptr_eeprom++; 
      
posli_zob();  

lcd_clear();
lcd_gotoxy(6,1);
lcd_putsf("THREE PHASE VECTOR WATTMETER");
for (x=0;x<6;x++)  rozsahy[x][0]=0;
sek_m=0;
while (sek_m<100) _WDR;;

         send(9);
         send(4);
         send(rozsahy[1][0]);
         send(rozsahy[1][1]);
         send(rozsahy[1][2]);          
         send(rozsahy[0][0]);
         send(rozsahy[0][1]);
         send(rozsahy[0][2]); 
         send(0xbb); 
 
for (;;)
    {   

     if (key_down==kdisp){   //vypise co sa vypisuje      
      co_sa_vypisuje();
      while (key_down==kdisp) _WDR;;
      lcd_clear();
      }      
      if (key_down==krang){ //vypise rozsahy
      vypis_rozsahy();
      while (key_down==krang) _WDR;;
      lcd_clear();
      }      
        else
         vypis_namerane();
     if (key_pressed==kstop){                  
                              if (status==run)
                               {  
                                 read_enable=false; 
                                 send(2);       
                                 send(6); 
                                 //send(0xbb); 
                                 read_enable=true;                                
                                status=stop;
                               }
                              else
                               {
                                 read_enable=false; 
                                 send(2);       
                                 send(7); 
                                // send(0xbb); 
                                 read_enable=true;                             
                                status=run;  
                               } 
                              nuluj_tlac;
                              }
     if (key_pressed==kmenu) menu();
     if (key_down==(krang|kshift)) 
      {
        nastav_rozsahy();  
        nuluj_tlac;
       } 
     if (key_down==(kdisp|kshift)) nastav_zobrazenie();  
     if (key_pressed==krms){
      if (status_harm==stop)            
       zob=0;              
      else   
       zob=4;
       posli_zob();
      }    
     if (key_pressed==kpow)
      {            
        if (status_harm==stop)            
       zob=1;              
      else   
       zob=5;
       posli_zob();
      }
     if (key_pressed==kmax)
      {            
        if (status_harm==stop)            
       zob=2;              
      else   
       zob=4;
       posli_zob();
      }  
     if ((key_pressed==kavg)&&(status_harm==stop))
      {            
       zob=3;       
       posli_zob();
      }             
     if (key_pressed==kharm) {
                           if (status_harm==run)
                               {  
                                                              
                                status_harm=stop;
                                zob=0;
                                posli_zob();

                               }
                              else
                               {
                                
                                status_harm=run; 
                                if ((zob!=1)&&(zob!=4))
                                {  
                                  zob=4;
                                  posli_zob();           

                                } 
                               } 
                              nuluj_tlac;
                              send_harm();
                            }
     if (key_pressed==kup)   {
                              nuluj_tlac;  
                              k_harm= (k_harm<50)? k_harm+1:0;
                              send_harm();
                             } 
     if (key_pressed==kdown) {
                              nuluj_tlac;   
                              k_harm= (k_harm>0)?  k_harm-1:50;
                              send_harm();
                             } 
    _WDR;                         
    };
}
