/*****************************************************************************
*
* Motorola Inc.
* (c) Copyright 2002 Motorola, Inc.
* ALL RIGHTS RESERVED.
*
******************************************************************************
*
* File Name: appconfig.h
*
* Description: file for static configuration of the application
*              (initial values, interrupt vectors)
*
* Modules Included:
*
*****************************************************************************/

#ifndef __APPCONFIG_H
#define __APPCONFIG_H

/*.*************************************************************************
*
*    DSP56F800 configuration file generated by Graphical Configuration Tool r3.0 
*
****************************************************************************.*/

#define   DSP56F805
#define   EXTCLK   8000000L

/*. Initialized Peripheral Modules:
--------------------------------------------------------------------------
          Module:  Clock:         Enabled interrupts:
          OCCS     40.000 MHz     -
          QT_A1    20.000 MHz     Compare
          QT_B0    20.000 MHz     Compare
          QT_C0    20.000 MHz     Compare
          QT_D0    0.625 MHz      -
          GPIO_B                  -
          GPIO_D                  -
          SCI_0    100000.000 Bd  RX Error, RX Full
          SCI_1    100000.000 Bd  TX Empty, RX Full
          ADC_A    4.000 MHz      Conversion complete, High limit error, Low limit error
          ITCN                    -
          PCMASTER                -
.*/

/*.
    OCCS Configuration
--------------------------------------------
    Core frequency: 80.000 MHz
    VOC frequency: 160.000 (O.K.) MHz
    Loss of lock 0 (coarse): Disable 
    Loss of lock 1 (fine): Disable 
    Loss of reference clock interrupt: Disable
    Enable lock detector: Enable

    COP operation: Disable
    COP timeout: 8388.608 ms
    COP run in Stop Mode: Disable
    COP run in Wait Mode: Disable
    COP write protect: Disable
.*/
#define OCCS_PLLCR_INIT                   0x0082
#define OCCS_PLLDB_INIT                   0x2013

/*.
    QT_A1 Configuration
--------------------------------------------
    Count mode: Count rising edges of primary source 
    0: Prescaler (IPB clock/ 2) , : Counter #0 input pin 
    Input polarity: True , Output polarity: True 
    Input capture mode: Capture disabled, input edge flag INTdisabled , Output mode: Asserted while counter is active 
    Count once: Count repeatedly , Count length: Count until compare, then reinitialize , Count direction: Count up 
    Output : Disable, Force OFLAG output: Disable, Master mode: Disable
    Forced OFLAG value: Disable, Enable external OFLAG force: Disable, Co-channel initialization: Disable
    Interrupts: Overflow: Disable
                Input edge: Disable
                Compare: Enable
.*/
#define QT_A1_CTRL_INIT                   0x3220
#define QT_A1_SCR_INIT                    0x4000
#define QT_A1_CMP1_INIT                   0x0c35
#define INT_VECTOR_ADDR_43                vypocty_interrupt
#define INT_PRIORITY_LEVEL_43             0x03

/*.
    QT_B0 Configuration
--------------------------------------------
    Count mode: Count rising edges of primary source 
    0: Prescaler (IPB clock/ 2) , : Counter #0 input pin 
    Input polarity: True , Output polarity: True 
    Input capture mode: Capture disabled, input edge flag INTdisabled , Output mode: Asserted while counter is active 
    Count once: Count repeatedly , Count length: Count until compare, then reinitialize , Count direction: Count up 
    Output : Disable, Force OFLAG output: Disable, Master mode: Disable
    Forced OFLAG value: Disable, Enable external OFLAG force: Disable, Co-channel initialization: Disable
    Interrupts: Overflow: Disable
                Input edge: Disable
                Compare: Enable
.*/
#define QT_B0_CTRL_INIT                   0x3220
#define QT_B0_SCR_INIT                    0x4000
#define QT_B0_CMP1_INIT                   0x0fa0
#define INT_VECTOR_ADDR_38                recorder_interrupt
#define INT_PRIORITY_LEVEL_38             0x03

/*.
    QT_C0 Configuration
--------------------------------------------
    Count mode: Count rising edges of primary source 
    0: Prescaler (IPB clock/ 2) , : Counter #0 input pin 
    Input polarity: True , Output polarity: True 
    Input capture mode: Capture disabled, input edge flag INTdisabled , Output mode: Asserted while counter is active 
    Count once: Count repeatedly , Count length: Count until compare, then reinitialize , Count direction: Count up 
    Output : Disable, Force OFLAG output: Disable, Master mode: Disable
    Forced OFLAG value: Disable, Enable external OFLAG force: Disable, Co-channel initialization: Disable
    Interrupts: Overflow: Disable
                Input edge: Disable
                Compare: Enable
.*/
#define QT_C0_CTRL_INIT                   0x3220
#define QT_C0_SCR_INIT                    0x4000
#define QT_C0_CMP1_INIT                   0x07d0
#define INT_VECTOR_ADDR_34                ADC_start
#define INT_PRIORITY_LEVEL_34             0x03

/*.
    QT_D0 Configuration
--------------------------------------------
    Count mode: Count rising edges of primary source 
    0: Prescaler (IPB clock/ 64) , : Counter #0 input pin 
    Input polarity: True , Output polarity: True 
    Input capture mode: Capture disabled, input edge flag INTdisabled , Output mode: Asserted while counter is active 
    Count once: Count repeatedly , Count length: Roll over , Count direction: Count up 
    Output : Disable, Force OFLAG output: Disable, Master mode: Disable
    Forced OFLAG value: Disable, Enable external OFLAG force: Disable, Co-channel initialization: Disable
    Interrupts: Overflow: Disable
                Input edge: Disable
                Compare: Disable
.*/
#define QT_D0_CTRL_INIT                   0x3c00

/*.
    GPIO_B Configuration
--------------------------------------------
    Pin 0:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 1:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 2:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 3:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 4:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 5:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 6:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 7:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
.*/
#define GPIO_B_DDR_INIT                   0x00ff
#define GPIO_B_PER_INIT                   0x0000

/*.
    GPIO_D Configuration
--------------------------------------------
    Pin 0:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 1:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 2:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 3:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 4:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 1 
            Interrupt: Disable,  Polarity: Active high 
    Pin 5:  Mode: GPIO ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 1 
            Interrupt: Disable,  Polarity: Active high 
    Pin 6:  Mode: Peripheral ,  Direction: Output ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
    Pin 7:  Mode: Peripheral ,  Direction: Input ,  Pull-up: Enable ,  Init.value: 0 
            Interrupt: Disable,  Polarity: Active high 
.*/
#define GPIO_D_DDR_INIT                   0x007f
#define GPIO_D_PER_INIT                   0x00c0
#define GPIO_D_DR_INIT                    0x0030

/*.
    SCI_0 Configuration
--------------------------------------------
    Baudrate: 100000.0 Bd
    Enable Receiver: Enable
    Enable Transmitter: Enable
    Data word length: 8 bits , Parity: None , Polarity: True polarity 
    Loop mode: Disable, Receiver source: TX output (internally) , Function in Wait Mode: SCI enabled in Wait Mode 
    Interrupts: RX Full: Enable
                RX Error: Enable
                TX Empty: Disable
                TX Empty: Disable
.*/
#define SCI_0_SCIBR_INIT                  0x0019
#define SCI_0_SCICR_INIT                  0x003c
#define SCI_0_RX_BUFFER_OKLIMIT           0x000f
#define SCI_0_RX_BUFFER_LOWLIMIT          0x000a
#define INT_VECTOR_ADDR_51                pcmasterRxTxIsr
#define INT_PRIORITY_LEVEL_51             0x01
#define INT_VECTOR_ADDR_52                pcmasterRxErrorIsr
#define INT_PRIORITY_LEVEL_52             0x01
#define INT_VECTOR_ADDR_53                pcmasterRxTxIsr
#define INT_PRIORITY_LEVEL_53             0x02

/*.
    SCI_1 Configuration
--------------------------------------------
    Baudrate: 100000.0 Bd
    Enable Receiver: Enable
    Enable Transmitter: Enable
    Data word length: 8 bits , Parity: None , Polarity: True polarity 
    Loop mode: Disable, Receiver source: TX output (internally) , Function in Wait Mode: SCI enabled in Wait Mode 
    Interrupts: RX Full: Enable
                RX Error: Disable
                TX Empty: Enable
                TX Empty: Enable
.*/
#define SCI_1_SCIBR_INIT                  0x0019
#define SCI_1_SCICR_INIT                  0x00ac
#define SCI_1_RX_BUFFER_OKLIMIT           0x000f
#define SCI_1_RX_BUFFER_LOWLIMIT          0x000a
#define INT_VECTOR_ADDR_47                TX1_empty
#define INT_PRIORITY_LEVEL_47             0x03
#define INT_VECTOR_ADDR_49                RX1_full
#define INT_PRIORITY_LEVEL_49             0x03

/*.
    ADC_A Configuration
--------------------------------------------
    Clock frequency: 4.000 MHz
    Trigger source: Software start 
    Channel Configuration: AN0-AN1: Single ended , AN2-AN3: Single ended 
                           AN4-AN5: Single ended , AN6-AN7: Single ended 
    Channel to Sample Mapping: SMP0: AN0 , SMP1: AN1 , SMP2: AN2 , SMP3: AN3 
                               SMP0: AN0 , SMP1: AN1 , SMP2: AN2 , SMP3: AN3 
    Scan Mode: Triggered Simultaneous 
    Zero crossing mode: SMP0: disabled , SMP1: disabled , SMP2: disabled , SMP3: disabled 
                        SMP4: disabled , SMP5: disabled , SMP6: disabled , SMP7: disabled 
    Interrupts: Conversion complete: Enable
                High limit error: Enable
                Low limit error: Enable
                Zero crossing: Disable
.*/
#define ADC_A_ADCR1_INIT                  0x0b05
#define ADC_A_ADCR2_INIT                  0x0004
#define ADC_A_ADLLMT0_INIT                0x01e0
#define ADC_A_ADLLMT1_INIT                0x01e0
#define ADC_A_ADLLMT2_INIT                0x7ff8
#define ADC_A_ADLLMT3_INIT                0x01e0
#define ADC_A_ADLLMT4_INIT                0x01e0
#define ADC_A_ADLLMT5_INIT                0x01e0
#define ADC_A_ADLLMT6_INIT                0x01e0
#define ADC_A_ADLLMT7_INIT                0x01e0
#define ADC_A_ADHLMT0_INIT                0x7cb0
#define ADC_A_ADHLMT1_INIT                0x7cb0
#define ADC_A_ADHLMT3_INIT                0x7cb0
#define ADC_A_ADHLMT4_INIT                0x7cb0
#define ADC_A_ADHLMT5_INIT                0x7cb0
#define ADC_A_ADHLMT6_INIT                0x7cb0
#define ADC_A_ADHLMT7_INIT                0x7cb0
#define INT_VECTOR_ADDR_55                ADC_complete
#define INT_PRIORITY_LEVEL_55             0x02
#define INT_VECTOR_ADDR_57                ADC_limit_interrupt
#define INT_PRIORITY_LEVEL_57             0x02

/*.
    ITCN Configuration
--------------------------------------------
    All maskable interrupts disabled: No
    IRQ A : Disable, IRQ B : Disable,
.*/

/*.
    PCMASTER Configuration
--------------------------------------------
.*/
#define PCMASTER_INCLUDE_CMD_SCOPE
#define PCMASTER_INCLUDE_CMD_RECORDER
#define PCMASTER_RECORDER_TIME_BASE       0x80c8
#define PCMASTER_REC_BUFF_LEN             0x01f4


/*.  End of autogenerated code - the following code will be skipped by GCT
**************************************************************************** ..*/

/* 
Example of interrupt vector definition: 

         extern void userISRFunction(void);  prototype of the ISR must be 
                                             placed in your code

         #define INT_VECTOR_ADDR_yy          userISRFunction 
         #define INT_PRIORITY_LEVEL_yy	     value 0-7 (0 = disabled, 
                                             (1 = lowest  interrupt priority, 
                                              7 = highest interrupt priority)

  where:
         yy  is interrupt vector number


Example of initialization values definition for GPIO:

         #define  GPIO_x_PER_INIT    0x0000
         #define  GPIO_x_DDR_INIT    0x0000

  where:
         x  is GPIO port
*/


#endif
