// this file works as a C headerfile and a linkerfile at the same time
#include "version.h"
#define TARGET_INITDATA_XFLASH

#if 0
# this is a kind of workaround to enable this file to work
# as a header file and a linker file at the same time

# Linker file file for DSP56803EVM/DSP56805EVM Internal memory
# interrupt vectors --> flash pROM starting at zero
#      program code --> flash pROM
#         constants --> flash xROM
#      dynamic data --> flash xROM -> xRAM
# requirements: Mode 0A and EX=0

# stack size is set to 0x0200 for internal RAM

MEMORY {
  .p_flash_ROM          (RX)  : ORIGIN = 0x0000, LENGTH = 0x7E00 # internal flash pROM
  .p_internal_RAM       (RWX) : ORIGIN = 0x7E00, LENGTH = 0x0200 # internal pRAM
  .p_boot_flash_ROM     (RX)  : ORIGIN = 0x8004, LENGTH = 0x07FC # internal boot pRAM
  .p_reserved           (RX)  : ORIGIN = 0x8800, LENGTH = 0x0000 # reserved

  .x_compiler_regs_iRAM (RW)  : ORIGIN = 0x0030, LENGTH = 0x0010 # C temp registrs in CodeWarrior
  .x_internal_RAM       (RW)  : ORIGIN = 0x0040, LENGTH = 0x07C0 # data
  .x_reserved           (R)   : ORIGIN = 0x0800, LENGTH = 0x0400 # reserved
  .x_peripherals        (RW)  : ORIGIN = 0x0C00, LENGTH = 0x0400 # periperal registers
  .x_flash_ROM          (R)   : ORIGIN = 0x1000, LENGTH = 0x1000 # data flash memory to place constant
  .x_external_RAM       (RW)  : ORIGIN = 0x2000, LENGTH = 0xDF80 # external data ram
  .x_core_regs          (RW)  : ORIGIN = 0xFF80, LENGTH = 0x0080 # on-chip core configuration registers

}

# we ensure the interrupt vector section is not deadstripped here

FORCE_ACTIVE {FconfigBootVector}
FORCE_ACTIVE {FconfigInterruptVector}

SECTIONS {
	.main_Application :
	{
################
####### programova pamat a konstanty ktore sa tam maju ulozit########
#######################	
		OBJECT (FconfigBootVector, vectors.c)
		OBJECT (FconfigInterruptVector, vectors.c)
#		OBJECT (Fc1,main.c)
#		OBJECT (Fc2,main.c)	
#		OBJECT (Fadresa,main.c)
#	 	OBJECT (FU1_offset,main.c)
#		OBJECT (FU2_offset,main.c)
#		OBJECT (FU3_offset,main.c)
#		OBJECT (FI1_offset,main.c)
#		OBJECT (FI2_offset,main.c)
#		OBJECT (FI3_offset,main.c)
		
		*(.text)
		*(rtlib.text)
		*(fp_engine.text)
	} > .p_flash_ROM

	.main_application_constants :
	{
		* (.rodata)
		* (.const.data)
		__data_ROM_addr = .;
	} > .x_flash_ROM
	
	.main_application_data : AT (__data_ROM_addr)
	{
		__data_RAM_addr = .;
		* (.data)
		* (fp_state.data)
		* (rtlib.data)
		__data_size = . - __data_RAM_addr;
	} > .x_internal_RAM
	
	 .main_data :
	 {

	  #OBJECT (FU1_n, main.c)
	 # OBJECT (FU2_n, main.c)
	  #OBJECT (FU3_n, main.c)
	  #OBJECT (FI1_n, main.c)
	 # OBJECT (FI2_n, main.c)
	 # OBJECT (FI3_n, main.c)
	 # OBJECT (Fco1, main.c)
	 # OBJECT (Fsi1, main.c)
	 # OBJECT (Fzobrazenie, main.c)

	  
	 # OBJECT (FrecorderBuff, pcmaster.c)
	  
	 } > .x_external_RAM
	 
	.main_application_bss :
	{
		# .bss sections
	  	__bss_addr = .;
	  	* (rtlib.bss.lo)
	  	* (.bss)
		__bss_size = . - __bss_addr;

		# setup the heap address
		__heap_addr = .;
		__heap_size = 0x0010; 
		__heap_end = __heap_addr + __heap_size; 

		# setup the stack address 
		_min_stack_size = 0x00a0;
		__stack_addr = __heap_end;
		__stack_end  = __stack_addr + _min_stack_size;
		
		# MSL globals:		
		F_heap_addr  = __heap_addr;
		F_heap_end   = __heap_end;
		F_stack_addr = __stack_addr;
		
		# startup globals
		F_bss_size      = __bss_size;
		F_bss_addr      = __bss_addr;

		F_data_RAM_addr = __data_RAM_addr;
		F_data_ROM_addr = __data_ROM_addr;
		F_data_size     = __data_size;

		. = . + (_min_stack_size + __heap_size) * (__stack_end > ADDR(.x_reserved));

	} >> .x_external_RAM	

	FArchIO   = ADDR(.x_peripherals);
	FArchCore = ADDR(.x_core_regs);
	
#	Fzobrazenie=0x4000;

}
#endif
