/*****************************************************************************
*
* Motorola Inc.
* (c) Copyright 2002 Motorola, Inc.
* ALL RIGHTS RESERVED.
*
******************************************************************************
*
* File Name: copdrv.c
*
* Description: COP driver
*
* Modules Included:
*
*****************************************************************************/

#include "types.h"
#include "arch.h"
#include "periph.h"

#include "appconfig.h"
#include "cop.h"

#ifdef __cplusplus
extern "C" {
#endif

/* initialization of COP (watchdog) */

void cop_Init(arch_sCOP *pCopBase)
{
	/* we are writing to COP Timeout reg first to allow using
	   write protect bit (CWP) in COP Control Reg */ 
	
	#ifdef COP_COPTO_INIT
	  periphMemWrite(COP_COPTO_INIT,&pCopBase->copto);
	#endif

	#ifdef COP_COPCTL_INIT
	periphMemWrite(COP_COPCTL_INIT,&pCopBase->copctl);
	#endif

	/* COP Service Register is not initialized */
}

#ifdef __cplusplus
}
#endif
