/*******************************************************************************
*
*  Motorola Inc.
*  (c) Copyright 2000 Motorola Inc.
*  ALL RIGHTS RESERVED.
*
********************************************************************************
*
*
*  File Name:   occs.c
*
*  Description: Source file for On-chip Clock Synthesis (OCCS) driver.
*
*
*  Modules Included:
*
*  Notes:
*
*
*******************************************************************************/
#include "appconfig.h"
#include "types.h"
#include "periph.h"
#include "arch.h"
#include "occs.h"


#ifdef __cplusplus
extern "C" {
#endif



void occsInit(void)
{
	#ifdef OCCS_CLKOSR_INIT
		/* Set CLKO Select Register */
		periphMemWrite(OCCS_CLKOSR_INIT, &ArchIO.Pll.clkosr);
	#endif
}



UInt32 occsGetIPBusFreq(UInt32 OscFreq)
{
	UWord16 DivBy,
			Prescaler,
	        Postscaler;

	DivBy = periphMemRead(&ArchIO.Pll.plldb);
	Prescaler = DivBy>>8;
	Postscaler = Prescaler>>2;
	DivBy &= 0x007F;
	Prescaler &= 0x0003;
	Postscaler &= 0x0003;
	if (periphBitTest(0x0001, &ArchIO.Pll.pllcr))
	{ /* Prescaler Output */
		return (OscFreq>>++Prescaler);
	}
	if (periphBitTest(0x0002, &ArchIO.Pll.pllcr))
	{ /* Postscaler Output */
		return ((OscFreq * ++DivBy)>>(++Prescaler + ++Postscaler));
	}
}



#ifdef __cplusplus
}
#endif