/******************************************************************************
*
* Motorola Inc.
* (c) Copyright 2001 Motorola, Inc.
* ALL RIGHTS RESERVED.
*
*******************************************************************************
*
* FILE NAME: pwmtarget.h     
*
* DESCRIPTION: Header file for DSP56805 device specific implementation
*
* MODULES INCLUDED:
*
* NOTES:
*
*******************************************************************************/

#ifndef __PWMTARGET_H
#define __PWMTARGET_H


/***********************************************************************
*
* PWM Fault Control Register
*
***********************************************************************/

#define ioctlPWM_FAULT_INT_ENABLE(pPwmBase,param) \
          if (param == PWM_FAULT_0) {periphBitSet(PWM_FIE_0,&pPwmBase->pmfctl);} \
          else if (param == PWM_FAULT_1){periphBitSet(PWM_FIE_1,&pPwmBase->pmfctl);}  \
          else if (param == PWM_FAULT_2){periphBitSet(PWM_FIE_2,&pPwmBase->pmfctl);}  \
          else {periphBitSet(PWM_FIE_3,&pPwmBase->pmfctl);}  // FAULT3
           

#define ioctlPWM_FAULT_INT_DISABLE(pPwmBase,param) \
          if (param == PWM_FAULT_0) {periphBitClear(PWM_FIE_0,&pPwmBase->pmfctl);} \
          else if (param == PWM_FAULT_1){periphBitClear(PWM_FIE_1,&pPwmBase->pmfctl);}  \
          else if (param == PWM_FAULT_2){periphBitClear(PWM_FIE_2,&pPwmBase->pmfctl);}  \
          else {periphBitClear(PWM_FIE_3,&pPwmBase->pmfctl);}  // FAULT3
           

#define ioctlPWM_SET_AUTOMATIC_FAULT_CLEAR(pPwmBase,param) \
          if (param == PWM_FAULT_0) {periphBitSet(PWM_FMODE_0,&pPwmBase->pmfctl);} \
          else if (param == PWM_FAULT_1){periphBitSet(PWM_FMODE_1,&pPwmBase->pmfctl);}  \
          else if (param == PWM_FAULT_2){periphBitSet(PWM_FMODE_2,&pPwmBase->pmfctl);}  \
          else {periphBitSet(PWM_FMODE_3,&pPwmBase->pmfctl);}  // FAULT3
           

#define ioctlPWM_SET_MANUAL_FAULT_CLEAR(pPwmBase,param) \
          if (param == PWM_FAULT_0) {periphBitClear(PWM_FMODE_0,&pPwmBase->pmfctl);} \
          else if (param == PWM_FAULT_1){periphBitClear(PWM_FMODE_1,&pPwmBase->pmfctl);}  \
          else if (param == PWM_FAULT_2){periphBitClear(PWM_FMODE_2,&pPwmBase->pmfctl);}  \
          else {periphBitClear(PWM_FMODE_3,&pPwmBase->pmfctl);}  // FAULT3
           


/***********************************************************************
*
* PWM Fault Status Register
*
***********************************************************************/

#define ioctlPWM_CLEAR_FAULT_FLAG(pPwmBase,param) \
          if (param == PWM_FAULT_0) {periphMemWrite(PWM_FTACK_0,&pPwmBase->pmfsa);} \
          else if (param == PWM_FAULT_1){periphMemWrite(PWM_FTACK_1,&pPwmBase->pmfsa);}  \
          else if (param == PWM_FAULT_2){periphMemWrite(PWM_FTACK_2,&pPwmBase->pmfsa);}  \
          else {periphMemWrite(PWM_FTACK_3,&pPwmBase->pmfsa);}  // FAULT3
           

/**********************************************************************
*
* PWM Disable Mapping1 Register
*
***********************************************************************/

#define ioctlPWM_WRITE_DISABLE_MAPPING_REG1(pPwmBase,param) \
           periphMemWrite(((UWord16)(param)),&pPwmBase->pmdismap1)
          

/**********************************************************************
*
* PWM Disable Mapping2 Register
*
***********************************************************************/

#define ioctlPWM_WRITE_DISABLE_MAPPING_REG2(pPwmBase,param) \
           periphMemWrite(((UWord16)(param)),&pPwmBase->pmdismap2)
          


#endif 