/******************************************************************************
*
* (c) Copyright 2006 IQsoft.
* ALL RIGHTS RESERVED.
*
*******************************************************************************
*
* FILE NAME: main.c   
*
* DESCRIPTION: Three Phase Vector Wattmeter
* AUTOR: Martin Pietka
*
* TARGET: DSP56F805 device
*
*******************************************************************************/

#include "types.h"
#include "arch.h"
#include "periph.h"
#include "mc.h"
#include "appconfig.h"
#include "adc.h"
#include "cop.h"
#include "decoder.h"
#include "gpio.h"
#include "itcn.h"
//#include "mscan.h"
#include "occs.h"
#include "pwm.h"
#include "qtimer.h"
#include "sci.h"
#include "scihl.h"
#include "spi.h"
#include "sys.h"
#include "pcmaster.h"
#include "mclib.h"
#include "def.h"  //v tomto subore su zadefinovane premenne a konstanty a direktivy


//Funkcie
static void InitProject (void); 
void posli(void);
void posli_harm(void);
void adcCalibrate (void);
//short FFT(volatile Frac16 *x,volatile  Frac16 *y);
void ADC_complete(void);
void set_offset();
void set_adr_all();
Harm_vysledok find_harmonic(volatile Frac16 *x,volatile int k);
Frac16 spocitaj_vykony(Frac16 P1,Frac16 P2,Frac16 P3, adresa_vykon *adresa);
//void 	compareC1_interrupt();
asm  Frac16  Sqrt (Frac32 x);
void hladaj_max_u();
void hladaj_max_i();
//volatile short *si;




/* main function definition                                         */
void main (void) 
{ 
char x;
Frac16 prep_i1,prep_i2,prep_i3,prep_u1,prep_u2,prep_u3;

//	sum_I3_rms=L_add(sum_I3_rms,L_mult(I3_f,I3_f)>>M);
//I1=FRAC16(0.001);
//I2=mult(I1,I1);
//sum_I1_rms=L_mult(I1,I1)>>M;
//sum_I1_rms>>=M;
//pocitadlo=N-1;
//compareC1_interrupt(); 1736 cycles

    /* initialize hardware                                          */
    //find_harmonic(i,u,1); //cycles 46246
    //FFT(i,u);  // 		 cycles 151196
//    pocitadlo=127;
//	compareC1_interrupt();
     InitProject ();
	set_adr_all(); // cycles 1946
	set_offset(); //170
//	compareC1_interrupt();
//	goto spocit_vyk;
	//ADC_complete(); //cycles normal 1316 // ked N 5562 //ked sa aj posiela 6948

 while (1)
 {

#ifdef maly_kod
   if ((fft_stats==full)&&(harm_on==true))
	{
		fft_stats=run;
		
		if (k_harm!=0)
		{
			vysl_h_u1=find_harmonic(u1,k_harm);
			vysl_h_i1=find_harmonic(i1,k_harm);
			vysl_h_u2=find_harmonic(u2,k_harm);
			vysl_h_i2=find_harmonic(i2,k_harm);
			vysl_h_u3=find_harmonic(u3,k_harm);
			vysl_h_i3=find_harmonic(i3,k_harm);
			h.U1_max=vysl_h_u1.A;
			h.U2_max=vysl_h_u2.A;
			h.U3_max=vysl_h_u3.A;
			h.I1_max=vysl_h_i1.A;
			h.I2_max=vysl_h_i2.A;
			h.I3_max=vysl_h_i3.A; 
			h.cos1=add(mult(vysl_h_u1.cos,vysl_h_i1.cos),mult(vysl_h_u1.sin,vysl_h_i1.sin));
			h.cos2=add(mult(vysl_h_u2.cos,vysl_h_i2.cos),mult(vysl_h_u2.sin,vysl_h_i2.sin));
			h.cos3=add(mult(vysl_h_u3.cos,vysl_h_i3.cos),mult(vysl_h_u3.sin,vysl_h_i3.sin));
			h.U1_rms=mult(vysl_h_u1.A,FRAC16(0.707106781));
			h.U2_rms=mult(vysl_h_u2.A,FRAC16(0.707106781));
			h.U3_rms=mult(vysl_h_u3.A,FRAC16(0.707106781));
			h.I1_rms=mult(vysl_h_i1.A,FRAC16(0.707106781));
			h.I2_rms=mult(vysl_h_i2.A,FRAC16(0.707106781));
			h.I3_rms=mult(vysl_h_i3.A,FRAC16(0.707106781));	
		}
		else
		{
			h.U1_max=n.U1_avg;
			h.U2_max=n.U2_avg;
			h.U3_max=n.U3_avg;
			h.I1_max=n.I1_avg;
			h.I2_max=n.I2_avg;
			h.I3_max=n.I3_avg; 
			h.U1_rms=abs_s(n.U1_avg);
			h.U2_rms=abs_s(n.U2_avg);
			h.U3_rms=abs_s(n.U3_avg);
			h.I1_rms=n.I1_avg;
			h.I2_rms=n.I2_avg;
			h.I3_rms=n.I3_avg; 
			h.cos1=FRAC16(1);
			h.cos2=FRAC16(1);
			h.cos3=FRAC16(1);
		}

		h.S1=mult(h.I1_rms,h.U1_rms);
		h.S2=mult(h.I2_rms,h.U2_rms);
		h.S3=mult(h.I3_rms,h.U3_rms);

		h.P1=mult(h.S1,h.cos1);
		h.P2=mult(h.S2,h.cos2);
		h.P3=mult(h.S3,h.cos3);
				// priemerne hodnoty
		h.cos=mult(h.cos1,FRAC16(0.333333333));
		h.cos=add (h.cos,mult(h.cos2,FRAC16(0.333333333)));
		h.cos=add (h.cos,mult(h.cos3,FRAC16(0.333333333)));
		
		prep_i1=prepocet_priemer_i[ai.adr1][ai.adr];
		prep_i2=prepocet_priemer_i[ai.adr2][ai.adr];
		prep_i3=prepocet_priemer_i[ai.adr3][ai.adr];
		
		prep_u1=prepocet_priemer_u[au.adr1][au.adr];
		prep_u2=prepocet_priemer_u[au.adr2][au.adr];
		prep_u3=prepocet_priemer_u[au.adr3][au.adr];
			
		h.I_rms=mult(h.I1_rms,prep_i1);
		h.I_rms=add (h.I_rms,mult(h.I2_rms,prep_i2));
		h.I_rms=add (h.I_rms,mult(h.I3_rms,prep_i3));
		
		h.U_rms=mult(h.U1_rms,prep_u1);
		h.U_rms=add (h.U_rms,mult(h.U2_rms,prep_u2));
		h.U_rms=add (h.U_rms,mult(h.U3_rms,prep_u3));
		
		h.I_max=mult(h.I1_max,prep_i1);
		h.I_max=add (h.I_max,mult(h.I2_max,prep_i2));
		h.I_max=add (h.I_max,mult(h.I3_max,prep_i3));
		
		h.U_max=mult(h.U1_max,prep_u1);
		h.U_max=add (h.U_max,mult(h.U2_max,prep_u2));
		h.U_max=add (h.U_max,mult(h.U3_max,prep_u3));		
		
		h.I_min=mult(h.I1_min,prep_i1);
		h.I_min=add (h.I_min,mult(h.I2_min,prep_i2));
		h.I_min=add (h.I_min,mult(h.I3_min,prep_i3));
		
		h.U_min=mult(h.U1_min,prep_u1);
		h.U_min=add (h.U_min,mult(h.U2_min,prep_u2));
		h.U_min=add (h.U_min,mult(h.U3_min,prep_u3));
		
		fft_stats=done;
		if (mozes_prepisat==true) dh=h;
		
	 }
	
	
	
	if ((TX1_on==false)&&(PC_request==true)&&(harm_on==true)) //ak sa nic neposiela a ak bola prijata poziadavka na posielanie
	  {	
	   
	   posli_harm();  //naplni TX_buffer hodnotami a zacne vysielat na disp
	  }
			  
#endif			  
	if (fcn==1)
	{
	   	set_adr_all();
	   	set_offset();
	   	fcn=0;
	}
	
   if (fcn==2)
   {
	   	adcCalibrate();
		fcn=0;	
	}
	
   if ((fcn==3)&&(TX1_on==false))
   {
	   fcn=0;
	   TX1_on=true;
	   TX1_ptr=4;
	   TX1_buffer[3]=4;
	   TX1_buffer[2]=1;
	   TX1_buffer[1]=zobrazenie;
	   TX1_buffer[0]=1^zobrazenie;
	   ioctl(SCI_1, SCI_INT_ENABLE, SCI_TX_EMPTY);
   }
   
	if ((TX1_on==false)&&(PC_request==true)&&(harm_on==false)) //ak sa nic neposiela a ak bola prijata poziadavka na posielanie
	{	
		posli();  //naplni TX_buffer hodnotami a zacne vysielat na dis		
	}

  if ((poslif==true)&&(TX1_on==false)&&(PC_request==true))
  {
  	   TX1_on=true;
	   TX1_ptr=5;
	   TX1_buffer[4]=5;
	   TX1_buffer[3]=8;
	   TX1_buffer[2]=dfrek_U1;
	   TX1_buffer[1]=dfrek_U1>>8;
	   TX1_buffer[0]=(dfrek_U1)^(dfrek_U1>>8)^8;
	   ioctl(SCI_1, SCI_INT_ENABLE, SCI_TX_EMPTY);
	   poslif=false;
  }
 
 }
}

static void InitProject (void)
{
	                                    

	
	ioctl(GPIO_D, GPIO_INIT, NULL);
	ioctl(GPIO_B, GPIO_INIT, NULL);

	/* ITCN initialization - set GPR and IPR according to the       */
	/* definitions in appconfig.h                                   */
	ioctl(ITCN, ITCN_INIT_GPRS, NULL);
	ioctl(ITCN, ITCN_INIT_IPR, NULL);	

	/* SCI initialization                                           */
	ioctl(SCI_0, SCI_INIT, NULL);
	ioctl(SCI_1, SCI_INIT, NULL);

		

	ioctl(QTIMER_C0, QT_INIT, NULL);
	ioctl(QTIMER_A1, QT_INIT, NULL);
	ioctl(QTIMER_B0, QT_INIT, NULL);
	ioctl(QTIMER_D0, QT_INIT, NULL);
	//ADC init	
	ioctl(ADC_A, ADC_INIT, NULL); 
	/* PC Master initialization  */
	pcmasterInit(); 
	archEnableInt();	
}




//Nastavenie offsetov AD prevodnika - pre kazdy rozsah je iny offset
void set_offset()
{ 
unsigned int offset;
	/* disable ADC operation                                             	*/ 
	ioctl(ADC_A, ADC_STOP, ADC_ON);
	ioctl(ADC_A, ADC_INT_DISABLE, ADC_END_OF_SCAN);
	ioctl(ADC_A, ADC_CLEAR_STATUS_EOSI, NULL);
	ioctl(ADC_A, ADC_STOP, ADC_OFF);
	// zapisanie do registrov prevodnika	   
	ioctl(ADC_A, ADC_WRITE_OFFSET1,I1_offset[ai.adr1]);
	ioctl(ADC_A, ADC_WRITE_OFFSET2,U1_offset[au.adr1]);
	ioctl(ADC_A, ADC_WRITE_OFFSET4,I3_offset[ai.adr3]);
	ioctl(ADC_A, ADC_WRITE_OFFSET5,I2_offset[ai.adr2]);
	ioctl(ADC_A, ADC_WRITE_OFFSET6,U2_offset[au.adr2]);
	ioctl(ADC_A, ADC_WRITE_OFFSET7,U3_offset[au.adr3]);  
	/* rewrite old parameters of conversion                            	*/  
	ioctl(ADC_A, ADC_STOP, ADC_ON);
	ioctl(ADC_A, ADC_INT_ENABLE, ADC_END_OF_SCAN);
	ioctl(ADC_A, ADC_STOP, ADC_OFF);
	archSetSat32();  //zapnutie saturacie	
}

//nastavenie vsetkych adries naraz a nastavenie maximalnych vykonov
void set_adr_all()
{
UWord16 tmp,tmp2;

	tmp=ioctl( GPIO_D, GPIO_READ_DATA, NULL);	
	tmp2=((ai.adr1&0b10)>>1)|((ai.adr1&0x1)<<1);
	ioctl( GPIO_D, GPIO_WRITE_DATA,(tmp&0xFFFC)|tmp2);

	tmp=ioctl( GPIO_B, GPIO_READ_DATA, NULL);
	tmp2=((ai.adr2&0b10)>>1)|((ai.adr2&0x1)<<1);	
	ioctl( GPIO_B, GPIO_WRITE_DATA,(tmp&0xFFCF)|(tmp2<<4)) ;

	tmp=ioctl( GPIO_B, GPIO_READ_DATA, NULL);	
	ioctl( GPIO_B, GPIO_WRITE_DATA,(tmp&0xFF3F)|(ai.adr3<<6)) ;	

	tmp=ioctl( GPIO_D, GPIO_READ_DATA, NULL);	
	ioctl( GPIO_D, GPIO_WRITE_DATA,(tmp&0xFFF3)|(au.adr1<<2)) ;	

	tmp=ioctl( GPIO_B, GPIO_READ_DATA, NULL);	
	ioctl( GPIO_B, GPIO_WRITE_DATA,(tmp&0xFFFC)|au.adr2) ;
	
	tmp=ioctl( GPIO_B, GPIO_READ_DATA, NULL);	
	ioctl( GPIO_B, GPIO_WRITE_DATA,(tmp&0xFFF3)|(au.adr3<<2)) ;
	
    I1_maximum=I_maxima[ai.adr1];
	I2_maximum=I_maxima[ai.adr2];
	I3_maximum=I_maxima[ai.adr3];
	U1_maximum=U_maxima[au.adr1];
	U3_maximum=U_maxima[au.adr3];	
	U2_maximum=U_maxima[au.adr2];
	P1_maximum=P_maxima[au.adr1][ai.adr1];  
	P2_maximum=P_maxima[au.adr2][ai.adr2];
	P3_maximum=P_maxima[au.adr3][ai.adr3];


}



//spracuje prijate data z panelu
void process_RX_data()
{ char x;
 
 switch (RX1_buffer[1])
 {
 	case 0x10:
 	{
 		PC_request=true;  //panel chce aby sa mu poslali namerane data
 		break;	
 	}
 	case 1:
 	{
 		fcn=RX1_buffer[2];
 		break;
 	}
 	case 0x30:
 	{
 		zobrazenie=RX1_buffer[2]; 	
 		break;
 	}
 	case 4:
 	{	//zapisanie nastavenych rozsahov
 		ai.auto1=false;ai.auto2=false;ai.auto3=false;
		au.auto1=false;au.auto2=false;au.auto3=false;
 		if (RX1_buffer[2]==4) ai.auto1=true;
 		else ai.adr1=RX1_buffer[2];
 		if (RX1_buffer[3]==4) ai.auto2=true;
 		else ai.adr2=RX1_buffer[3];
 		if (RX1_buffer[4]==4) ai.auto3=true;
 		else ai.adr3=RX1_buffer[4];
 		if (RX1_buffer[5]==4) au.auto1=true;
 		else au.adr1=RX1_buffer[5];
 		if (RX1_buffer[6]==4) au.auto2=true;
 		else au.adr2=RX1_buffer[6];
 		if (RX1_buffer[7]==4) au.auto3=true;
 		else au.adr3=RX1_buffer[7];
 		hladaj_max_u();
	  	hladaj_max_i();
	  	dau=au;
	  	dai=ai;
 		fcn=1;
 		break;
 		
 	}
 	case 5:
 	{
 		harm_on=RX1_buffer[2];
 		k_harm=RX1_buffer[3];
 		break;
 	}
 	case 6:
 	{
 		mozes_prepisat=false;
 		break;
 	}
 	case 7:
 	{
 		mozes_prepisat=true;
 		break;
 	}
 	
 }
//zapnutie prerusenia
 ioctl( SCI_1, SCI_INT_ENABLE, SCI_RX_FULL);	
}

//prerusienie od seriovej linky - od panelu
void RX1_full()
{ 
 #pragma interrupt

 static volatile unsigned int tmp;

#ifdef read_enable
	ioctl( SCI_1, SCI_GET_STATUS_REG, NULL);	
	tmp=ioctl( SCI_1, SCI_READ_DATA, NULL);


	RX1_buffer[RX1_ptr]=tmp;
	if (++RX1_ptr == RX1_buffer[0]) 
	{
		RX1_ptr=0;    
		ioctl( SCI_1, SCI_INT_DISABLE, SCI_RX_FULL);  //interrupt RX off
		process_RX_data();   
	}
	if (tmp==0xbb) RX1_ptr=0;
	
	ioctl( SCI_1, SCI_CLEAR_STATUS_REG, NULL);	
#endif	
}


//posielanie do panelu - cez buffer   
void TX1_empty()
{
#pragma interrupt
 static volatile char priznak=0;
 static volatile UWord16 dat;


 ioctl( SCI_1, SCI_GET_STATUS_REG, NULL);
 ioctl( SCI_1, SCI_CLEAR_STATUS_REG, NULL);
 
	if (TX1_ptr==0)
	{
		ioctl(SCI_1, SCI_INT_DISABLE, SCI_TX_EMPTY);  //ak sa poslalo vsetko tak sa off TX
		TX1_on=false;
	}

	else
	{
		TX1_ptr--;
		ioctl( SCI_1, SCI_WRITE_DATA,TX1_buffer[TX1_ptr]);  //posle sa dalsi bajt z bufru	
	}


	
}


//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
void ADC_complete(void)
{
#pragma interrupt saveall
	
/*	U1=ioctl(ADC_A,ADC_READ_SAMPLE,U1_pin);
	U2=ioctl(ADC_A,ADC_READ_SAMPLE,U2_pin);
	U3=ioctl(ADC_A,ADC_READ_SAMPLE,U3_pin);
	I1=ioctl(ADC_A,ADC_READ_SAMPLE,I1_pin);
	I2=ioctl(ADC_A,ADC_READ_SAMPLE,I2_pin);
	I3=ioctl(ADC_A,ADC_READ_SAMPLE,I3_pin);
*/
	//nacitanie samplov z ADC
	U1=mult(prepocet_scale_u[0][au.adr1], ioctl(ADC_A,ADC_READ_SAMPLE,U1_pin));
	U2=mult(prepocet_scale_u[1][au.adr2], ioctl(ADC_A,ADC_READ_SAMPLE,U2_pin));
	U3=mult(prepocet_scale_u[2][au.adr3], ioctl(ADC_A,ADC_READ_SAMPLE,U3_pin));
	I1=mult(prepocet_scale_i[0][ai.adr1], ioctl(ADC_A,ADC_READ_SAMPLE,I1_pin));
	I2=mult(prepocet_scale_i[1][ai.adr2], ioctl(ADC_A,ADC_READ_SAMPLE,I2_pin));
	I3=mult(prepocet_scale_i[2][ai.adr3], ioctl(ADC_A,ADC_READ_SAMPLE,I3_pin));
	CV=ioctl(ADC_A,ADC_READ_SAMPLE,CV_pin);


   	//filtrovanie 	   	
	U1_f=add(U1,mult(filter_u1,sub(U1_f,U1)));
	I1_f=add(I1,mult(filter_i1,sub(I1_f,I1)));
	U2_f=add(U2,mult(filter_u2,sub(U2_f,U2)));
	I2_f=add(I2,mult(filter_i2,sub(I2_f,I2)));
	U3_f=add(U3,mult(filter_u3,sub(U3_f,U3)));
	I3_f=add(I3,mult(filter_i3,sub(I3_f,I3)));   	
	CV_f=add(CV,mult(filter_cv,sub(CV_f,CV)));   	
   	
 	//frek_U1_c++;
  /* clearing Adc interrupt  flag 										*/
	ioctl(ADC_A, ADC_CLEAR_STATUS_EOSI, NULL);	
}
//-------------------------------------------------------
void ADC_limit_interrupt()
{
#pragma interrupt saveall
static volatile unsigned int lowl=12288,highl=20480,prlim;	
	

if (ioctl(ADC_A, ADC_GET_STATUS_LLMTI, NULL))
{
    if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_LLS, U1_pin))
	{
	    if 	 (ioctl(ADC_A, ADC_READ_LOW_LIMIT,U1_pin)==500) over_limit=under_voltage|1;
	    ioctl(ADC_A, ADC_WRITE_LOW_LIMIT2, 500);		
		ioctl(ADC_A, ADC_WRITE_HIGH_LIMIT2, 18432);		
		
	}
		
	if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_LLS, U2_pin)) over_limit=under_voltage|2;
	if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_LLS, U3_pin)) over_limit=under_voltage|3;
	
	if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_LLS, I1_pin)) over_limit=under_current|1;
	if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_LLS, I2_pin)) over_limit=under_current|2;
	if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_LLS, I3_pin)) over_limit=under_current|3;
	
	
}
else
{
    if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_HLS, U1_pin))
	{
		if 	 (ioctl(ADC_A, ADC_READ_HIGH_LIMIT,U1_pin)==32268) over_limit=over_voltage|1;
		ioctl(ADC_A, ADC_WRITE_HIGH_LIMIT2, 32268);		
		ioctl(ADC_A, ADC_WRITE_LOW_LIMIT2, 14336);	
		if ((ioctl(QTIMER_D0, QT_READ_COUNTER_REG, NULL)<65500)&&(ioctl(QTIMER_D0, QT_READ_COUNTER_REG, NULL)>2083))
		{
		  ioctl(QTIMER_A1, QT_WRITE_COMPARE_REG1, ioctl(QTIMER_D0, QT_READ_COUNTER_REG, NULL)>>2);	
	      frek_U1=ioctl(QTIMER_D0, QT_READ_COUNTER_REG, NULL);
	      if (mozes_prepisat==true) dfrek_U1=frek_U1;
	      poslif=true;
		}
		else
		{
			ioctl(QTIMER_A1, QT_WRITE_COMPARE_REG1,3125);	
		}
		ioctl(QTIMER_D0, QT_WRITE_COUNTER_REG, 0);
		
	}
	
	if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_HLS, U2_pin)) over_limit=over_voltage|2;
	if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_HLS, U3_pin)) over_limit=over_voltage|3;
	
	if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_HLS, I1_pin)) over_limit=over_current|1;
	if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_HLS, I2_pin)) over_limit=over_current|2;
	if (ioctl(ADC_A, ADC_GET_LIMIT_STATUS_HLS, I3_pin)) over_limit=over_current|3;
		
}
	
	ioctl(ADC_A, ADC_CLEAR_STATUS_HLMTI, NULL);
	ioctl(ADC_A, ADC_CLEAR_STATUS_LLMTI, NULL);
}
//-------------------------------------------------------


//----Prerusenie v ktorom sa pocita---------------------------------------------------------------------

void vypocty_interrupt()
{
 #pragma interrupt save all
 
 
  unsigned int x,adr,adru,adri;
  Frac16 prep_i1,prep_i2,prep_i3,prep_u1,prep_u2,prep_u3,pom1,pom2;
char zmena=false,sat=false;

//goto spocit_vyk;
/*  clear interrupt register                                           	*/
	ioctl(QTIMER_A1, QT_CLEAR_FLAG, QT_COMPARE_FLAG); 
	archEnableInt();	//povolenie preruseni (aby bolo prerusenie prerusitelne)
	ioctl(QTIMER_A1, QT_INT_DISABLE, QT_COMPARE_INT);
	  if ((fft_stats==empty)&&(harm_on==true))
   {   
   //	adr=pmemread(&adresa[pocitadlo]);
   	I1_n[pocitadlo]=I1_f;
   	U1_n[pocitadlo]=U1_f;
   	I2_n[pocitadlo]=I2_f;
   	U2_n[pocitadlo]=U2_f;
   	I3_n[pocitadlo]=I3_f;
   	U3_n[pocitadlo]=U3_f;
  
   }
  //pre pocitanie Q
	I1n[pocitadlo]=I1_f;
   	U1n[pocitadlo]=U1_f;
   	I2n[pocitadlo]=I2_f;
   	U2n[pocitadlo]=U2_f;
   	I3n[pocitadlo]=I3_f;
   	U3n[pocitadlo]=U3_f;
   	
  	//minimum
	if (I1_min1>I1_f) I1_min1=I1_f;
	if (U1_min1>U1_f) U1_min1=U1_f;	
	
	if (I2_min1>I2_f) I2_min1=I2_f;
	if (U2_min1>U2_f) U2_min1=U2_f;	
	
	if (I3_min1>I3_f) I3_min1=I3_f;
	if (U3_min1>U3_f) U3_min1=U3_f;	
	
	//maximum
	if (I1_max1<I1_f) I1_max1=I1_f;
	if (U1_max1<U1_f) U1_max1=U1_f;	
	
	if (I2_max1<I2_f) I2_max1=I2_f;
	if (U2_max1<U2_f) U2_max1=U2_f;	
	
	if (I3_max1<I3_f) I3_max1=I3_f;
	if (U3_max1<U3_f) U3_max1=U3_f;	
	
	
	//integrovanie
	sum_I1_avg+=I1_f; 
	sum_I1_avg_rec+=abs_s(I1_f);
//	sum_I1_rms=L_add(sum_I1_rms,L_mult(mult(I1_f,I1_f),N_1));
	sum_I1_rms=L_add(sum_I1_rms,L_mult(I1_f,I1_f)>>M);
	
	sum_U1_avg+=U1_f; 
	sum_U1_avg_rec+=abs_s(U1_f);
	sum_U1_rms=L_add(sum_U1_rms,L_mult(U1_f,U1_f)>>M);
	
	sum_I2_avg+=I2_f; 
	sum_I2_avg_rec+=abs_s(I2_f);
	sum_I2_rms=L_add(sum_I2_rms,L_mult(I2_f,I2_f)>>M);
	
	sum_U2_avg+=U2_f; 
	sum_U2_avg_rec+=abs_s(U2_f);
	sum_U2_rms=L_add(sum_U2_rms,L_mult(U2_f,U2_f)>>M);
	
	sum_I3_avg+=I3_f; 
	sum_I3_avg_rec+=abs_s(I3_f);
	sum_I3_rms=L_add(sum_I3_rms,L_mult(I3_f,I3_f)>>M);
	
	sum_U3_avg+=U3_f; 
	sum_U3_avg_rec+=abs_s(U3_f);
	sum_U3_rms=L_add(sum_U3_rms,L_mult(U3_f,U3_f)>>M);
	
	P1_p=L_mult(U1_f,I1_f);
	P2_p=L_mult(U2_f,I2_f);
	P3_p=L_mult(U3_f,I3_f);
	
	sum_P1=L_add(sum_P1,P1_p>>M);
	sum_P2=L_add(sum_P2,P2_p>>M);
	sum_P3=L_add(sum_P3,P3_p>>M);
	
	pocitadlo++;
	
	
	if (pocitadlo==N)  //ak sa pocet nameranych vzoriek=N tak...
	{


		n.I1_max=I1_max1;
		n.U1_max=U1_max1;
		n.I1_min=I1_min1;
		n.U1_min=U1_min1;
		U1_max1=FRAC16(-1);
		I1_max1=FRAC16(-1);
		U1_min1=FRAC16(1);
		I1_min1=FRAC16(1);

		n.I2_max=I2_max1;
		n.U2_max=U2_max1;
		n.I2_min=I2_min1;
		n.U2_min=U2_min1;
		U2_max1=FRAC16(-1);
		I2_max1=FRAC16(-1);
		U2_min1=FRAC16(1);
		I2_min1=FRAC16(1);

		n.I3_max=I3_max1;
		n.U3_max=U3_max1;
		n.I3_min=I3_min1;
		n.U3_min=U3_min1;
		U3_max1=FRAC16(-1);
		I3_max1=FRAC16(-1);
		U3_min1=FRAC16(1);
		I3_min1=FRAC16(1);

		if (fft_stats==empty)
	    fft_stats=full;
		if (fft_stats==done)
		fft_stats=empty;
		pocitadlo=0;
		
		n.I1_avg=sum_I1_avg>>M;
		n.I1_avg_rec=sum_I1_avg_rec>>M;
		n.I1_rms=Sqrt(sum_I1_rms);
	
	
		sum_I1_avg=0;
		sum_I1_rms=0;
		sum_I1_avg_rec=0;		
	
		n.U1_avg=sum_U1_avg>>M;
		n.U1_avg_rec=sum_U1_avg_rec>>M;
		n.U1_rms=Sqrt(sum_U1_rms);

		sum_U1_avg=0;
		sum_U1_rms=0;
		sum_U1_avg_rec=0;
		
		n.I2_avg=sum_I2_avg>>M;
		n.I2_avg_rec=sum_I2_avg_rec>>M;
		n.I2_rms=Sqrt(sum_I2_rms);

		sum_I2_avg=0;
		sum_I2_rms=0;
		sum_I2_avg_rec=0;		
	
		n.U2_avg=sum_U2_avg>>M;
		n.U2_avg_rec=sum_U2_avg_rec>>M;
		n.U2_rms=Sqrt(sum_U2_rms);

		sum_U2_avg=0;
		sum_U2_rms=0;
		sum_U2_avg_rec=0;
		
		n.I3_avg=sum_I3_avg>>M;
		n.I3_avg_rec=sum_I3_avg_rec>>M;
		n.I3_rms=Sqrt(sum_I3_rms);

		sum_I3_avg=0;
		sum_I3_rms=0;
		sum_I3_avg_rec=0;		
	
		n.U3_avg=sum_U3_avg>>M;
		n.U3_avg_rec=sum_U3_avg_rec>>M;
		n.U3_rms=Sqrt(sum_U3_rms);

		sum_U3_avg=0;
		sum_U3_rms=0;
		sum_U3_avg_rec=0;

    	n.P1=round(sum_P1);
    	n.P2=round(sum_P2);
    	n.P3=round(sum_P3);
    	
    	sum_P1=0;
    	sum_P2=0;
    	sum_P3=0;
    	
    	n.S1=mult(n.I1_rms,n.U1_rms)	;
		n.S2=mult(n.I2_rms,n.U2_rms)	;    	
		n.S3=mult(n.I3_rms,n.U3_rms)	;

			
		n.cos1=div_s(n.P1,n.S1) ;
		n.cos2=div_s(n.P2,n.S2) ;
		n.cos3=div_s(n.P3,n.S3) ;
	
	//vypocet Q
	  sum_Q1=0;
	  sum_Q2=0;
	  sum_Q3=0;
	  for (x=0;x<96;x++)
	  {
	  	sum_Q1=L_add(sum_Q1,L_mult(U1n[x],I1n[x+32])>>M);
	  	sum_Q2=L_add(sum_Q2,L_mult(U2n[x],I2n[x+32])>>M);
	  	sum_Q3=L_add(sum_Q3,L_mult(U3n[x],I3n[x+32])>>M);
	  }
	  
	  for (x=96;x<128;x++)
	  {
	  	sum_Q1=L_add(sum_Q1,L_mult(U1n[x],I1n[x-96])>>M);
	  	sum_Q2=L_add(sum_Q2,L_mult(U2n[x],I2n[x-96])>>M);
	  	sum_Q3=L_add(sum_Q3,L_mult(U3n[x],I3n[x-96])>>M);
	  }
		
		n.Q1=round(sum_Q1);		
		n.Q2=round(sum_Q2);		
		n.Q3=round(sum_Q3);		

	
		//S^2-P^2-Q^2=D^2
		sum_Q1=L_add(L_mult(n.Q1,n.Q1),L_mult(n.P1,n.P1));
		n.D1=Sqrt(L_abs(L_sub(L_mult(n.S1,n.S1),sum_Q1)));		
		sum_Q1=L_add(L_mult(n.Q2,n.Q2),L_mult(n.P2,n.P2));
		n.D2=Sqrt(L_abs(L_sub(L_mult(n.S2,n.S2),sum_Q1)));		
		sum_Q1=L_add(L_mult(n.Q3,n.Q3),L_mult(n.P3,n.P3));
		n.D3=Sqrt(L_abs(L_sub(L_mult(n.S3,n.S3),sum_Q1)));

		n.Q=spocitaj_vykony(n.Q1,n.Q2,n.Q3,&adr_Q);		
		n.D=spocitaj_vykony(n.D1,n.D2,n.D3,&adr_D);
		n.S=spocitaj_vykony(n.S1,n.S2,n.S3,&adr_S);
		n.P=spocitaj_vykony(n.P1,n.P2,n.P3,&adr_P);
		P_maximum=P_maxima[adr_P.u][adr_P.i];
		Q_maximum=P_maxima[adr_Q.u][adr_Q.i];
		S_maximum=P_maxima[adr_S.u][adr_S.i];
		D_maximum=P_maxima[adr_D.u][adr_D.i];
		
		
		
		// priemerne hodnoty
		n.cos=mult(n.cos1,FRAC16(0.333333333));
		n.cos=add (n.cos,mult(n.cos2,FRAC16(0.333333333)));
		n.cos=add (n.cos,mult(n.cos3,FRAC16(0.333333333)));						
		
		prep_i1=prepocet_priemer_i[ai.adr1][ai.adr];
		prep_i2=prepocet_priemer_i[ai.adr2][ai.adr];
		prep_i3=prepocet_priemer_i[ai.adr3][ai.adr];
	
		prep_u1=prepocet_priemer_u[au.adr1][au.adr];
		prep_u2=prepocet_priemer_u[au.adr2][au.adr];
		prep_u3=prepocet_priemer_u[au.adr3][au.adr];
			
			
	
		n.I_rms=mult(n.I1_rms,prep_i1);
		n.I_rms=add (n.I_rms,mult(n.I2_rms,prep_i2));
		n.I_rms=add (n.I_rms,mult(n.I3_rms,prep_i3));
		
		n.U_rms=mult(n.U1_rms,prep_u1);
		n.U_rms=add (n.U_rms,mult(n.U2_rms,prep_u2));
		n.U_rms=add (n.U_rms,mult(n.U3_rms,prep_u3));
		
		n.I_max=mult(n.I1_max,prep_i1);
		n.I_max=add (n.I_max,mult(n.I2_max,prep_i2));
		n.I_max=add (n.I_max,mult(n.I3_max,prep_i3));
		
		n.U_max=mult(n.U1_max,prep_u1);
		n.U_max=add (n.U_max,mult(n.U2_max,prep_u2));
		n.U_max=add (n.U_max,mult(n.U3_max,prep_u3));		
		
		n.I_min=mult(n.I1_min,prep_i1);
		n.I_min=add (n.I_min,mult(n.I2_min,prep_i2));
		n.I_min=add (n.I_min,mult(n.I3_min,prep_i3));
		
		n.U_min=mult(n.U1_min,prep_u1);
		n.U_min=add (n.U_min,mult(n.U2_min,prep_u2));
		n.U_min=add (n.U_min,mult(n.U3_min,prep_u3));

		n.U_avg_rec=mult(n.U1_avg_rec,prep_u1);
		n.U_avg_rec=add (n.U_avg_rec,mult(n.U2_avg_rec,prep_u2));
		n.U_avg_rec=add (n.U_avg_rec,mult(n.U3_avg_rec,prep_u3));				
		
		n.I_avg_rec=mult(n.I1_avg_rec,prep_i1);
		n.I_avg_rec=add (n.I_avg_rec,mult(n.I2_avg_rec,prep_i2));
		n.I_avg_rec=add (n.I_avg_rec,mult(n.I3_avg_rec,prep_i3));				
		
		n.U_avg=mult(n.U1_avg,prep_u1);
		n.U_avg=add (n.U_avg,mult(n.U2_avg,prep_u2));
		n.U_avg=add (n.U_avg,mult(n.U3_avg,prep_u3));
		
		n.I_avg=mult(n.I1_avg,prep_i1);
		n.I_avg=add (n.I_avg,mult(n.I2_avg,prep_i2));
		n.I_avg=add (n.I_avg,mult(n.I3_avg,prep_i3));
		I_maximum=I_maxima[ai.adr];
		U_maximum=I_maxima[au.adr];
		
	
		adru=au.adr;
		adri=ai.adr;
	

	
	
	
		if (mozes_prepisat==true)	d=n;


		// automaticke prepinanie rozsahov pre prud	  
	    #ifdef auto_range_on_i
	    if (ai.auto1==true)
	    {
		  if ((n.I1_max<FRAC16(0.15)&&(n.I1_min>FRAC16(-0.15))))
			{
				ai.adr1+=(ai.adr1<3)? 1:0;
				zmena=true;
			}	
		  if ((n.I1_max>FRAC16(0.59)||(n.I1_min<FRAC16(-0.45)))) 	      
		   {
			   zmena=true;	
			   ai.adr1-= (ai.adr1>0)? 1:0;	
		   }	
	    }
	    
	   if (ai.auto2==true)
	   {
		 if ((n.I2_max<FRAC16(0.15)&&(n.I2_min>FRAC16(-0.15)))) 
		   {
			   zmena=true;	
			   ai.adr2+= (ai.adr2<3)? 1:0;
		   }	   	
		 if ((n.I2_max>FRAC16(0.59)||(n.I2_min<FRAC16(-0.45)))) 
		   {
			   zmena=true;	
			   ai.adr2-= (ai.adr2>0)? 1:0;	
		   }  
	   }
	   
	   if (ai.auto3==true)
	   {
	   	 if ((n.I3_max<FRAC16(0.15)&&(n.I3_min>FRAC16(-0.15)))) 
		   {
			   zmena=true;	
			   ai.adr3+= (ai.adr3<3)? 1:0;	  
		   }
		  if ((n.I3_max>FRAC16(0.59)||(n.I3_min<FRAC16(-0.45)))) 
		   {
			   zmena=true;	
			   ai.adr3-= (ai.adr3>0)? 1:0;	
		   }  
	   }
	   
	   #endif
	// automaticke prepinanie rozsahov pre napatie	   
	   
	   #ifdef auto_range_on_u
	   
	   if (au.auto1==true)
	   {
		    if ((n.U1_max<FRAC16(0.15)&&(n.U1_min>FRAC16(-0.15)))) 
		   {
			   	zmena=true;	   
			    au.adr1+= (au.adr1<3)? 1:0;
		   }
		  if ((n.U1_max>FRAC16(0.55)||(n.U1_min<FRAC16(-0.45)))) 
		   {
			   	zmena=true;
			   	au.adr1-= (au.adr1>0)? 1:0;
		   } 	
	   }
	  
	   if (au.auto2==true)
	   {
	   	if ((n.U2_max<FRAC16(0.15)&&(n.U2_min>FRAC16(-0.15)))) 
	       {
			   	au.adr2+= (au.adr2<3)? 1:0;
			   	zmena=true;
		   }
		 if ((n.U2_max>FRAC16(0.55)||(n.U2_min<FRAC16(-0.45)))) 
		   {
			    zmena=true;
			   	au.adr2-= (au.adr2>0)? 1:0;
		   }  
	   }
	   
	   if (au.auto3==true)
	   {
	   	if ((n.U3_max<FRAC16(0.15)&&(n.U3_min>FRAC16(-0.15)))) 
		   {
			   	au.adr3+= (au.adr3<3)? 1:0;
			   	zmena=true;
		   }	   
	    if ((n.U3_max>FRAC16(0.55)||(n.U3_min<FRAC16(-0.45)))) 
		   {
			   	zmena=true;
			   	au.adr3-= (au.adr3>0)? 1:0;
		   }	  
	   
	   }
	   #endif
	   
	   
	   if (zmena==true) //ak bol prepnuty nejaky rozsah tak...
	    {
		   	zmena=false;
		   	set_adr_all();
	  		set_offset();
	  		hladaj_max_u();
	  		hladaj_max_i();
	  		
	  		if (mozes_prepisat==true)
	  		{
	  			dau=au;
	  			dai=ai;
	  			
	  		}
	    }
 
		
	}

ioctl(QTIMER_A1, QT_INT_ENABLE, QT_COMPARE_INT);	
}

//----------------------------------------------------------------------------------
void hladaj_max_u()
{ 

	au.adr=au.adr1;	
	if (au.adr>au.adr2)
	   au.adr=au.adr2;
	if (au.adr>au.adr3)
	 au.adr=au.adr3;


}

//----------------------------------------------------------------------------------
void hladaj_max_i()
{ 

	ai.adr=ai.adr1;	
	if (ai.adr>ai.adr2)
	   ai.adr=ai.adr2;
	if (ai.adr>ai.adr3)
	 ai.adr=ai.adr3;

}
//----------------------------------------------------------------------------------
//-----	spocitavanie vykonov (nie je take lahke, treba menit rozsah ked prekroci maximum-----
Frac16 spocitaj_vykony(Frac16 P1,Frac16 P2,Frac16 P3, adresa_vykon *adresa)
{ 
 adresa_vykon adr;
 Frac16 prep_i1,prep_i2,prep_i3,prep_u1,prep_u2,prep_u3,pom1,pom2,P;
 char sat=false;
 	
	
adr.u=au.adr;
adr.i=ai.adr;

spocit_vyk:
		prep_i1=prepocet_priemer_pi[ai.adr1][adr.i];
		prep_i2=prepocet_priemer_pi[ai.adr2][adr.i];
		prep_i3=prepocet_priemer_pi[ai.adr3][adr.i];
		
		prep_u1=prepocet_priemer_pu[au.adr1][adr.u];
		prep_u2=prepocet_priemer_pu[au.adr2][adr.u];
		prep_u3=prepocet_priemer_pu[au.adr3][adr.u];
			
	    P=mult(mult(P1,prep_i1),prep_u1);
		archSetNoSat();
		pom1=add(P,mult(mult(P2,prep_i2),prep_u2));
		archSetSat32();
		pom2=add(P,mult(mult(P2,prep_i2),prep_u2));
		if (pom1==pom2) P=pom1;  
		 else 
		  if (adr.u>0) 
		  {
		    adr.u--;
		    goto spocit_vyk;	
		  }
		   else
		    if (adr.i>0) 
		    {
		     adr.i--;
		     goto spocit_vyk;	
		    }
		    else
		      sat=true;  //prekroceny maximalny vykon - je v saturacii
		archSetNoSat();
		pom1=add(P,mult(mult(P3,prep_i3),prep_u3));
		archSetSat32();
		pom2=add(P,mult(mult(P3,prep_i3),prep_u3));
		if (pom1==pom2) P=pom1;  
		 else 
		  if (adr.u>0) 
		  {
		    adr.u--;
		    goto spocit_vyk;	
		  }
		   else
		    if (adr.i>0) 
		    {
		     adr.i--;
		     goto spocit_vyk;	
		    }
		    else
		      {
		       sat=true;
		       P=MAX_16;	
		      }   
 *adresa=adr;
 		          
 return (P)		;
}			
//----




//---------prerusenie na spustanie ADC----------------------------------------------------------------
void ADC_start (void)
{	
#pragma interrupt

  
	ioctl(ADC_A,ADC_START, NULL);   //ADC start
//	pocitadlo_r++;


	//ulozenie maxim a minim a hladanie znova

/*  clear interrupt register                                           	*/
	ioctl(QTIMER_C0, QT_CLEAR_FLAG, QT_COMPARE_FLAG); 
}

//----- Free master--------------------------------------------------------------------
// 500us prerusenie
void recorder_interrupt()
{
//#pragma interrupt
#pragma interrupt saveall
//	archEnableInt();
	flag_500us=true;
	pocitadlo_500us++;
#ifdef pc_master_on
 	pcmasterRecorder();
#endif 	
/*  clear interrupt register                                           	*/
	ioctl(QTIMER_B0, QT_CLEAR_FLAG, QT_COMPARE_FLAG); 
	
}

//-------------------------------------------------------------------------
//citanie konstant z pflash mem
static int asm pmemread (const short *addr) 
{
    move p:(r2)+,y0
    rts
}

//-------------------------------------------------------------------------
static void asm pmemwrite (const int *addr,short data) 
{
    move y0,p:(r2)+
    rts
}
//-------------------------------------------------------------------------

void posli_harm(void)
{
  int x;
  #ifdef maly_kod
       	TX1_buffer[0]=0;
       	TX1_buffer[26]=27;
       	TX1_buffer[25]=3;
       	
		switch (zobrazenie)
		{
			
			case 4: //ked sa zobrazuje Imax Irms Umax Urms
			{	
				if (riadok==0)
				{
				//prve dva riadky	
	
					TX1_buffer[1]=(dau.adr2<<4)|0x04;
					TX1_buffer[2]=dh.U2_rms>>8;
					TX1_buffer[3]=dh.U2_rms;
					
					TX1_buffer[4]=TX1_buffer[1];
					TX1_buffer[5]=dh.U2_max>>8;
					TX1_buffer[6]=dh.U2_max;
					
					TX1_buffer[7]=dai.adr2|0x40;
					TX1_buffer[8]=dh.I2_rms>>8;
					TX1_buffer[9]=dh.I2_rms;
					
					TX1_buffer[10]=TX1_buffer[7];
					TX1_buffer[11]=dh.I2_max>>8;
					TX1_buffer[12]=dh.I2_max;
					
					TX1_buffer[13]=(dau.adr1<<4)|0x04;
					TX1_buffer[14]=dh.U1_rms>>8;
					TX1_buffer[15]=dh.U1_rms;
					
					TX1_buffer[16]=TX1_buffer[13];
					TX1_buffer[17]=dh.U1_max>>8;
					TX1_buffer[18]=dh.U1_max;
					
					TX1_buffer[19]=dai.adr1|0x40;
					TX1_buffer[20]=dh.I1_rms>>8;
					TX1_buffer[21]=dh.I1_rms;
					
					TX1_buffer[22]=TX1_buffer[19];
					TX1_buffer[23]=dh.I1_max>>8;
					TX1_buffer[24]=dh.I1_max;
					
					riadok=1;
				}
				else
				{
				//druhe dva riadky	
	
					TX1_buffer[1]=(dau.adr<<4)|0x04;
					TX1_buffer[2]=dh.U_rms>>8;
					TX1_buffer[3]=dh.U_rms;
					
					TX1_buffer[4]=TX1_buffer[1];
					TX1_buffer[5]=dh.U_max>>8;
					TX1_buffer[6]=dh.U_max;
					
					TX1_buffer[7]=dai.adr|0x40;
					TX1_buffer[8]=dh.I_rms>>8;
					TX1_buffer[9]=dh.I_rms;
					
					TX1_buffer[10]=TX1_buffer[7];
					TX1_buffer[11]=dh.I_max>>8;
					TX1_buffer[12]=dh.I_max;
					
					TX1_buffer[13]=(dau.adr3<<4)|0x04;
					TX1_buffer[14]=dh.U3_rms>>8;
					TX1_buffer[15]=dh.U3_rms;
					
					TX1_buffer[16]=TX1_buffer[13];
					TX1_buffer[17]=dh.U3_max>>8;
					TX1_buffer[18]=dh.U3_max;
					
					TX1_buffer[19]=dai.adr3|0x40;
					TX1_buffer[20]=dh.I3_rms>>8;
					TX1_buffer[21]=dh.I3_rms;
					
					TX1_buffer[22]=TX1_buffer[19];
					TX1_buffer[23]=dh.I3_max>>8;
					TX1_buffer[24]=dh.I3_max;
				
					TX1_buffer[25]=5;
					
					riadok=0;
				}
			 break;	
			}
			case 5://P Q S D
			{
				if (riadok==0)
				{
				//prve dva riadky	
					
					TX1_buffer[1]=0x44;
					TX1_buffer[2]=dh.cos2>>8;
					TX1_buffer[3]=dh.cos2;
					
					TX1_buffer[4]=dai.adr2|(dau.adr2<<4);
					TX1_buffer[5]=dh.Q2>>8;
					TX1_buffer[6]=dh.Q2;
					
					TX1_buffer[7]=TX1_buffer[4];
					TX1_buffer[8]=dh.S2>>8;
					TX1_buffer[9]=dh.S2;
					
					TX1_buffer[10]=TX1_buffer[4];
					TX1_buffer[11]=dh.P2>>8;
					TX1_buffer[12]=dh.P2;
					
					TX1_buffer[13]=0x44;;
					TX1_buffer[14]=dh.cos1>>8;
					TX1_buffer[15]=dh.cos1;
					
					TX1_buffer[16]=dai.adr1|(dau.adr1<<4);
					TX1_buffer[17]=dh.Q1>>8;
					TX1_buffer[18]=dh.Q1;
					
					TX1_buffer[19]=TX1_buffer[16];
					TX1_buffer[20]=dh.S1>>8;
					TX1_buffer[21]=dh.S1;
					
					TX1_buffer[22]=TX1_buffer[16];
					TX1_buffer[23]=dh.P1>>8;
					TX1_buffer[24]=dh.P1;
					
					riadok=1;
				}
				else
				{
				//druhe dva riadky	

					TX1_buffer[1]=0x44;
					TX1_buffer[2]=dh.cos>>8;
					TX1_buffer[3]=dh.cos;
					
					TX1_buffer[4]=dai.adr|(dau.adr<<4);
					TX1_buffer[5]=dh.Q>>8;
					TX1_buffer[6]=dh.Q;
					
					TX1_buffer[7]=TX1_buffer[4];
					TX1_buffer[8]=dh.S>>8;
					TX1_buffer[9]=dh.S;
					
					TX1_buffer[10]=TX1_buffer[4];
					TX1_buffer[11]=dh.P>>8;
					TX1_buffer[12]=dh.P;
					
					TX1_buffer[13]=0x44;
					TX1_buffer[14]=dh.cos3>>8;
					TX1_buffer[15]=dh.cos3;
					
					TX1_buffer[16]=dai.adr3|(dau.adr3<<4);
					TX1_buffer[17]=dh.Q3>>8;
					TX1_buffer[18]=dh.Q3;
					
					TX1_buffer[19]=TX1_buffer[16];
					TX1_buffer[20]=dh.S3>>8;
					TX1_buffer[21]=dh.S3;
					
					TX1_buffer[22]=TX1_buffer[16];
					TX1_buffer[23]=dh.P3>>8;
					TX1_buffer[24]=dh.P3;
					TX1_buffer[25]=5;
					
					riadok=0;
				} 
			 break;	
			}			
		}
		
	//pocitanie jednoducheho CRC	
	for (x=1;x<26;x++) TX1_buffer[0]^=TX1_buffer[x];
	TX1_ptr=27; //velkost posielanych dat
	ioctl(SCI_1, SCI_INT_ENABLE, SCI_TX_EMPTY);  //spustenie vysielania
	TX1_on=true;  
	PC_request=false;
#endif	
}
	

//-------------------------------------------------------------------------
//funkcia na naplnenie vysielacieho buffra
void posli(void)
{
  int x;
		switch (zobrazenie)
		{
			
			case 0: //ked sa zobrazuje I U P cos
			{	
				if (riadok==0)
				{
				//prve dva riadky	
					
					TX1_buffer[0]=0;
					
					TX1_buffer[1]=0x44;
					TX1_buffer[2]=d.cos2>>8;
					TX1_buffer[3]=d.cos2;
					
					TX1_buffer[4]=dai.adr2|(dau.adr2<<4);
					TX1_buffer[5]=d.P2>>8;
					TX1_buffer[6]=d.P2;
					
					TX1_buffer[7]=(dau.adr2<<4)|0x04;
					TX1_buffer[8]=d.U2_rms>>8;
					TX1_buffer[9]=d.U2_rms;
					
					TX1_buffer[10]=dai.adr2|0x40;
					TX1_buffer[11]=d.I2_rms>>8;
					TX1_buffer[12]=d.I2_rms;
					
					TX1_buffer[13]=0x44;
					TX1_buffer[14]=d.cos1>>8;
					TX1_buffer[15]=d.cos1;
					
					TX1_buffer[16]=dai.adr1|(dau.adr1<<4);
					TX1_buffer[17]=d.P1>>8;
					TX1_buffer[18]=d.P1;
					
					TX1_buffer[19]=(dau.adr1<<4)|0x04;
					TX1_buffer[20]=d.U1_rms>>8;
					TX1_buffer[21]=d.U1_rms;
					
					TX1_buffer[22]=dai.adr1|0x40;
					TX1_buffer[23]=d.I1_rms>>8;
					TX1_buffer[24]=d.I1_rms;
					TX1_buffer[25]=3;
					TX1_buffer[26]=27;
					riadok=1;
				}
				else
				{
				//druhe dva riadky	
					
					TX1_buffer[0]=0;
					
					TX1_buffer[1]=0x44;
					TX1_buffer[2]=d.cos>>8;
					TX1_buffer[3]=d.cos;
					
					TX1_buffer[4]=adr_P.i|(adr_P.u<<4);
					TX1_buffer[5]=d.P>>8;
					TX1_buffer[6]=d.P;
					
					TX1_buffer[7]=(dau.adr<<4)|0x04;
					TX1_buffer[8]=d.U_rms>>8;
					TX1_buffer[9]=d.U_rms;
					
					TX1_buffer[10]=dai.adr|0x40;
					TX1_buffer[11]=d.I_rms>>8;
					TX1_buffer[12]=d.I_rms;
					
					TX1_buffer[13]=0x44;
					TX1_buffer[14]=d.cos3>>8;
					TX1_buffer[15]=d.cos3;
					
					TX1_buffer[16]=dai.adr3|(dau.adr3<<4);
					TX1_buffer[17]=d.P3>>8;
					TX1_buffer[18]=d.P3;
					
					TX1_buffer[19]=(dau.adr3<<4)|0x04;
					TX1_buffer[20]=d.U3_rms>>8;
					TX1_buffer[21]=d.U3_rms;
					
					TX1_buffer[22]=dai.adr3|0x40;
					TX1_buffer[23]=d.I3_rms>>8;
					TX1_buffer[24]=d.I3_rms;
					TX1_buffer[25]=5;
					TX1_buffer[26]=27;
					riadok=0;
				}
			 break;	
			}
	

			case 1://P Q S D
			{
				if (riadok==0)
				{
				//prve dva riadky	
					
					TX1_buffer[0]=0;
					
					TX1_buffer[1]=dai.adr2|(dau.adr2<<4);
					TX1_buffer[2]=d.D2>>8;
					TX1_buffer[3]=d.D2;
					
					TX1_buffer[4]=TX1_buffer[1];
					TX1_buffer[5]=d.Q2>>8;
					TX1_buffer[6]=d.Q2;
					
					TX1_buffer[7]=TX1_buffer[1];
					TX1_buffer[8]=d.S2>>8;
					TX1_buffer[9]=d.S2;
					
					TX1_buffer[10]=TX1_buffer[1];
					TX1_buffer[11]=d.P2>>8;
					TX1_buffer[12]=d.P2;
					
					TX1_buffer[13]=dai.adr1|(dau.adr1<<4);;
					TX1_buffer[14]=d.D1>>8;
					TX1_buffer[15]=d.D1;
					
					TX1_buffer[16]=TX1_buffer[13];
					TX1_buffer[17]=d.Q1>>8;
					TX1_buffer[18]=d.Q1;
					
					TX1_buffer[19]=TX1_buffer[13];
					TX1_buffer[20]=d.S1>>8;
					TX1_buffer[21]=d.S1;
					
					TX1_buffer[22]=TX1_buffer[13];
					TX1_buffer[23]=d.P1>>8;
					TX1_buffer[24]=d.P1;
					TX1_buffer[25]=3;
					TX1_buffer[26]=27;
					riadok=1;
				}
				else
				{
				//druhe dva riadky	
					
					TX1_buffer[0]=0;
					
					TX1_buffer[1]=adr_D.i|(adr_D.u<<4);
					TX1_buffer[2]=d.D>>8;
					TX1_buffer[3]=d.D;
					
					TX1_buffer[4]=adr_Q.i|(adr_Q.u<<4);
					TX1_buffer[5]=d.Q>>8;
					TX1_buffer[6]=d.Q;
					
					TX1_buffer[7]=adr_S.i|(adr_S.u<<4);
					TX1_buffer[8]=d.S>>8;
					TX1_buffer[9]=d.S;
					
					TX1_buffer[10]=adr_P.i|(adr_P.u<<4);
					TX1_buffer[11]=d.P>>8;
					TX1_buffer[12]=d.P;
					
					TX1_buffer[13]=dai.adr3|(dau.adr3<<4);
					TX1_buffer[14]=d.D3>>8;
					TX1_buffer[15]=d.D3;
					
					TX1_buffer[16]=TX1_buffer[13];
					TX1_buffer[17]=d.Q3>>8;
					TX1_buffer[18]=d.Q3;
					
					TX1_buffer[19]=TX1_buffer[13];
					TX1_buffer[20]=d.S3>>8;
					TX1_buffer[21]=d.S3;
					
					TX1_buffer[22]=TX1_buffer[13];
					TX1_buffer[23]=d.P3>>8;
					TX1_buffer[24]=d.P3;
					TX1_buffer[25]=5;
					TX1_buffer[26]=27;
					riadok=0;
				
				}
			 break;	
			}
			case 2:  //Umax,Umin,Imax,Imin
			{
				if (riadok==0)
				{
				//prve dva riadky	
					
					TX1_buffer[0]=0;
					
					TX1_buffer[1]=(dau.adr2<<4)|0x04;
					TX1_buffer[2]=d.U2_min>>8;
					TX1_buffer[3]=d.U2_min;
					
					TX1_buffer[4]=TX1_buffer[1];
					TX1_buffer[5]=d.U2_max>>8;
					TX1_buffer[6]=d.U2_max;
					
					TX1_buffer[7]=dai.adr2|0x40;
					TX1_buffer[8]=d.I2_min>>8;
					TX1_buffer[9]=d.I2_min;
					
					TX1_buffer[10]=TX1_buffer[7];
					TX1_buffer[11]=d.I2_max>>8;
					TX1_buffer[12]=d.I2_max;
					
					TX1_buffer[13]=(dau.adr1<<4)|0x04;;
					TX1_buffer[14]=d.U1_min>>8;
					TX1_buffer[15]=d.U1_min;
					
					TX1_buffer[16]=TX1_buffer[13];
					TX1_buffer[17]=d.U1_max>>8;
					TX1_buffer[18]=d.U1_max;
					
					TX1_buffer[19]=dai.adr1|0x40;
					TX1_buffer[20]=d.I1_min>>8;
					TX1_buffer[21]=d.I1_min;
					
					TX1_buffer[22]=TX1_buffer[19];
					TX1_buffer[23]=d.I1_max>>8;
					TX1_buffer[24]=d.I1_max;
					TX1_buffer[25]=3;
					TX1_buffer[26]=27;
					riadok=1;
				}
				else
				{
				//druhe dva riadky	
					
					TX1_buffer[0]=0;
					
					TX1_buffer[1]=(dau.adr<<4)|0x04;
					TX1_buffer[2]=d.U_min>>8;
					TX1_buffer[3]=d.U_min;
					
					TX1_buffer[4]=TX1_buffer[1];
					TX1_buffer[5]=d.U_max>>8;
					TX1_buffer[6]=d.U_max;
					
					TX1_buffer[7]=dai.adr|0x40;
					TX1_buffer[8]=d.I_min>>8;
					TX1_buffer[9]=d.I_min;
					
					TX1_buffer[10]=TX1_buffer[7];
					TX1_buffer[11]=d.I_max>>8;
					TX1_buffer[12]=d.I_max;
					
					TX1_buffer[13]=(dau.adr3<<4)|0x04;;
					TX1_buffer[14]=d.U3_min>>8;
					TX1_buffer[15]=d.U3_min;
					
					TX1_buffer[16]=TX1_buffer[13];
					TX1_buffer[17]=d.U3_max>>8;
					TX1_buffer[18]=d.U3_max;
					
					TX1_buffer[19]=dai.adr3|0x40;
					TX1_buffer[20]=d.I3_min>>8;
					TX1_buffer[21]=d.I3_min;
					
					TX1_buffer[22]=TX1_buffer[19];
					TX1_buffer[23]=d.I3_max>>8;
					TX1_buffer[24]=d.I3_max;
					TX1_buffer[25]=5;
					TX1_buffer[26]=27;
					riadok=0;
				
				}
			 break;	
			}
				case 3:  //avg, avg_rec values
			{
				if (riadok==0)
				{
				//prve dva riadky	
					
					TX1_buffer[0]=0;
					
					TX1_buffer[1]=(dau.adr2<<4)|0x04;
					TX1_buffer[2]=d.U2_avg_rec>>8;
					TX1_buffer[3]=d.U2_avg_rec;
					
					TX1_buffer[4]=TX1_buffer[1];
					TX1_buffer[5]=d.U2_avg>>8;
					TX1_buffer[6]=d.U2_avg;
					
					TX1_buffer[7]=dai.adr2|0x40;
					TX1_buffer[8]=d.I2_avg_rec>>8;
					TX1_buffer[9]=d.I2_avg_rec;
					
					TX1_buffer[10]=TX1_buffer[7];
					TX1_buffer[11]=d.I2_avg>>8;
					TX1_buffer[12]=d.I2_avg;
					
					TX1_buffer[13]=(dau.adr1<<4)|0x04;;
					TX1_buffer[14]=d.U1_avg_rec>>8;
					TX1_buffer[15]=d.U1_avg_rec;
					
					TX1_buffer[16]=TX1_buffer[13];
					TX1_buffer[17]=d.U1_avg>>8;
					TX1_buffer[18]=d.U1_avg;
					
					TX1_buffer[19]=dai.adr1|0x40;
					TX1_buffer[20]=d.I1_avg_rec>>8;
					TX1_buffer[21]=d.I1_avg_rec;
					
					TX1_buffer[22]=TX1_buffer[19];
					TX1_buffer[23]=d.I1_avg>>8;
					TX1_buffer[24]=d.I1_avg;
					TX1_buffer[25]=3;
					TX1_buffer[26]=27;
					riadok=1;
				}
				else
				{
				//druhe dva riadky	
					
					TX1_buffer[0]=0;
					
					TX1_buffer[1]=(dau.adr<<4)|0x04;
					TX1_buffer[2]=d.U_avg_rec>>8;
					TX1_buffer[3]=d.U_avg_rec;
					
					TX1_buffer[4]=TX1_buffer[1];
					TX1_buffer[5]=d.U_avg>>8;
					TX1_buffer[6]=d.U_avg;
					
					TX1_buffer[7]=dai.adr|0x40;
					TX1_buffer[8]=d.I_avg_rec>>8;
					TX1_buffer[9]=d.I_avg_rec;
					
					TX1_buffer[10]=TX1_buffer[7];
					TX1_buffer[11]=d.I_avg>>8;
					TX1_buffer[12]=d.I_avg;
					
					TX1_buffer[13]=(dau.adr3<<4)|0x04;;
					TX1_buffer[14]=d.U3_avg_rec>>8;
					TX1_buffer[15]=d.U3_avg_rec;
					
					TX1_buffer[16]=TX1_buffer[13];
					TX1_buffer[17]=d.U3_avg>>8;
					TX1_buffer[18]=d.U3_avg;
					
					TX1_buffer[19]=dai.adr3|0x40;
					TX1_buffer[20]=d.I3_avg_rec>>8;
					TX1_buffer[21]=d.I3_avg_rec;
					
					TX1_buffer[22]=TX1_buffer[19];
					TX1_buffer[23]=d.I3_avg>>8;
					TX1_buffer[24]=d.I3_avg;
					TX1_buffer[25]=5;
					TX1_buffer[26]=27;
					riadok=0;
				
				}
			 break;	
			}	
		
		}
		
	//pocitanie jednoducheho CRC	
	for (x=1;x<26;x++) TX1_buffer[0]^=TX1_buffer[x];
	TX1_ptr=27; //velkost posielanych dat
	ioctl(SCI_1, SCI_INT_ENABLE, SCI_TX_EMPTY);  //spustenie vysielania
	TX1_on=true;  
	PC_request=false;
}
//-------------------------------------------------------------------------
//nastavi offsety ADC na 0
void set_offset_to_0()
{
	ioctl(ADC_A, ADC_STOP, ADC_ON);
	ioctl(ADC_A, ADC_INT_DISABLE, ADC_END_OF_SCAN);
	ioctl(ADC_A, ADC_CLEAR_STATUS_EOSI, NULL);
	ioctl(ADC_A, ADC_STOP, ADC_OFF);

	ioctl(ADC_A, ADC_WRITE_OFFSET1,0);
	ioctl(ADC_A, ADC_WRITE_OFFSET2,0);
	ioctl(ADC_A, ADC_WRITE_OFFSET4,0);
	ioctl(ADC_A, ADC_WRITE_OFFSET5,0);
	ioctl(ADC_A, ADC_WRITE_OFFSET6,0);
	ioctl(ADC_A, ADC_WRITE_OFFSET7,0);   
	/* rewrite old parameters of conversion                            	*/  
	ioctl(ADC_A, ADC_STOP, ADC_ON);
	ioctl(ADC_A, ADC_INT_ENABLE, ADC_END_OF_SCAN);
	ioctl(ADC_A, ADC_STOP, ADC_OFF);
  
}



//-------------------------------------------------------------------------

//FFT
Harm_vysledok find_harmonic(volatile Frac16 *x,volatile int k)
{
 	int n;
	volatile Frac32 sumr=0,sumi=0; 
	volatile Frac16 sumr16=0,sumi16=0,A;
	Harm_vysledok vysl;
	
  sumr=0;sumi=0;		
  for (n=0;n<N;n++)
  {
  	sumr+=mult(x[n],co1[(n*k)%N]) ;
  	sumi+=mult(x[n],si1[(n*k)%N]) ;
  	
  }
sumr>>=M;
sumi>>=M;
   
sumr16=(int)sumr;  
sumi16=(int)sumi;
//vypocet amplitudy
A=Sqrt(L_add(L_mult(sumr16,sumr16),L_mult(sumi16,sumi16)));
vysl.cos=div_s(sumr16,A);
vysl.sin=div_s(sumi16,A);
vysl.A=A<<1;
//vypocet fazy
//vysl.F=(sumi16==0) ? FRAC16(0.5) :MCLIB_Atan2(sumi16,sumr16);   
return (vysl);

}
//-------------------------------------------------------------------------

//kalibracia ADC
void adcCalibrate (void)
{
  unsigned  int i = 0,adr=0;
  unsigned  int NUM_ADC_SAMPLES = 13;
  Frac32 oi1=0,oi2=0,oi3=0,ou1=0,ou2=0,ou3=0;
  
  
#ifdef maly_kod
  
  ioctl(QTIMER_C0,QT_INT_DISABLE,QT_COMPARE_INT);
  set_offset_to_0();
  /* disable ADC operation                                             	*/ 
  ioctl(ADC_A, ADC_STOP, ADC_ON);
  ioctl(ADC_A, ADC_INT_DISABLE, ADC_END_OF_SCAN);
  ioctl(ADC_A, ADC_CLEAR_STATUS_EOSI, NULL);
	  
  
  /* re-enable ADC operation 		                  					*/
  ioctl(ADC_A, ADC_STOP, ADC_OFF);
  

  for (adr=0;adr<4;adr++)
  {
  U1=0;U1_f=0;ou1=0;
  U2=0;U2_f=0;ou2=0;
  U3=0;U3_f=0;ou3=0;
  I1=0;I1_f=0;oi1=0;
  I2=0;I2_f=0;oi2=0;
  I3=0;I3_f=0;oi3=0;
  
  ai.adr1=adr;
  ai.adr2=adr;
  ai.adr3=adr;
  au.adr1=adr;
  au.adr2=adr;
  au.adr3=adr;
  set_adr_all();	
  /* measurement loop 									               	*/
  for (i=0; i<(1<<NUM_ADC_SAMPLES); i++)
  {
	/* wait for end of scan flag    	    				            */
	ioctl(ADC_A,ADC_START, NULL);
//pocitadlo_500us=0;
    flag_500us=false;
	while (flag_500us==false);
	
   	while (!ioctl(ADC_A, ADC_GET_STATUS_EOSI, NULL));
   	ioctl(ADC_A, ADC_CLEAR_STATUS_EOSI, NULL);
   	
   		//nacitanie samplov z ADC
	U1=ioctl(ADC_A,ADC_READ_SAMPLE,U1_pin);
	U2=ioctl(ADC_A,ADC_READ_SAMPLE,U2_pin);
	U3=ioctl(ADC_A,ADC_READ_SAMPLE,U3_pin);
	I1=ioctl(ADC_A,ADC_READ_SAMPLE,I1_pin);
	I2=ioctl(ADC_A,ADC_READ_SAMPLE,I2_pin);
	I3=ioctl(ADC_A,ADC_READ_SAMPLE,I3_pin);
//	CV=ioctl(ADC_A,ADC_READ_SAMPLE,CV_pin);

   	//filtrovanie 	   	
	U1_f=add(U1,mult(FRAC16(0.9),sub(U1_f,U1)));
	I1_f=add(I1,mult(FRAC16(0.9),sub(I1_f,I1)));
	U2_f=add(U2,mult(FRAC16(0.9),sub(U2_f,U2)));
	I2_f=add(I2,mult(FRAC16(0.9),sub(I2_f,I2)));
	U3_f=add(U3,mult(FRAC16(0.9),sub(U3_f,U3)));
	I3_f=add(I3,mult(FRAC16(0.9),sub(I3_f,I3)));   	
//	CV_f=add(CV,mult(filter_cv,sub(CV_f,CV)));   	
   	
   	
   	oi1+=I1_f;   	
   	oi2+=I2_f;
   	oi3+=I3_f;
   	ou1+=U1_f;
   	ou2+=U2_f;
   	ou3+=U3_f;
   	
  }
  oi1= L_shr(oi1,NUM_ADC_SAMPLES);
  oi2= L_shr(oi2,NUM_ADC_SAMPLES);
  oi3= L_shr(oi3,NUM_ADC_SAMPLES);
  ou1= L_shr(ou1,NUM_ADC_SAMPLES);
  ou2= L_shr(ou2,NUM_ADC_SAMPLES);
  ou3= L_shr(ou3,NUM_ADC_SAMPLES);
  
  I1_offset[adr]=((int)oi1);
  I2_offset[adr]=((int)oi2);
  I3_offset[adr]=((int)oi3);
  U1_offset[adr]=((int)ou1);
  U2_offset[adr]=((int)ou2);
  U3_offset[adr]=((int)ou3);
  
/*  pmemwrite(&I1_offset[adr],(int)oi1);
  pmemwrite(&I2_offset[adr],(int)oi2);
  pmemwrite(&I3_offset[adr],(int)oi3);
  pmemwrite(&U1_offset[adr],(int)ou1);
  pmemwrite(&U2_offset[adr],(int)ou2);
  pmemwrite(&U3_offset[adr],(int)ou3);*/
  }
  
  adr=0;
  ai.adr1=adr;
  ai.adr2=adr;
  ai.adr3=adr;
  au.adr1=adr;
  au.adr2=adr;
  au.adr3=adr;
  set_adr_all();
  set_offset();
  ioctl(QTIMER_C0,QT_INT_ENABLE,QT_COMPARE_INT);
#endif  
}


//-------------------------------------------------------------------------
#undef		sub
asm  Frac16  Sqrt (Frac32 x)
{
                move    #$4000,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall14
                bfclr   #$4000,Y0
TooSmall14:
                bfset   #$2000,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall13
                bfclr   #$2000,Y0
TooSmall13:
                bfset   #$1000,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall12
                bfclr   #$1000,Y0
TooSmall12:
                bfset   #$0800,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall11
                bfclr   #$0800,Y0
TooSmall11:
                bfset   #$0400,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall10
                bfclr   #$0400,Y0
TooSmall10:
                bfset   #$0200,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall9
                bfclr   #$0200,Y0
TooSmall9:
                bfset   #$0100,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall8
                bfclr   #$0100,Y0
TooSmall8:
                bfset   #$0080,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall7
                bfclr   #$0080,Y0
TooSmall7:
                bfset   #$0040,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall6
                bfclr   #$0040,Y0
TooSmall6:
                bfset   #$0020,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall5
                bfclr   #$0020,Y0
TooSmall5:
                bfset   #$0010,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall4
                bfclr   #$0010,Y0
TooSmall4:
                bfset   #$0008,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall3
                bfclr   #$0008,Y0
TooSmall3:
                bfset   #$0004,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall2
                bfclr   #$0004,Y0
TooSmall2:
                bfset   #$0002,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall1
                bfclr   #$0002,Y0
TooSmall1:
                bfset   #$0001,Y0
                mpy     Y0,Y0,B
                cmp     A,B
                ble     TooSmall0
                bfclr   #$0001,Y0
TooSmall0:
                mpy     Y0,Y0,B
                sub     A,B
                abs     B
                lea		(SP)+
                MOVE 	B1,X:(SP)+
                move	B0,X:(SP)
                //move    B1,MR1
                //move    B0,MR0
                move    Y0,X0
                incw    Y0
                mpy     Y0,Y0,B
                sub     A,B
                abs     B
                pop		A0
                pop		A1
                //move    MR1,A1
                //move    MR0,A0
                cmp     A,B
                blt     UseEstR
                move    X0,Y0
UseEstR:
                rts
}