/************************************************************************
 *                                                                      *
 * Motorola, Inc.                                                       *
 * (c) Copyright 2002 Motorola, Inc.                                    *
 * ALL RIGHTS RESERVED                                                  *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 * File name    : basic.h                                               *
 *                                                                      *
 ************************************************************************/
#ifndef _BASIC_H_
#define _BASIC_H_

#include "rand.h"     /* include random function prototypes             */     

/* definition of saturation control macros                              */
#ifndef archSetSat32  /* set saturation mode                            */  
    #define archSetSat32()    asm {bfset #$10,omr};
#endif

#ifndef archSetNoSat  /* clear saturation mode                          */
    #define archSetNoSat()    asm {bfclr #$10,omr};
#endif

/* prototypes of the basic math functions                               */
extern Frac16 MCLIB_Sin   (register Frac16 val);
extern Frac16 MCLIB_Cos   (register Frac16 val);
extern Frac16 MCLIB_Tan   (register Frac16 val);
extern Frac16 MCLIB_Asin  (register Frac16 val);
extern Frac16 MCLIB_Acos  (register Frac16 val);
extern Frac16 MCLIB_Atan  (register Frac16 val);
extern Frac16 MCLIB_Atan2 (register Frac16 yval, register Frac16 xval);
extern asm Frac16 MCLIB_Sqrt  (register Frac32 val);

#endif /* _BASIC_H_ */
