/*******************************************************************************
*                                                                              *
* Motorola Inc.                                                                *
* (c) Copyright 2001 Motorola, Inc.                                            *
* ALL RIGHTS RESERVED.                                                         *
*                                                                              *
********************************************************************************
*                                                                              *
* File Name:         controller.h                                              *
*                                                                              *
* Description:       Types definition used in controller.c file                *
*                                                                              *
* Modules Included: none                                                       *
*                                                                              *
*******************************************************************************/
#ifndef __CONTROLLER_H
#define __CONTROLLER_H

typedef struct
{
   Frac16 ProportionalGain;
   Frac16 IntegralGain;
   Frac32 IntegralPortionK_1;
   Frac16 PositivePILimit;
   Frac16 NegativePILimit;
   Word16 ProportionalGainScale;
   Word16 IntegralGainScale;
}mc_sPIparams1_limitSc;


extern asm Frac16 MCLIB_ControllerPI (Frac16 DesiredValue, Frac16 MeasuredValue, \
                                     mc_sPIparams1_limitSc *pParams);

#endif __CONTROLLER_H       