/************************************************************************
 *                                                                      *
 * Motorola, Inc.                                                       *
 * (c) Copyright 2002 Motorola, Inc.                                    *
 * ALL RIGHTS RESERVED                                                  *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 * File name  : resolver.h                                              *
 *                                                                      *
 ************************************************************************/
#ifndef __RESOLVER_H__
#define __RESOLVER_H__ 
    
#include "types.h"
    
/* Definition of special macros                                         */
#ifndef FRAC16    
  #define FRAC16(x) ((Frac16)((x)<0.999969482421875?((x)>=-1?(x)*0x8000:0x8000):0x7FFF))
#endif        
    
/* External function prototype(s)                                       */
extern void   MCLIB_InitTrackObsv     (Frac16 k1_d, Frac16 k2_d, int k1_scale, int k2_scale);
extern void   MCLIB_CalcTrackObsv     (Frac16 sinA, Frac16 cosA);
extern Frac16 MCLIB_GetResPosition    (void);
extern int    MCLIB_GetResRevolutions (void);
extern Frac32 MCLIB_GetResSpeed       (void);
extern void   MCLIB_SetResPosition    (Frac16 newPosition);
extern void   MCLIB_SetResRevolutions (int newRevolutions);
extern Frac16 MCLIB_SinPIx            (Frac16 x);
extern Frac16 MCLIB_CosPIx            (Frac16 x);
    
#endif /* __RESOLVER_H__ */