;CodeVisionAVR C Compiler V1.24.5 Professional
;(C) Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : float, width, precision
;(s)scanf features      : long, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM


	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM


	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM


	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 Chip type           : ATmega16
;       3 Program type        : Application
;       4 Clock frequency     : 16,000000 MHz
;       5 Memory model        : Small
;       6 External SRAM size  : 0
;       7 Data Stack size     : 256
;       8 *****************************************************/
;       9 
;      10 #include <mega16.h>
;      11 
;      12 // Alphanumeric LCD Module functions
;      13 #asm
;      14    .equ __lcd_port=0x18 ;PORTB
   .equ __lcd_port=0x18 ;PORTB
;      15 #endasm
;      16 #include <lcd4x40.h>    
;      17 #include <stdio.h>
;      18 #include <math.h>
;      19 #include <define.h>

	.CSEG
;      20 //def
;      21 #define RXB8 1
;      22 #define TXB8 0
;      23 #define UPE 2
;      24 #define OVR 3
;      25 #define FE 4
;      26 #define UDRE 5
;      27 #define RXC 7 
;      28 
;      29 #define BD_9600  0xCF
;      30 #define BD_57600 0x22
;      31 
;      32 #define FRAMING_ERROR (1<<FE)
;      33 #define PARITY_ERROR (1<<UPE)
;      34 #define DATA_OVERRUN (1<<OVR)
;      35 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      36 #define RX_COMPLETE (1<<RXC)
;      37 #define RX_BUFFER_SIZE 34
;      38 #define TX_BUFFER_SIZE 8
;      39 #define true    1
;      40 #define false   0 
;      41 #define stop    0
;      42 #define run     1 
;      43 #define nuluj_tlac key_pressed=0x00;
;      44 #define _WDR #asm("wdr"); //reset watchdog
;      45 
;      46 typedef unsigned char byte;
;      47 
;      48 volatile unsigned char rx_wr_index,rx_rd_index,rx_counter;      

	.DSEG
_rx_wr_index:
	.BYTE 0x1
_rx_rd_index:
	.BYTE 0x1
_rx_counter:
	.BYTE 0x1
;      49 volatile unsigned char tx_wr_index,tx_rd_index,tx_counter;
_tx_wr_index:
	.BYTE 0x1
_tx_rd_index:
	.BYTE 0x1
_tx_counter:
	.BYTE 0x1
;      50 //volatile char key; 
;      51 volatile unsigned int key_down,key_down0,key_pressed;
_key_down:
	.BYTE 0x2
_key_down0:
	.BYTE 0x2
_key_pressed:
	.BYTE 0x2
;      52 volatile unsigned char tx_buffer[TX_BUFFER_SIZE];
_tx_buffer:
	.BYTE 0x8
;      53 volatile unsigned char rx_buffer[RX_BUFFER_SIZE];
_rx_buffer:
	.BYTE 0x22
;      54 // This flag is set on USART Receiver buffer overflow
;      55 bit rx_buffer_overflow;         
;      56 
;      57 
;      58 volatile float meas_data[16],frekv=0;
_meas_data:
	.BYTE 0x40
_frekv:
	.BYTE 0x4
;      59 volatile unsigned char rozsahy[2][3],polsek=0,sek=0,zob=1,
_rozsahy:
	.BYTE 0x6
_polsek:
	.BYTE 0x1
_sek:
	.BYTE 0x1
_zob:
	.BYTE 0x1
;      60                        sek_m,read_enable=true,status=run,
_sek_m:
	.BYTE 0x1
_read_enable:
	.BYTE 0x1
_status:
	.BYTE 0x1
;      61                        status_harm=stop,k_harm=1,poslane=true;
_status_harm:
	.BYTE 0x1
_k_harm:
	.BYTE 0x1
_poslane:
	.BYTE 0x1
;      62 #pragma warn-
;      63 eeprom volatile unsigned char e_zob,e_rozsahy[2][3];

	.ESEG
_e_zob:
	.DB  0x0
_e_rozsahy:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;      64 #pragma warn+
;      65 
;      66 
;      67 //------------------------------------------------
;      68 #pragma used+
;      69 void send(unsigned char c)
;      70 {

	.CSEG
_send:
;      71 while (!(UCSRA & DATA_REGISTER_EMPTY))  ;
_0x8:
	SBIS 0xB,5
	RJMP _0x8
;      72 UDR=c;
	LD   R30,Y
	OUT  0xC,R30
;      73 }
	ADIW R28,1
	RET
;      74 #pragma used-
;      75 //------------------------------------------------
;      76 // function used to define user characters
;      77 void define_char(byte flash *pc,byte char_code)
;      78 {
_define_char:
;      79 byte i,a;
;      80 _en1_msk=LCD_EN2;
	ST   -Y,R17
	ST   -Y,R16
;	*pc -> Y+3
;	char_code -> Y+2
;	i -> R16
;	a -> R17
	LDI  R30,LOW(8)
	STS  __en1_msk,R30
;      81 a=(char_code<<3)|0x40;
	LDD  R30,Y+2
	CALL __LSLB3
	ORI  R30,0x40
	MOV  R17,R30
;      82 for (i=0; i<8; i++) 
	LDI  R16,LOW(0)
_0xC:
	CPI  R16,8
	BRSH _0xD
;      83 {                
;      84 _en1_msk=LCD_EN1;
	LDI  R30,LOW(4)
	STS  __en1_msk,R30
;      85 lcd_write_byte(a,*pc);
	ST   -Y,R17
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CALL SUBOPT_0x0
;      86 _en1_msk=LCD_EN2;
	LDI  R30,LOW(8)
	STS  __en1_msk,R30
;      87 lcd_write_byte(a++,*pc++);
	ST   -Y,R17
	INC  R17
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	SBIW R30,1
	CALL SUBOPT_0x0
;      88 }
	SUBI R16,-1
	RJMP _0xC
_0xD:
;      89 }               
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
;      90 //------------------------------------------------
;      91 
;      92 //------------------------------------------------
;      93 void co_sa_vypisuje()
;      94 { char x,s[41];
_co_sa_vypisuje:
;      95 //lcd_clear();
;      96 for (x=0;x<4;x++){
	SBIW R28,41
	ST   -Y,R16
;	x -> R16
;	s -> Y+1
	LDI  R16,LOW(0)
_0xF:
	CPI  R16,4
	BRSH _0x10
;      97 lcd_gotoxy(0,x);                               
	CALL SUBOPT_0x1
;      98 lcd_putsf(text[zob][x]);
	LDI  R26,LOW(_text*2)
	LDI  R27,HIGH(_text*2)
	LDS  R30,_zob
	LDI  R31,0
	PUSH R27
	PUSH R26
	LDI  R26,LOW(164)
	LDI  R27,HIGH(164)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0x2
	PUSH R27
	PUSH R26
	LDI  R26,LOW(41)
	LDI  R27,HIGH(41)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0x3
;      99 } 
	SUBI R16,-1
	RJMP _0xF
_0x10:
;     100 _WDR;
	wdr
;     101 }   
	RJMP _0x193
;     102 
;     103 
;     104 void posli_zob()
;     105 {unsigned char pom;
_posli_zob:
;     106  
;     107  pom=read_enable;
	ST   -Y,R16
;	pom -> R16
	LDS  R16,_read_enable
;     108  read_enable=false;
	CALL SUBOPT_0x4
;     109  send(4);
;     110  send(0x30);
	CALL SUBOPT_0x5
;     111  send(zob); 
;     112  send(0xbb);
;     113  read_enable=pom;
	STS  _read_enable,R16
;     114 }
	LD   R16,Y+
	RET
;     115 
;     116 
;     117 
;     118 //------------------------------------------------ 
;     119 void vypis_rozsahy()
;     120 { 
_vypis_rozsahy:
;     121  char x,s[41];
;     122 lcd_clear();
	SBIW R28,41
	ST   -Y,R16
;	x -> R16
;	s -> Y+1
	CALL _lcd_clear
;     123 lcd_putsf("L1     L2     L3");
	__POINTW1FN _0,0
	CALL SUBOPT_0x6
;     124 lcd_gotoxy(20,1);
	CALL SUBOPT_0x7
;     125 lcd_putsf("Voltage");
	__POINTW1FN _0,17
	CALL SUBOPT_0x6
;     126 lcd_gotoxy(20,2);
	CALL SUBOPT_0x8
;     127 lcd_putsf("Current");
	__POINTW1FN _0,25
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     128 for (x=0;x<2;x++)
	LDI  R16,LOW(0)
_0x12:
	CPI  R16,2
	BRLO PC+3
	JMP _0x13
;     129  {
;     130  
;     131   sprintf(s,"%p  %p  %p",
;     132   rozsahy_text[x][rozsahy[x][0]],
;     133   rozsahy_text[x][rozsahy[x][1]],
;     134   rozsahy_text[x][rozsahy[x][2]]);
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,33
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x9
	PUSH R27
	PUSH R26
	LDI  R26,LOW(30)
	LDI  R27,HIGH(30)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xA
	PUSH R27
	PUSH R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	POP  R26
	POP  R27
	LDI  R31,0
	PUSH R27
	PUSH R26
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0xB
	PUSH R27
	PUSH R26
	LDI  R26,LOW(30)
	LDI  R27,HIGH(30)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xA
	PUSH R27
	PUSH R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	POP  R26
	POP  R27
	LDI  R31,0
	PUSH R27
	PUSH R26
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0xB
	PUSH R27
	PUSH R26
	LDI  R26,LOW(30)
	LDI  R27,HIGH(30)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xA
	PUSH R27
	PUSH R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+2
	POP  R26
	POP  R27
	LDI  R31,0
	PUSH R27
	PUSH R26
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
;     135   lcd_gotoxy(0,x+1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
;     136   lcd_puts(s);     
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
;     137  } 
	SUBI R16,-1
	RJMP _0x12
_0x13:
;     138 }  
_0x193:
	LDD  R16,Y+0
	ADIW R28,42
	RET
;     139 //------------------------------------------------
;     140 //-Prerusenie od casovaca 0-KLAVESNICA------------
;     141 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     142 { unsigned int key_inl; 
_timer0_ovf_isr:
	CALL SUBOPT_0xC
;     143 
;     144 // row1=0;   
;     145 // #asm("nop");         
;     146 // key_inl=key_in;
;     147 // #asm("nop");
;     148 // key_down=(key_down&0xffffff00)|key_inl;
;     149 // row2=0;
;     150 // row1=1;     
;     151 // #asm("nop"); 
;     152 // key_inl=key_in;
;     153 // #asm("nop");
;     154 // key_down=(key_down&0xffff00ff)|(key_inl<<8);
;     155 // row3=0;    
;     156 // row2=1;
;     157 // #asm("nop");                                        
;     158 // key_inl=key_in;
;     159 // key_down=(key_down&0xff00ffff)|(key_inl<<16);
;     160 // row4=0;
;     161 // row3=1;
;     162 // #asm("nop");                                         
;     163 // key_inl=key_in;
;     164 // #asm("nop");
;     165 // key_down=(key_down&0x00ffffff)|(key_inl<<24);
;     166 // row4=1;     
;     167 
;     168  row1=0;   
;	key_inl -> R16,R17
	CBI  0x15,7
;     169  #asm("nop"); 
	nop
;     170  key_inl=key_in;
	CALL SUBOPT_0xD
;     171  key_down=(key_down&0xff00)|key_inl;
	ANDI R30,LOW(0xFF00)
	OR   R30,R16
	OR   R31,R17
	STS  _key_down,R30
	STS  _key_down+1,R31
;     172  row1=1;
	SBI  0x15,7
;     173  #asm("nop");  
	nop
;     174  row2=0;     
	CBI  0x15,6
;     175  #asm("nop"); 
	nop
;     176   key_inl=key_in;
	CALL SUBOPT_0xD
;     177  key_down=(key_down&0x00ff)|(key_inl<<8);
	ANDI R31,HIGH(0xFF)
	MOVW R26,R30
	__GETW1R 16,17
	MOV  R31,R30
	LDI  R30,0
	OR   R30,R26
	OR   R31,R27
	STS  _key_down,R30
	STS  _key_down+1,R31
;     178  row2=1;
	SBI  0x15,6
;     179                                   
;     180 key_down=~key_down;
	COM  R30
	COM  R31
	STS  _key_down,R30
	STS  _key_down+1,R31
;     181 if (key_down!=key_down0)  //doslo k zmene key_down
	LDS  R30,_key_down0
	LDS  R31,_key_down0+1
	LDS  R26,_key_down
	LDS  R27,_key_down+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x14
;     182  key_pressed=key_down & (key_down0 ^ key_down);   
	LDS  R30,_key_down
	LDS  R31,_key_down+1
	LDS  R26,_key_down0
	LDS  R27,_key_down0+1
	EOR  R30,R26
	EOR  R31,R27
	LDS  R26,_key_down
	LDS  R27,_key_down+1
	AND  R30,R26
	AND  R31,R27
	STS  _key_pressed,R30
	STS  _key_pressed+1,R31
;     183 else
	RJMP _0x15
_0x14:
;     184  if (key_down==0x0) 
	LDS  R30,_key_down
	LDS  R31,_key_down+1
	SBIW R30,0
	BRNE _0x16
;     185   polsek++ ; //ak je drzane stale to iste tlacidlo
	LDS  R30,_polsek
	SUBI R30,-LOW(1)
	STS  _polsek,R30
;     186 key_down0=key_down;  
_0x16:
_0x15:
	LDS  R30,_key_down
	LDS  R31,_key_down+1
	STS  _key_down0,R30
	STS  _key_down0+1,R31
;     187 sek++;  
	LDS  R30,_sek
	SUBI R30,-LOW(1)
	STS  _sek,R30
;     188 sek_m++;
	LDS  R30,_sek_m
	SUBI R30,-LOW(1)
	STS  _sek_m,R30
;     189 if (sek==15)
	LDS  R26,_sek
	CPI  R26,LOW(0xF)
	BRNE _0x17
;     190  {
;     191  // if ((read_enable==true)&&(poslane==true)) 
;     192   if (read_enable==true)
	LDS  R26,_read_enable
	CPI  R26,LOW(0x1)
	BRNE _0x18
;     193    {  
;     194     poslane=false;
	LDI  R30,LOW(0)
	STS  _poslane,R30
;     195     send(3);       
	CALL SUBOPT_0xE
;     196     send(0x10);  //0x10
	LDI  R30,LOW(16)
	CALL SUBOPT_0xF
;     197     send(0xbb); 
;     198    }
;     199   sek=0;
_0x18:
	LDI  R30,LOW(0)
	STS  _sek,R30
;     200  }   
;     201  
;     202 }               
_0x17:
	RJMP _0x19E
;     203 //------------------------------------------------
;     204 void vypis_namerane()
;     205 { char x=0,y=0,s[41];
_vypis_namerane:
;     206   volatile char temp_text[4][7];
;     207       
;     208  for  (x=0;x<4;x++){
	SBIW R28,63
	SBIW R28,6
	ST   -Y,R17
	ST   -Y,R16
;	x -> R16
;	y -> R17
;	s -> Y+30
;	temp_text -> Y+2
	LDI  R16,0
	LDI  R17,0
	LDI  R16,LOW(0)
_0x1A:
	CPI  R16,4
	BRLO PC+3
	JMP _0x1B
;     209 y=x*4;
	MOV  R30,R16
	LSL  R30
	LSL  R30
	MOV  R17,R30
;     210 sprintf(temp_text[0],"%f",meas_data[y++]);
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,44
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	SUBI R17,-1
	CALL SUBOPT_0x10
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;     211 sprintf(temp_text[1],"%f",meas_data[y++]);
	MOVW R30,R28
	ADIW R30,9
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,44
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	SUBI R17,-1
	CALL SUBOPT_0x10
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;     212 sprintf(temp_text[2],"%f",meas_data[y++]);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,44
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	SUBI R17,-1
	CALL SUBOPT_0x10
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;     213 sprintf(temp_text[3],"%f",meas_data[y]); 
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,44
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CALL SUBOPT_0x10
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;     214 for (y=0;y<4;y++){
	LDI  R17,LOW(0)
_0x1D:
	CPI  R17,4
	BRSH _0x1E
;     215 temp_text[y][6]=0;
	CALL SUBOPT_0x11
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,6
	LDI  R30,LOW(0)
	ST   X,R30
;     216 if (temp_text[y][5]==0x2e) temp_text[y][5]=' '; //ak je na konci bodka tak nezobraz ju
	CALL SUBOPT_0x11
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+5
	CPI  R30,LOW(0x2E)
	BRNE _0x1F
	CALL SUBOPT_0x11
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,5
	LDI  R30,LOW(32)
	ST   X,R30
;     217 }                    
_0x1F:
	SUBI R17,-1
	RJMP _0x1D
_0x1E:
;     218 //y=x*4;
;     219 sprintf(s,"%c=%s %c=%s %c=%s %c=%s ",
;     220 velic_text[zob][0][x],temp_text[0],
;     221 velic_text[zob][1][x],temp_text[1],
;     222 velic_text[zob][2][x],temp_text[2],
;     223 velic_text[zob][3][x],temp_text[3]
;     224 );         
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,47
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x12
	CALL __LSLW4
	CALL SUBOPT_0x2
	CALL SUBOPT_0x13
	MOVW R30,R28
	ADIW R30,10
	CALL SUBOPT_0x14
	PUSH R27
	PUSH R26
	CALL __LSLW4
	POP  R26
	POP  R27
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,4
	CALL SUBOPT_0x15
	MOVW R30,R28
	ADIW R30,25
	CALL SUBOPT_0x14
	PUSH R27
	PUSH R26
	CALL __LSLW4
	POP  R26
	POP  R27
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,8
	CALL SUBOPT_0x15
	MOVW R30,R28
	ADIW R30,40
	CALL SUBOPT_0x14
	PUSH R27
	PUSH R26
	CALL __LSLW4
	POP  R26
	POP  R27
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,12
	CALL SUBOPT_0x15
	MOVW R30,R28
	ADIW R30,55
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,32
	CALL _sprintf
	ADIW R28,36
;     225 lcd_gotoxy(0,x);                               
	CALL SUBOPT_0x1
;     226 lcd_puts(s); 
	MOVW R30,R28
	ADIW R30,30
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
;     227 }  
	SUBI R16,-1
	RJMP _0x1A
_0x1B:
;     228 lcd_gotoxy(36,0);
	LDI  R30,LOW(36)
	CALL SUBOPT_0x16
;     229 lcd_putsf(status_text[status]);
	LDI  R26,LOW(_status_text*2)
	LDI  R27,HIGH(_status_text*2)
	LDS  R30,_status
	LDI  R31,0
	PUSH R27
	PUSH R26
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0x3
;     230 lcd_gotoxy(36,1);
	LDI  R30,LOW(36)
	ST   -Y,R30
	CALL SUBOPT_0x7
;     231 lcd_putsf(status_harm_text[status_harm]);
	LDI  R26,LOW(_status_harm_text*2)
	LDI  R27,HIGH(_status_harm_text*2)
	LDS  R30,_status_harm
	LDI  R31,0
	PUSH R27
	PUSH R26
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0x3
;     232 lcd_gotoxy(36,2);
	LDI  R30,LOW(36)
	ST   -Y,R30
	CALL SUBOPT_0x8
;     233 if (status_harm==run)
	LDS  R26,_status_harm
	CPI  R26,LOW(0x1)
	BRNE _0x20
;     234   {     
;     235 
;     236    sprintf(temp_text[3],"k=%d ",k_harm); 
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,72
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_k_harm
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;     237    if (k_harm>9) temp_text[3][4]=0;
	LDS  R26,_k_harm
	LDI  R30,LOW(9)
	CP   R30,R26
	BRSH _0x21
	LDI  R30,LOW(0)
	STD  Y+27,R30
;     238    lcd_puts(temp_text[3]);
_0x21:
	CALL SUBOPT_0x17
;     239   }
;     240 else
	RJMP _0x22
_0x20:
;     241   {
;     242    lcd_putsf("    ");
	__POINTW1FN _0,78
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     243   }    
_0x22:
;     244 lcd_gotoxy(36,3);
	LDI  R30,LOW(36)
	CALL SUBOPT_0x18
;     245   if (frekv<1000) 
	LDS  R26,_frekv
	LDS  R27,_frekv+1
	LDS  R24,_frekv+2
	LDS  R25,_frekv+3
	__GETD1N 0x447A0000
	CALL __CMPF12
	BRSH _0x23
;     246   {
;     247    sprintf(temp_text[3],"%f",frekv);          
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,44
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_frekv
	LDS  R31,_frekv+1
	LDS  R22,_frekv+2
	LDS  R23,_frekv+3
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;     248    if (temp_text[3][3]=='.') temp_text[3][3]=' ';
	CALL SUBOPT_0x19
	BRNE _0x24
	LDI  R30,LOW(32)
	STD  Y+26,R30
;     249    }
_0x24:
;     250   else 
	RJMP _0x25
_0x23:
;     251   {
;     252    sprintf(temp_text[3],"%f",frekv/1000);    
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,44
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_frekv
	LDS  R27,_frekv+1
	LDS  R24,_frekv+2
	LDS  R25,_frekv+3
	__GETD1N 0x447A0000
	CALL __DIVF21
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;     253    if (temp_text[3][2]=='.') temp_text[3][2]=' ';\   
;     254     temp_text[3][3]='k';        
	MOVW R30,R28
	ADIW R30,25
	LD   R30,Z
	CPI  R30,LOW(0x2E)
	BRNE _0x26
	LDI  R30,LOW(32)
	STD  Y+25,R30
_0x26:
	LDI  R30,LOW(107)
	STD  Y+26,R30
;     255   } 
_0x25:
;     256   
;     257  temp_text[3][4]=0;
	LDI  R30,LOW(0)
	STD  Y+27,R30
;     258 if (temp_text[3][3]=='.') temp_text[3][3]=' ';
	CALL SUBOPT_0x19
	BRNE _0x27
	LDI  R30,LOW(32)
	STD  Y+26,R30
;     259 lcd_puts(temp_text[3]);
_0x27:
	CALL SUBOPT_0x17
;     260 }
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,63
	ADIW R28,8
	RET
;     261 //------------------------------------------------
;     262 void process_RX_data()
;     263 { unsigned char x=2,y=0,*ptr;
_process_RX_data:
;     264   int c,c2; 
;     265   float f;
;     266 read_enable=false; 
	SBIW R28,6
	CALL __SAVELOCR6
;	x -> R16
;	y -> R17
;	*ptr -> R18,R19
;	c -> R20,R21
;	c2 -> Y+10
;	f -> Y+6
	LDI  R16,2
	LDI  R17,0
	LDI  R30,LOW(0)
	STS  _read_enable,R30
;     267 poslane=true;
	LDI  R30,LOW(1)
	STS  _poslane,R30
;     268 for (x=1;x<rx_buffer[0]-1;x++)
	LDI  R16,LOW(1)
_0x29:
	LDS  R30,_rx_buffer
	SUBI R30,LOW(1)
	CP   R16,R30
	BRSH _0x2A
;     269 { 
;     270 y^=rx_buffer[x];
	CALL SUBOPT_0x1A
	EOR  R17,R30
;     271 }
	SUBI R16,-1
	RJMP _0x29
_0x2A:
;     272 
;     273 if (y==rx_buffer[rx_buffer[0]-1])
	LDS  R30,_rx_buffer
	SUBI R30,LOW(1)
	CALL SUBOPT_0x1B
	CP   R30,R17
	BREQ PC+3
	JMP _0x2B
;     274 { 
;     275 if (rx_buffer[1]==1)  //nestavit zobrazovene veliciny
	__GETB1MN _rx_buffer,1
	CPI  R30,LOW(0x1)
	BRNE _0x2C
;     276 {  
;     277  zob=rx_buffer[2];  
	__GETB1MN _rx_buffer,2
	STS  _zob,R30
;     278  //send(OK);
;     279 }
;     280 if (rx_buffer[1]==2)  //nestavit rozsahy
_0x2C:
	__GETB1MN _rx_buffer,1
	CPI  R30,LOW(0x2)
	BRNE _0x2D
;     281 {
;     282  ptr=rozsahy; 
	__POINTWRM 18,19,_rozsahy
;     283   for (x=2;x<8;x++)
	LDI  R16,LOW(2)
_0x2F:
	CPI  R16,8
	BRSH _0x30
;     284     {
;     285      *ptr++=rx_buffer[x];
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	CALL SUBOPT_0x1A
	POP  R26
	POP  R27
	ST   X,R30
;     286     } 
	SUBI R16,-1
	RJMP _0x2F
_0x30:
;     287 // send(OK);    
;     288 }
;     289 if (rx_buffer[1]==3) //namerane hodnoty pre prve dva riadky
_0x2D:
	__GETB1MN _rx_buffer,1
	CPI  R30,LOW(0x3)
	BRNE _0x31
;     290 {                            
;     291   y=2;
	LDI  R17,LOW(2)
;     292   for (x=0;x<8;x++)
	LDI  R16,LOW(0)
_0x33:
	CPI  R16,8
	BRSH _0x34
;     293   {
;     294    //spodne| vrchne |exponent
;     295    c=rx_buffer[y++];
	MOV  R30,R17
	SUBI R17,-1
	CALL SUBOPT_0x1C
;     296    c2=rx_buffer[y++]; 
	SUBI R17,-1
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1D
;     297    c=c|(c2<<8); 
	__ORWRR 20,21,30,31
;     298    c2=rx_buffer[y++];                
	MOV  R30,R17
	SUBI R17,-1
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1E
;     299    f=(c*exponenty[0][(c2&0b0000111)]*exponenty[1][(c2&0b01110000)>>4])/32767.0;
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__POINTW1FN _exponenty,20
	CALL SUBOPT_0x1F
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x20
;     300    meas_data[x]=f;   
;     301   }   
	SUBI R16,-1
	RJMP _0x33
_0x34:
;     302   //send(OK);
;     303 }  
;     304 if (rx_buffer[1]==5) //namerane hodnoty pre prve dva riadky
_0x31:
	__GETB1MN _rx_buffer,1
	CPI  R30,LOW(0x5)
	BRNE _0x35
;     305 {                            
;     306   y=2;
	LDI  R17,LOW(2)
;     307   for (x=8;x<16;x++)
	LDI  R16,LOW(8)
_0x37:
	CPI  R16,16
	BRSH _0x38
;     308   {
;     309    //spodne| vrchne |exponent
;     310    c=rx_buffer[y++];
	MOV  R30,R17
	SUBI R17,-1
	CALL SUBOPT_0x1C
;     311    c2=rx_buffer[y++];
	SUBI R17,-1
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1D
;     312    c=c|(c2<<8);                 
	__ORWRR 20,21,30,31
;     313    c2=rx_buffer[y++];                
	MOV  R30,R17
	SUBI R17,-1
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1E
;     314    f=(c*exponenty[0][(c2&0b0000111)]*exponenty[1][(c2&0b01110000)>>4])/32767.0;
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__POINTW1FN _exponenty,20
	CALL SUBOPT_0x1F
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x20
;     315    meas_data[x]=f;   
;     316   } 
	SUBI R16,-1
	RJMP _0x37
_0x38:
;     317 
;     318  } 
;     319 if (rx_buffer[1]==4)
_0x35:
	__GETB1MN _rx_buffer,1
	CPI  R30,LOW(0x4)
	BRNE _0x39
;     320 {
;     321  kontrast=rx_buffer[2];
	__GETB1MN _rx_buffer,2
	OUT  0x2A,R30
;     322  light=rx_buffer[3];
	__GETB1MN _rx_buffer,3
	OUT  0x28,R30
;     323 
;     324 }       
;     325 if (rx_buffer[1]==8) //prijatie frekvencie
_0x39:
	__GETB1MN _rx_buffer,1
	CPI  R30,LOW(0x8)
	BRNE _0x3A
;     326 {
;     327  c=rx_buffer[2];
	__POINTW1MN _rx_buffer,2
	LD   R20,Z
	CLR  R21
;     328  c2=rx_buffer[3];
	__GETB1MN _rx_buffer,3
	CALL SUBOPT_0x1D
;     329  c=c|(c2<<8);
	__ORWRR 20,21,30,31
;     330  frekv= (status_harm==stop)? 625000.0/(1.0*c):625000.0*k_harm/(1.0*c);
	LDS  R26,_status_harm
	CPI  R26,LOW(0x0)
	BRNE _0x3B
	CALL SUBOPT_0x21
	__GETD2N 0x49189680
	RJMP _0x194
_0x3B:
	LDS  R30,_k_harm
	__GETD2N 0x49189680
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
_0x194:
	CALL __DIVF21
	STS  _frekv,R30
	STS  _frekv+1,R31
	STS  _frekv+2,R22
	STS  _frekv+3,R23
;     331 }       
;     332 
;     333 }
_0x3A:
;     334 
;     335 
;     336  UCSRB|=0x80;  //interrupt RX on
_0x2B:
	SBI  0xA,7
;     337  read_enable=true;
	LDI  R30,LOW(1)
	STS  _read_enable,R30
;     338 }
	CALL __LOADLOCR6
	ADIW R28,12
	RET
;     339 
;     340 //------------------------------------------------
;     341 // USART Receiver interrupt service routine
;     342 interrupt [USART_RXC] void usart_rx_isr(void)
;     343 {
_usart_rx_isr:
	CALL SUBOPT_0xC
;     344 char status,data;
;     345 
;     346 status=UCSRA;
;	status -> R16
;	data -> R17
	IN   R16,11
;     347 data=UDR;
	IN   R17,12
;     348 if ((status & (FRAMING_ERROR | PARITY_ERROR ))==0)
	MOV  R30,R16
	ANDI R30,LOW(0x14)
	BRNE _0x3E
;     349    {
;     350    rx_buffer[rx_wr_index]=data;
	LDS  R26,_rx_wr_index
	LDI  R27,0
	SUBI R26,LOW(-_rx_buffer)
	SBCI R27,HIGH(-_rx_buffer)
	ST   X,R17
;     351    if (++rx_wr_index == rx_buffer[0]) 
	LDS  R26,_rx_wr_index
	SUBI R26,-LOW(1)
	STS  _rx_wr_index,R26
	LDS  R30,_rx_buffer
	CP   R30,R26
	BRNE _0x3F
;     352    {
;     353     rx_wr_index=0;    
	LDI  R30,LOW(0)
	STS  _rx_wr_index,R30
;     354     UCSRB&=0b01111111;  //interrupt RX off
	CBI  0xA,7
;     355     process_RX_data();   
	CALL _process_RX_data
;     356     }
;     357    };   
_0x3F:
_0x3E:
;     358 }
_0x19E:
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     359 //------------------------------------------------ 
;     360 void lcd_cursor_on(unsigned char x)
;     361 {     
_lcd_cursor_on:
;     362     _en1_msk=LCD_EN2;
	CALL SUBOPT_0x22
;     363     _lcd_ready();
;     364     _lcd_write_data(0xc);  
	CALL SUBOPT_0x23
;     365     _en1_msk=LCD_EN1;
	CALL SUBOPT_0x24
;     366     _lcd_ready();
;     367     _lcd_write_data(0xc); 
	CALL SUBOPT_0x23
;     368     
;     369   if (x==1){
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x40
;     370     _en1_msk=LCD_EN1;
	CALL SUBOPT_0x24
;     371     _lcd_ready();
;     372     _lcd_write_data(0xf);
	CALL SUBOPT_0x25
;     373    
;     374     }
;     375     if (x==2){
_0x40:
	LD   R26,Y
	CPI  R26,LOW(0x2)
	BRNE _0x41
;     376     _en1_msk=LCD_EN2;
	CALL SUBOPT_0x22
;     377     _lcd_ready();
;     378     _lcd_write_data(0xf);
	CALL SUBOPT_0x25
;     379    
;     380     }
;     381 }
_0x41:
	ADIW R28,1
	RET
;     382 
;     383 
;     384 //------------------------------------------------ 
;     385 void lcd_gotoxy_cursor(unsigned char x,unsigned char y)
;     386 {
_lcd_gotoxy_cursor:
;     387  if (y<2)
	LD   R26,Y
	CPI  R26,LOW(0x2)
	BRSH _0x42
;     388   lcd_cursor_on(1);
	LDI  R30,LOW(1)
	RJMP _0x195
;     389   else
_0x42:
;     390   lcd_cursor_on(2);
	LDI  R30,LOW(2)
_0x195:
	ST   -Y,R30
	CALL _lcd_cursor_on
;     391   lcd_gotoxy(x,y);
	LDD  R30,Y+1
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _lcd_gotoxy
;     392 }
	ADIW R28,2
	RET
;     393 
;     394 //------------------------------------------------        
;     395                                                           
;     396 void nastav_zobrazenie()
;     397 { unsigned char pom;                     
_nastav_zobrazenie:
;     398 lcd_clear();        
	ST   -Y,R16
;	pom -> R16
	CALL _lcd_clear
;     399 pom=zob;
	LDS  R16,_zob
;     400 read_enable=false;
	LDI  R30,LOW(0)
	STS  _read_enable,R30
;     401 do
_0x45:
;     402 {
;     403  co_sa_vypisuje();
	CALL _co_sa_vypisuje
;     404  lcd_gotoxy(0,0);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x16
;     405  lcd_cursor_on(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_cursor_on
;     406  key_pressed=0;
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     407  while(key_pressed==0)  _WDR;;
_0x47:
	LDS  R30,_key_pressed
	LDS  R31,_key_pressed+1
	SBIW R30,0
	BRNE _0x49
	wdr
	RJMP _0x47
_0x49:
;     408  if (key_pressed==kdisp)
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	BRNE _0x4A
;     409  if (status_harm==run)
	LDS  R26,_status_harm
	CPI  R26,LOW(0x1)
	BRNE _0x4B
;     410     zob= (zob==4)? 5:4;
	LDS  R26,_zob
	CPI  R26,LOW(0x4)
	BRNE _0x4C
	LDI  R30,LOW(5)
	RJMP _0x4D
_0x4C:
	LDI  R30,LOW(4)
_0x4D:
	RJMP _0x196
;     411    else  
_0x4B:
;     412      zob= (zob<3)? zob+1:0;
	LDS  R26,_zob
	CPI  R26,LOW(0x3)
	BRSH _0x50
	LDS  R30,_zob
	SUBI R30,-LOW(1)
	RJMP _0x51
_0x50:
	LDI  R30,LOW(0)
_0x51:
_0x196:
	STS  _zob,R30
;     413  }while ((key_pressed!=kesc)&&(key_pressed!=kenter)); 
_0x4A:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BREQ _0x53
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRNE _0x54
_0x53:
	RJMP _0x46
_0x54:
	RJMP _0x45
_0x46:
;     414  lcd_clear();
	CALL SUBOPT_0x26
;     415   if (key_pressed==kenter)
	BRNE _0x55
;     416        { 
;     417          send(4);
	CALL SUBOPT_0x27
;     418          send(0x30);  //0x30
	CALL SUBOPT_0x5
;     419          send(zob); 
;     420          send(0xbb);
;     421         } 
;     422     else zob=pom;    
	RJMP _0x56
_0x55:
	STS  _zob,R16
;     423 read_enable=true;
_0x56:
	LDI  R30,LOW(1)
	STS  _read_enable,R30
;     424  lcd_cursor_on(3);
	CALL SUBOPT_0x28
;     425 }
	LD   R16,Y+
	RET
;     426 
;     427 //------------------------------------------------        
;     428 void nastav_rozsahy()
;     429 {unsigned char posx=0,posy=0,*ptr_ram;
_nastav_rozsahy:
;     430  unsigned char pom[2][3] ;
;     431  
;     432  for (posx=0;posx<3;posx++)
	SBIW R28,6
	CALL __SAVELOCR4
;	posx -> R16
;	posy -> R17
;	*ptr_ram -> R18,R19
;	pom -> Y+4
	LDI  R16,0
	LDI  R17,0
	LDI  R16,LOW(0)
_0x58:
	CPI  R16,3
	BRSH _0x59
;     433   for (posy=0;posy<4;posy++)  
	LDI  R17,LOW(0)
_0x5B:
	CPI  R17,4
	BRSH _0x5C
;     434   pom[posx][posy]=rozsahy[posx][posy];
	CALL SUBOPT_0x29
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xA
	PUSH R27
	PUSH R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0x2A
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
;     435   
;     436   posx=0;posy=0;
	SUBI R17,-1
	RJMP _0x5B
_0x5C:
	SUBI R16,-1
	RJMP _0x58
_0x59:
	LDI  R16,LOW(0)
	LDI  R17,LOW(0)
;     437   
;     438  read_enable=false;
	LDI  R30,LOW(0)
	STS  _read_enable,R30
;     439 //------------rozsahy---------------------------  
;     440             key_pressed=0x3;                   
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	STS  _key_pressed,R30
	STS  _key_pressed+1,R31
;     441             posx=0;
	LDI  R16,LOW(0)
;     442             posy=0;
	LDI  R17,LOW(0)
;     443             while ((key_pressed!=kesc)&&(key_pressed!=kenter))
_0x5D:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BREQ _0x60
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRNE _0x61
_0x60:
	RJMP _0x5F
_0x61:
;     444             { 
;     445               _WDR;
	wdr
;     446              if (key_pressed!=0)
	LDS  R30,_key_pressed
	LDS  R31,_key_pressed+1
	SBIW R30,0
	BRNE PC+3
	JMP _0x62
;     447              {  
;     448                #asm("nop");                                          
	nop
;     449                if (key_pressed==kright)
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x400)
	LDI  R30,HIGH(0x400)
	CPC  R27,R30
	BRNE _0x63
;     450                 if (posx<2) posx++;else posx=0;
	CPI  R16,2
	BRSH _0x64
	SUBI R16,-1
	RJMP _0x65
_0x64:
	LDI  R16,LOW(0)
;     451                 
;     452                 if (key_pressed==krang)        
_0x65:
_0x63:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRNE _0x66
;     453                 if (rozsahy[posy][posx]<4) rozsahy[posy][posx]++;
	CALL SUBOPT_0x2B
	PUSH R27
	PUSH R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0x2
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0x4)
	BRSH _0x67
	CALL SUBOPT_0x2B
	PUSH R27
	PUSH R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0x2
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,-LOW(1)
	RJMP _0x197
;     454                  else  rozsahy[posy][posx]=0;     
_0x67:
	CALL SUBOPT_0x2B
	PUSH R27
	PUSH R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0x2
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
_0x197:
	ST   X,R30
;     455                  
;     456                if (key_pressed==kleft)
_0x66:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x8)
	LDI  R30,HIGH(0x8)
	CPC  R27,R30
	BRNE _0x69
;     457                 if (posx>0) posx--;else posx=2;
	LDI  R30,LOW(0)
	CP   R30,R16
	BRSH _0x6A
	SUBI R16,1
	RJMP _0x6B
_0x6A:
	LDI  R16,LOW(2)
;     458             
;     459                if ((key_pressed==kup)||(key_pressed==kdown))
_0x6B:
_0x69:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x4)
	LDI  R30,HIGH(0x4)
	CPC  R27,R30
	BREQ _0x6D
	CPI  R26,LOW(0x800)
	LDI  R30,HIGH(0x800)
	CPC  R27,R30
	BRNE _0x6C
_0x6D:
;     460                 posy= (posy==0)? 1:0;
	CPI  R17,0
	BRNE _0x6F
	LDI  R30,LOW(1)
	RJMP _0x70
_0x6F:
	LDI  R30,LOW(0)
_0x70:
	MOV  R17,R30
;     461                key_pressed=0; 
_0x6C:
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     462         
;     463              vypis_rozsahy(); 
	CALL _vypis_rozsahy
;     464              lcd_gotoxy_cursor(posx*7,posy+1);   
	MOV  R26,R16
	LDI  R30,LOW(7)
	MUL  R30,R26
	MOV  R30,R0
	ST   -Y,R30
	MOV  R30,R17
	SUBI R30,-LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy_cursor
;     465                             
;     466              }
;     467             }
_0x62:
	RJMP _0x5D
_0x5F:
;     468 //             ptr_ram=rozsahy;
;     469 //             ptr_eeprom=e_rozsahy;
;     470 //             for (posx=0;posx<6;posx++)               
;     471 //                 *ptr_eeprom++=*ptr_ram++;               
;     472            lcd_cursor_on(3); 
	CALL SUBOPT_0x28
;     473            lcd_clear();                               
	CALL SUBOPT_0x26
;     474 
;     475  if (key_pressed==kenter)
	BRNE _0x72
;     476   { 
;     477          send(9);
	CALL SUBOPT_0x2C
;     478          send(4);
;     479          send(rozsahy[1][0]);
	__GETB1MN _rozsahy,3
	ST   -Y,R30
	CALL _send
;     480          send(rozsahy[1][1]);
	__GETB1MN _rozsahy,4
	ST   -Y,R30
	CALL _send
;     481          send(rozsahy[1][2]);          
	__GETB1MN _rozsahy,5
	CALL SUBOPT_0x2D
;     482          send(rozsahy[0][0]);
;     483          send(rozsahy[0][1]);
	__GETB1MN _rozsahy,1
	ST   -Y,R30
	CALL _send
;     484          send(rozsahy[0][2]); 
	__GETB1MN _rozsahy,2
	CALL SUBOPT_0xF
;     485          send(0xbb); 
;     486    }                 
;     487    else
	RJMP _0x73
_0x72:
;     488       for (posx=0;posx<3;posx++)
	LDI  R16,LOW(0)
_0x75:
	CPI  R16,3
	BRSH _0x76
;     489         for (posy=0;posy<4;posy++)  
	LDI  R17,LOW(0)
_0x78:
	CPI  R17,4
	BRSH _0x79
;     490          rozsahy[posx][posy]=pom[posx][posy];
	CALL SUBOPT_0xA
	PUSH R27
	PUSH R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	POP  R26
	POP  R27
	CALL SUBOPT_0x2A
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x29
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
;     491   
;     492    read_enable=true;  
	SUBI R17,-1
	RJMP _0x78
_0x79:
	SUBI R16,-1
	RJMP _0x75
_0x76:
_0x73:
	LDI  R30,LOW(1)
	STS  _read_enable,R30
;     493 key_pressed=0x0;                
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     494 }
	CALL __LOADLOCR4
	ADIW R28,10
	RET
;     495 //------------------------------------------------        
;     496 
;     497 //------------------------------------------------        
;     498 
;     499 void menu()
;     500 { unsigned char pos=0,x,posy=0,*ptr_ram;
_menu:
;     501 eeprom unsigned char *ptr_eeprom;
;     502   char s[40];
;     503   unsigned int per;
;     504 read_enable=false;  
	SBIW R28,44
	CALL __SAVELOCR5
;	pos -> R16
;	x -> R17
;	posy -> R18
;	*ptr_ram -> R19,R20
;	*ptr_eeprom -> Y+47
;	s -> Y+7
;	per -> Y+5
	LDI  R16,0
	LDI  R18,0
	LDI  R30,LOW(0)
	STS  _read_enable,R30
;     505  zaciatok:
_0x7A:
;     506  pos=0;     
	LDI  R16,LOW(0)
;     507  key_pressed=0x0; 
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     508  lcd_clear();
	CALL _lcd_clear
;     509  lcd_putchar(3);
	CALL SUBOPT_0x2E
;     510  lcd_putsf("Ranges");
	__POINTW1FN _0,83
	CALL SUBOPT_0x2F
;     511  lcd_gotoxy(1,1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
;     512  lcd_putsf("Wattmeter restart");
	__POINTW1FN _0,90
	CALL SUBOPT_0x2F
;     513  lcd_gotoxy(1,2);
	CALL SUBOPT_0x8
;     514  lcd_putsf("Automatic calibration");
	__POINTW1FN _0,108
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     515  lcd_gotoxy(1,3);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x18
;     516  lcd_putsf("Display settings"); 
	__POINTW1FN _0,130
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     517  
;     518  while (key_pressed!=kesc){
_0x7B:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE PC+3
	JMP _0x7D
;     519  _WDR;
	wdr
;     520  if (key_pressed!=0){  
	LDS  R30,_key_pressed
	LDS  R31,_key_pressed+1
	SBIW R30,0
	BRNE PC+3
	JMP _0x7E
;     521   #asm("nop");
	nop
;     522   #asm("nop");
	nop
;     523   #asm("nop");
	nop
;     524 //------------rozsahy---------------------------  
;     525  if ((key_pressed==kright)&&(pos==0))
	CPI  R26,LOW(0x400)
	LDI  R30,HIGH(0x400)
	CPC  R27,R30
	BRNE _0x80
	CPI  R16,0
	BREQ _0x81
_0x80:
	RJMP _0x7F
_0x81:
;     526           {
;     527             nastav_rozsahy();              
	CALL _nastav_rozsahy
;     528             goto zaciatok;
	RJMP _0x7A
;     529           }                                 
;     530           
;     531 //---------veliciny-------------------------  
;     532   if ((key_pressed==kright)&&(pos==1))
_0x7F:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x400)
	LDI  R30,HIGH(0x400)
	CPC  R27,R30
	BRNE _0x83
	CPI  R16,1
	BREQ _0x84
_0x83:
	RJMP _0x82
_0x84:
;     533      {   
;     534       lcd_clear();
	CALL _lcd_clear
;     535       for(;;);
_0x86:
	RJMP _0x86
;     536      }                                  
;     537 //--------------display-----------------------     
;     538   if ((key_pressed==kright)&&(pos==3))
_0x82:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x400)
	LDI  R30,HIGH(0x400)
	CPC  R27,R30
	BRNE _0x89
	CPI  R16,3
	BREQ _0x8A
_0x89:
	RJMP _0x88
_0x8A:
;     539     {
;     540      lcd_clear();
	CALL _lcd_clear
;     541      posy=0;            
	LDI  R18,LOW(0)
;     542      goto pisper;
	RJMP _0x8B
;     543      while (key_pressed!=kesc)
_0x8C:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE PC+3
	JMP _0x8E
;     544        { _WDR;
	wdr
;     545           if ((key_pressed==kup) ||(key_pressed==kdown)){
	CPI  R26,LOW(0x4)
	LDI  R30,HIGH(0x4)
	CPC  R27,R30
	BREQ _0x90
	CPI  R26,LOW(0x800)
	LDI  R30,HIGH(0x800)
	CPC  R27,R30
	BRNE _0x8F
_0x90:
;     546             posy= (posy==0)? 1:0;                          
	CPI  R18,0
	BRNE _0x92
	LDI  R30,LOW(1)
	RJMP _0x93
_0x92:
	LDI  R30,LOW(0)
_0x93:
	MOV  R18,R30
;     547             goto pisper;
	RJMP _0x8B
;     548            }
;     549           
;     550           if ((key_pressed==kdisp)|| 
_0x8F:
;     551               ((key_down==kdisp)&&(polsek>10)))
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	BREQ _0x96
	LDS  R26,_key_down
	LDS  R27,_key_down+1
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	BRNE _0x97
	LDS  R26,_polsek
	LDI  R30,LOW(10)
	CP   R30,R26
	BRLO _0x96
_0x97:
	RJMP _0x95
_0x96:
;     552            {
;     553             if (posy==0) kontrast-=12;
	CPI  R18,0
	BRNE _0x9A
	IN   R30,0x2A
	SUBI R30,LOW(12)
	OUT  0x2A,R30
;     554              else light-=12;  
	RJMP _0x9B
_0x9A:
	IN   R30,0x28
	SUBI R30,LOW(12)
	OUT  0x28,R30
;     555 pisper:     polsek=0;            
_0x9B:
_0x8B:
	LDI  R30,LOW(0)
	STS  _polsek,R30
;     556             per=kontrast;
	IN   R30,0x2A
	CALL SUBOPT_0x30
;     557             per=100-(per*100)/256;
;     558             sprintf(s,"Contrast   :%u%% ",per);
	__POINTW1FN _0,147
	CALL SUBOPT_0x31
	LDI  R24,4
	CALL SUBOPT_0x32
;     559             lcd_gotoxy(0,0);
	CALL SUBOPT_0x16
;     560             lcd_puts(s);                     
	CALL SUBOPT_0x33
;     561             per=light;
	IN   R30,0x28
	CALL SUBOPT_0x30
;     562             per=100-(per*100)/256;
;     563             sprintf(s,"Back light :%u%%  ",per);
	__POINTW1FN _0,165
	CALL SUBOPT_0x31
	LDI  R24,4
	CALL SUBOPT_0x32
;     564             lcd_gotoxy(0,1);
	ST   -Y,R30
	CALL SUBOPT_0x7
;     565             lcd_puts(s);  
	CALL SUBOPT_0x33
;     566             lcd_gotoxy_cursor(12,posy);
	LDI  R30,LOW(12)
	ST   -Y,R30
	ST   -Y,R18
	CALL _lcd_gotoxy_cursor
;     567             key_pressed=0x0;
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     568            }
;     569        }  
_0x95:
	RJMP _0x8C
_0x8E:
;     570      goto zaciatok;  
	RJMP _0x7A
;     571     }
;     572 //-----kalibracia------------------------
;     573       if ((key_pressed==kright)&&(pos==2))
_0x88:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x400)
	LDI  R30,HIGH(0x400)
	CPC  R27,R30
	BRNE _0x9D
	CPI  R16,2
	BREQ _0x9E
_0x9D:
	RJMP _0x9C
_0x9E:
;     574       { 
;     575         key_pressed=0;
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     576         lcd_clear();
	CALL _lcd_clear
;     577         lcd_putsf("Disconnect all terminals and short");
	__POINTW1FN _0,184
	CALL SUBOPT_0x34
;     578         lcd_gotoxy(0,1);
	ST   -Y,R30
	CALL SUBOPT_0x7
;     579         lcd_putsf("circuit them,or connect them with ground");
	__POINTW1FN _0,219
	CALL SUBOPT_0x34
;     580         lcd_gotoxy(0,3);
	CALL SUBOPT_0x18
;     581         lcd_putsf("Press START key if done,or ESC to exit...");
	__POINTW1FN _0,260
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     582         while (1){
_0x9F:
;     583          _WDR;
	wdr
;     584          if (key_pressed==kesc) goto zaciatok;
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0xA2
	RJMP _0x7A
;     585          if (key_pressed==kenter)
_0xA2:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRNE _0xA3
;     586           {
;     587            key_pressed=0;   
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     588            send(3); //kolko bajtov sa posiela
	CALL SUBOPT_0xE
;     589            send(1); //zapis do premennej fcn 
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _send
;     590            send(2); //fcn=3  => kalibracia
	CALL SUBOPT_0x35
;     591            lcd_clear();
	CALL _lcd_clear
;     592            lcd_gotoxy(6,0);
	LDI  R30,LOW(6)
	CALL SUBOPT_0x16
;     593            lcd_putsf("Calibrating is completed!");
	__POINTW1FN _0,302
	CALL SUBOPT_0x34
;     594            lcd_gotoxy(0,26);
	ST   -Y,R30
	LDI  R30,LOW(26)
	ST   -Y,R30
	CALL _lcd_gotoxy
;     595            lcd_putsf("Press any key...");
	__POINTW1FN _0,328
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     596            while (key_pressed==0) _WDR;;
_0xA4:
	LDS  R30,_key_pressed
	LDS  R31,_key_pressed+1
	SBIW R30,0
	BRNE _0xA6
	wdr
	RJMP _0xA4
_0xA6:
;     597            goto zaciatok;
	RJMP _0x7A
;     598            
;     599           }
;     600         }
_0xA3:
	RJMP _0x9F
;     601        }
;     602  
;     603   if (key_pressed==kup) 
_0x9C:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x4)
	LDI  R30,HIGH(0x4)
	CPC  R27,R30
	BRNE _0xA7
;     604    if (pos>0) pos--;
	LDI  R30,LOW(0)
	CP   R30,R16
	BRSH _0xA8
	SUBI R16,1
;     605     else pos=3; 
	RJMP _0xA9
_0xA8:
	LDI  R16,LOW(3)
;     606     
;     607   if (key_pressed==kdown) 
_0xA9:
_0xA7:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x800)
	LDI  R30,HIGH(0x800)
	CPC  R27,R30
	BRNE _0xAA
;     608    if (pos<3) pos++;
	CPI  R16,3
	BRSH _0xAB
	SUBI R16,-1
;     609     else pos=0;    
	RJMP _0xAC
_0xAB:
	LDI  R16,LOW(0)
;     610      
;     611   key_pressed=0x0;
_0xAC:
_0xAA:
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     612  for (x=0;x<4;x++){   
	LDI  R17,LOW(0)
_0xAE:
	CPI  R17,4
	BRSH _0xAF
;     613   lcd_gotoxy(0,x);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R17
	CALL _lcd_gotoxy
;     614   lcd_putchar(' ');  
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL _lcd_putchar
;     615   }
	SUBI R17,-1
	RJMP _0xAE
_0xAF:
;     616   lcd_gotoxy(0,pos);
	CALL SUBOPT_0x1
;     617   lcd_putchar(3);  
	CALL SUBOPT_0x2E
;     618   } 
;     619  }
_0x7E:
	RJMP _0x7B
_0x7D:
;     620 lcd_cursor_on(3); //vypnutie kurzorov 
	CALL SUBOPT_0x28
;     621 read_enable=true;
	LDI  R30,LOW(1)
	STS  _read_enable,R30
;     622 }                                               
	CALL __LOADLOCR5
	ADIW R28,49
	RET
;     623 //---------------------------------------------- 
;     624 // posle status a ktora harmonicka sa ma pocitat
;     625 void send_harm()
;     626 { char st;
_send_harm:
;     627  st=read_enable;
	ST   -Y,R16
;	st -> R16
	LDS  R16,_read_enable
;     628  read_enable=false;
	CALL SUBOPT_0x4
;     629  send(4);
;     630  send(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _send
;     631  send(status_harm);
	LDS  R30,_status_harm
	ST   -Y,R30
	CALL _send
;     632  send(k_harm);
	LDS  R30,_k_harm
	ST   -Y,R30
	CALL _send
;     633  read_enable=st;
	STS  _read_enable,R16
;     634 }
	LD   R16,Y+
	RET
;     635 //---------------------------------------------- 
;     636 void main(void)
;     637 { char s[30];
_main:
;     638 unsigned char x,y,*ptr_ram;
;     639 eeprom unsigned char *ptr_eeprom;
;     640 
;     641  //inicializacia
;     642  
;     643 // Input/Output Ports initialization
;     644 // Port A initialization
;     645 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     646 // State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
;     647 PORTA=0xFF;
	SBIW R28,30
;	s -> Y+0
;	x -> R16
;	y -> R17
;	*ptr_ram -> R18,R19
;	*ptr_eeprom -> R20,R21
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     648 DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;     649 
;     650 // Port B initialization
;     651 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     652 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     653 PORTB=0x00;
	OUT  0x18,R30
;     654 DDRB=0x00;
	OUT  0x17,R30
;     655 // Port C initialization
;     656 // Func7=Out Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
;     657 // State7=0 State6=0 State5=T State4=T State3=T State2=T State1=0 State0=0 
;     658 PORTC=0x00;
	OUT  0x15,R30
;     659 DDRC=0xC3;
	LDI  R30,LOW(195)
	OUT  0x14,R30
;     660  // Port D initialization
;     661 // Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
;     662 // State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T 
;     663 PORTD=0b11001101;
	LDI  R30,LOW(205)
	OUT  0x12,R30
;     664 DDRD=0b00110010;
	LDI  R30,LOW(50)
	OUT  0x11,R30
;     665 // Timer/Counter 0 initialization
;     666 // Clock source: System Clock
;     667 // Clock value: 15,625 kHz
;     668 // Mode: Normal top=FFh
;     669 // OC0 output: Disconnected
;     670 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
;     671 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     672 OCR0=0x00;
	OUT  0x3C,R30
;     673 
;     674 // Timer/Counter 1 initialization
;     675 // Clock source: System Clock
;     676 // Clock value: 15,625 kHz
;     677 // Mode: Fast PWM top=00FFh
;     678 // OC1A output: non-Inv.
;     679 // OC1B output: non-Inv.
;     680 // Noise Canceler: Off
;     681 // Input Capture on Falling Edge
;     682 TCCR1A=0xA1;
	LDI  R30,LOW(161)
	OUT  0x2F,R30
;     683 TCCR1B=0x0a;
	LDI  R30,LOW(10)
	OUT  0x2E,R30
;     684 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     685 TCNT1L=0x00;
	OUT  0x2C,R30
;     686 ICR1H=0x00;
	OUT  0x27,R30
;     687 ICR1L=0x00;
	OUT  0x26,R30
;     688 OCR1AH=0x00;
	OUT  0x2B,R30
;     689 OCR1AL=0x10;
	LDI  R30,LOW(16)
	OUT  0x2A,R30
;     690 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;     691 OCR1BL=0x80;
	LDI  R30,LOW(128)
	OUT  0x28,R30
;     692 
;     693 // Timer/Counter 2 initialization
;     694 // Clock source: System Clock
;     695 // Clock value: Timer 2 Stopped
;     696 // Mode: Normal top=FFh
;     697 // OC2 output: Disconnected
;     698 ASSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x22,R30
;     699 TCCR2=0x00;
	OUT  0x25,R30
;     700 TCNT2=0x00;
	OUT  0x24,R30
;     701 OCR2=0x00;
	OUT  0x23,R30
;     702 
;     703 // External Interrupt(s) initialization
;     704 // INT0: Off
;     705 // INT1: Off
;     706 // INT2: Off
;     707 MCUCR=0x00;
	OUT  0x35,R30
;     708 MCUCSR=0x00;
	OUT  0x34,R30
;     709 
;     710 // Timer(s)/Counter(s) Interrupt(s) initialization
;     711 TIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x39,R30
;     712 
;     713 // USART initialization
;     714 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     715 // USART Receiver: On
;     716 // USART Transmitter: On
;     717 // USART Mode: Asynchronous
;     718 // USART Baud rate: 57600 (Double Speed Mode)
;     719 UCSRA=0x02;
	LDI  R30,LOW(2)
	OUT  0xB,R30
;     720 UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     721 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     722 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     723 //UBRRL=0x22;
;     724 UBRRL=19;
	LDI  R30,LOW(19)
	OUT  0x9,R30
;     725 // Analog Comparator initialization
;     726 // Analog Comparator: Off
;     727 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     728 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     729 SFIOR=0x00;              
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     730 
;     731 // Watchdog Timer initialization
;     732 // Watchdog Timer Prescaler: OSC/1024k
;     733 #pragma optsize-
;     734 WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
;     735 WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
;     736 #ifdef _OPTIMIZE_SIZE_
;     737 #pragma optsize+
;     738 #endif
;     739 
;     740 
;     741 // LCD module initialization
;     742 lcd_init();
	CALL _lcd_init
;     743 define_char(char1,1);     //znak fi
	LDI  R30,LOW(_char1*2)
	LDI  R31,HIGH(_char1*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _define_char
;     744 // define_char(char2,2);  //  znak omega
;     745 define_char(char3,3);     //sipka 
	LDI  R30,LOW(_char3*2)
	LDI  R31,HIGH(_char3*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _define_char
;     746 define_char(char4,4);
	LDI  R30,LOW(_char4*2)
	LDI  R31,HIGH(_char4*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _define_char
;     747 define_char(char5,5);
	LDI  R30,LOW(_char5*2)
	LDI  R31,HIGH(_char5*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _define_char
;     748 define_char(char6,6);
	LDI  R30,LOW(_char6*2)
	LDI  R31,HIGH(_char6*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _define_char
;     749 // if (lcd==0) error|=lcd_err;
;     750 // Global enable interrupts
;     751 #asm("sei")
	sei
;     752 PORTC|=0b11000011;
	IN   R30,0x15
	ORI  R30,LOW(0xC3)
	OUT  0x15,R30
;     753 
;     754 
;     755 key_down0=0x0;
	LDI  R30,0
	STS  _key_down0,R30
	STS  _key_down0+1,R30
;     756 key_down=key_down0;
	LDS  R30,_key_down0
	LDS  R31,_key_down0+1
	STS  _key_down,R30
	STS  _key_down+1,R31
;     757 key_pressed=0x0;  
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     758 
;     759 //nacitanie nastaveni z EEPROM
;     760 // ptr_ram=velic_typ;
;     761 // ptr_eeprom=e_velic_typ;
;     762 // for (x=0;x<16;x++)               
;     763 //  *ptr_ram++=*ptr_eeprom++;
;     764 // ptr_ram=rozsahy;
;     765 // ptr_eeprom=e_rozsahy;
;     766 // for (x=0;x<6;x++)               
;     767 //  *ptr_ram++=*ptr_eeprom++; 
;     768       
;     769 posli_zob();  
	CALL _posli_zob
;     770 
;     771 lcd_clear();
	CALL _lcd_clear
;     772 lcd_gotoxy(6,1);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL SUBOPT_0x7
;     773 lcd_putsf("THREE PHASE VECTOR WATTMETER");
	__POINTW1FN _0,345
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     774 for (x=0;x<6;x++)  rozsahy[x][0]=0;
	LDI  R16,LOW(0)
_0xB1:
	CPI  R16,6
	BRSH _0xB2
	CALL SUBOPT_0xA
	PUSH R27
	PUSH R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;     775 sek_m=0;
	SUBI R16,-1
	RJMP _0xB1
_0xB2:
	LDI  R30,LOW(0)
	STS  _sek_m,R30
;     776 while (sek_m<100) _WDR;;
_0xB3:
	LDS  R26,_sek_m
	CPI  R26,LOW(0x64)
	BRSH _0xB5
	wdr
	RJMP _0xB3
_0xB5:
;     777 
;     778          send(9);
	CALL SUBOPT_0x2C
;     779          send(4);
;     780          send(rozsahy[1][0]);
	__GETB1MN _rozsahy,3
	ST   -Y,R30
	CALL _send
;     781          send(rozsahy[1][1]);
	__GETB1MN _rozsahy,4
	ST   -Y,R30
	CALL _send
;     782          send(rozsahy[1][2]);          
	__GETB1MN _rozsahy,5
	CALL SUBOPT_0x2D
;     783          send(rozsahy[0][0]);
;     784          send(rozsahy[0][1]);
	__GETB1MN _rozsahy,1
	ST   -Y,R30
	CALL _send
;     785          send(rozsahy[0][2]); 
	__GETB1MN _rozsahy,2
	CALL SUBOPT_0xF
;     786          send(0xbb); 
;     787  
;     788 for (;;)
_0xB7:
;     789     {   
;     790 
;     791      if (key_down==kdisp){   //vypise co sa vypisuje      
	LDS  R26,_key_down
	LDS  R27,_key_down+1
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	BRNE _0xB9
;     792       co_sa_vypisuje();
	CALL _co_sa_vypisuje
;     793       while (key_down==kdisp) _WDR;;
_0xBA:
	LDS  R26,_key_down
	LDS  R27,_key_down+1
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	BRNE _0xBC
	wdr
	RJMP _0xBA
_0xBC:
;     794       lcd_clear();
	CALL _lcd_clear
;     795       }      
;     796       if (key_down==krang){ //vypise rozsahy
_0xB9:
	LDS  R26,_key_down
	LDS  R27,_key_down+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRNE _0xBD
;     797       vypis_rozsahy();
	CALL _vypis_rozsahy
;     798       while (key_down==krang) _WDR;;
_0xBE:
	LDS  R26,_key_down
	LDS  R27,_key_down+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRNE _0xC0
	wdr
	RJMP _0xBE
_0xC0:
;     799       lcd_clear();
	CALL _lcd_clear
;     800       }      
;     801         else
	RJMP _0xC1
_0xBD:
;     802          vypis_namerane();
	CALL _vypis_namerane
;     803      if (key_pressed==kstop){                  
_0xC1:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRNE _0xC2
;     804                               if (status==run)
	LDS  R26,_status
	CPI  R26,LOW(0x1)
	BRNE _0xC3
;     805                                {  
;     806                                  read_enable=false; 
	CALL SUBOPT_0x36
;     807                                  send(2);       
;     808                                  send(6); 
	LDI  R30,LOW(6)
	CALL SUBOPT_0x37
;     809                                  //send(0xbb); 
;     810                                  read_enable=true;                                
;     811                                 status=stop;
	LDI  R30,LOW(0)
	RJMP _0x198
;     812                                }
;     813                               else
_0xC3:
;     814                                {
;     815                                  read_enable=false; 
	CALL SUBOPT_0x36
;     816                                  send(2);       
;     817                                  send(7); 
	LDI  R30,LOW(7)
	CALL SUBOPT_0x37
;     818                                 // send(0xbb); 
;     819                                  read_enable=true;                             
;     820                                 status=run;  
	LDI  R30,LOW(1)
_0x198:
	STS  _status,R30
;     821                                } 
;     822                               nuluj_tlac;
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     823                               }
;     824      if (key_pressed==kmenu) menu();
_0xC2:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x4000)
	LDI  R30,HIGH(0x4000)
	CPC  R27,R30
	BRNE _0xC5
	CALL _menu
;     825      if (key_down==(krang|kshift)) 
_0xC5:
	LDS  R26,_key_down
	LDS  R27,_key_down+1
	CPI  R26,LOW(0x140)
	LDI  R30,HIGH(0x140)
	CPC  R27,R30
	BRNE _0xC6
;     826       {
;     827         nastav_rozsahy();  
	CALL _nastav_rozsahy
;     828         nuluj_tlac;
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     829        } 
;     830      if (key_down==(kdisp|kshift)) nastav_zobrazenie();  
_0xC6:
	LDS  R26,_key_down
	LDS  R27,_key_down+1
	CPI  R26,LOW(0x180)
	LDI  R30,HIGH(0x180)
	CPC  R27,R30
	BRNE _0xC7
	CALL _nastav_zobrazenie
;     831      if (key_pressed==krms){
_0xC7:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x20)
	LDI  R30,HIGH(0x20)
	CPC  R27,R30
	BRNE _0xC8
;     832       if (status_harm==stop)            
	LDS  R30,_status_harm
	CPI  R30,0
	BRNE _0xC9
;     833        zob=0;              
	LDI  R30,LOW(0)
	RJMP _0x199
;     834       else   
_0xC9:
;     835        zob=4;
	LDI  R30,LOW(4)
_0x199:
	STS  _zob,R30
;     836        posli_zob();
	CALL _posli_zob
;     837       }    
;     838      if (key_pressed==kpow)
_0xC8:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x10)
	LDI  R30,HIGH(0x10)
	CPC  R27,R30
	BRNE _0xCB
;     839       {            
;     840         if (status_harm==stop)            
	LDS  R30,_status_harm
	CPI  R30,0
	BRNE _0xCC
;     841        zob=1;              
	LDI  R30,LOW(1)
	RJMP _0x19A
;     842       else   
_0xCC:
;     843        zob=5;
	LDI  R30,LOW(5)
_0x19A:
	STS  _zob,R30
;     844        posli_zob();
	CALL _posli_zob
;     845       }
;     846      if (key_pressed==kmax)
_0xCB:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x1000)
	LDI  R30,HIGH(0x1000)
	CPC  R27,R30
	BRNE _0xCE
;     847       {            
;     848         if (status_harm==stop)            
	LDS  R30,_status_harm
	CPI  R30,0
	BRNE _0xCF
;     849        zob=2;              
	LDI  R30,LOW(2)
	RJMP _0x19B
;     850       else   
_0xCF:
;     851        zob=4;
	LDI  R30,LOW(4)
_0x19B:
	STS  _zob,R30
;     852        posli_zob();
	CALL _posli_zob
;     853       }  
;     854      if ((key_pressed==kavg)&&(status_harm==stop))
_0xCE:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x2000)
	LDI  R30,HIGH(0x2000)
	CPC  R27,R30
	BRNE _0xD2
	LDS  R26,_status_harm
	CPI  R26,LOW(0x0)
	BREQ _0xD3
_0xD2:
	RJMP _0xD1
_0xD3:
;     855       {            
;     856        zob=3;       
	LDI  R30,LOW(3)
	STS  _zob,R30
;     857        posli_zob();
	CALL _posli_zob
;     858       }             
;     859      if (key_pressed==kharm) {
_0xD1:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x2)
	LDI  R30,HIGH(0x2)
	CPC  R27,R30
	BRNE _0xD4
;     860                            if (status_harm==run)
	LDS  R26,_status_harm
	CPI  R26,LOW(0x1)
	BRNE _0xD5
;     861                                {  
;     862                                                               
;     863                                 status_harm=stop;
	LDI  R30,LOW(0)
	STS  _status_harm,R30
;     864                                 zob=0;
	STS  _zob,R30
;     865                                 posli_zob();
	CALL _posli_zob
;     866 
;     867                                }
;     868                               else
	RJMP _0xD6
_0xD5:
;     869                                {
;     870                                 
;     871                                 status_harm=run; 
	LDI  R30,LOW(1)
	STS  _status_harm,R30
;     872                                 if ((zob!=1)&&(zob!=4))
	LDS  R26,_zob
	CPI  R26,LOW(0x1)
	BREQ _0xD8
	CPI  R26,LOW(0x4)
	BRNE _0xD9
_0xD8:
	RJMP _0xD7
_0xD9:
;     873                                 {  
;     874                                   zob=4;
	LDI  R30,LOW(4)
	STS  _zob,R30
;     875                                   posli_zob();           
	CALL _posli_zob
;     876 
;     877                                 } 
;     878                                } 
_0xD7:
_0xD6:
;     879                               nuluj_tlac;
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     880                               send_harm();
	CALL _send_harm
;     881                             }
;     882      if (key_pressed==kup)   {
_0xD4:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x4)
	LDI  R30,HIGH(0x4)
	CPC  R27,R30
	BRNE _0xDA
;     883                               nuluj_tlac;  
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     884                               k_harm= (k_harm<50)? k_harm+1:0;
	LDS  R26,_k_harm
	CPI  R26,LOW(0x32)
	BRSH _0xDB
	LDS  R30,_k_harm
	SUBI R30,-LOW(1)
	RJMP _0xDC
_0xDB:
	LDI  R30,LOW(0)
_0xDC:
	STS  _k_harm,R30
;     885                               send_harm();
	CALL _send_harm
;     886                              } 
;     887      if (key_pressed==kdown) {
_0xDA:
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x800)
	LDI  R30,HIGH(0x800)
	CPC  R27,R30
	BRNE _0xDE
;     888                               nuluj_tlac;   
	LDI  R30,0
	STS  _key_pressed,R30
	STS  _key_pressed+1,R30
;     889                               k_harm= (k_harm>0)?  k_harm-1:50;
	LDS  R26,_k_harm
	LDI  R30,LOW(0)
	CP   R30,R26
	BRSH _0xDF
	LDS  R30,_k_harm
	SUBI R30,LOW(1)
	RJMP _0xE0
_0xDF:
	LDI  R30,LOW(50)
_0xE0:
	STS  _k_harm,R30
;     890                               send_harm();
	CALL _send_harm
;     891                              } 
;     892     _WDR;                         
_0xDE:
	wdr
;     893     };
	RJMP _0xB7
;     894 }
	ADIW R28,30
_0xE2:
	RJMP _0xE2

    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable1=2
    .equ __lcd_enable2=3
    .equ __lcd_busy_flag=7

	.DSEG
__en1_msk:
	.BYTE 0x1

	.CSEG
__lcd_delay_G2:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    ldi   r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
    in    r26,__lcd_port
    lds   r27,__en1_msk
__lcd_busy:
	CALL __lcd_delay_G2
    or    r26,r27
    out   __lcd_port,r26          ;EN=1
	CALL __lcd_delay_G2
    in    r30,__lcd_pin
    andi  r26,0xf3
    out   __lcd_port,r26          ;EN=0
	CALL __lcd_delay_G2
    or    r26,r27
    out   __lcd_port,r26          ;EN=1
	CALL __lcd_delay_G2
    andi  r26,0xf3
    out   __lcd_port,r26          ;EN=0
	CALL __lcd_delay_G2
    sbrc  r30,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G2:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    or    r26,r30
    out   __lcd_port,r26          ;EN=1
	CALL __lcd_delay_G2
    andi  r26,0xf3
    out   __lcd_port,r26          ;EN=0
	CALL __lcd_delay_G2
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    ldi   r26,0xff                ;set as output
    out   __lcd_direction,r26
    lds   r30,__en1_msk
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G2
    ld    r26,y
    swap  r26
	CALL __lcd_write_nibble_G2
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_write_byte:
	CALL __lcd_ready
	LDD  R30,Y+1
	CALL SUBOPT_0x38
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	ST   -Y,R30
	CALL __lcd_write_data
	ADIW R28,2
	RET
__lcd_read_nibble_G2:
    in    r27,__lcd_port
    lds   r30,__en1_msk
    or    r27,r30
    out   __lcd_port,r27          ;EN=1
	CALL __lcd_delay_G2
    in    r30,__lcd_pin           ;read
    andi  r27,0xf3
    out   __lcd_port,r27          ;EN=0
	CALL __lcd_delay_G2
    andi  r30,0xf0
	RET
_lcd_read_byte0_G2:
	CALL __lcd_delay_G2
	CALL __lcd_read_nibble_G2
    mov   r26,r30
	CALL __lcd_read_nibble_G2
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	ST   -Y,R16
	LDI  R30,LOW(4)
	STS  __en1_msk,R30
	LDD  R26,Y+1
	LDI  R30,LOW(1)
	CP   R30,R26
	BRSH _0xE3
	LDI  R30,LOW(8)
	STS  __en1_msk,R30
_0xE3:
	LDD  R30,Y+2
	SUBI R30,-LOW(128)
	MOV  R16,R30
	LDD  R30,Y+1
	ANDI R30,LOW(0x1)
	BREQ _0xE4
	ORI  R16,LOW(64)
_0xE4:
	CALL __lcd_ready
	ST   -Y,R16
	CALL __lcd_write_data
	LDD  R4,Y+2
	LDD  R5,Y+1
	LDD  R16,Y+0
	ADIW R28,3
	RET
_lcd_clear1:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	CALL SUBOPT_0x38
	CALL SUBOPT_0x23
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	RET
_lcd_clear:
	LDI  R30,LOW(8)
	STS  __en1_msk,R30
	CALL _lcd_clear1
	LDI  R30,LOW(4)
	STS  __en1_msk,R30
	CALL _lcd_clear1
	LDI  R30,LOW(0)
	MOV  R5,R30
	MOV  R4,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R4
	LDI  R30,LOW(40)
	CP   R30,R4
	BRSH _0xE5
	__lcd_putchar1:
	INC  R5
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R5
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0xE5:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
_lcd_putsf:
    ld   r30,y
    ldd  r31,y+1
__lcd_putsf0:
	lpm
    tst  r0
    breq __lcd_putsf1
    adiw r30,1
    st   -y,r0
    rcall _lcd_putchar
    rjmp __lcd_putsf0
__lcd_putsf1:
	ADIW R28,2
	RET
__long_delay:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G2:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    ldi   r26,0xff                ;set as output
    out   __lcd_direction,r26
    lds   r30,__en1_msk
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G2
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init1_G2:
	CALL SUBOPT_0x39
	CALL SUBOPT_0x39
	CALL SUBOPT_0x39
	CALL __long_delay
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G2
	CALL __long_delay
	LDI  R30,LOW(40)
	CALL SUBOPT_0x3A
	LDI  R30,LOW(4)
	CALL SUBOPT_0x3A
	LDI  R30,LOW(133)
	CALL SUBOPT_0x3A
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G2
	CPI  R30,LOW(0x5)
	BREQ _0xE6
	LDI  R30,LOW(0)
	RET
_0xE6:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(1)
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable1 ;EN1=0
    cbi   __lcd_port,__lcd_enable2 ;EN2=0
    cbi   __lcd_port,__lcd_rs      ;RS=0
	LDI  R30,LOW(4)
	CALL SUBOPT_0x3B
	BRNE _0xE7
	LDI  R30,LOW(0)
	RET
_0xE7:
	LDI  R30,LOW(8)
	CALL SUBOPT_0x3B
	BRNE _0xE8
	LDI  R30,LOW(0)
	RET
_0xE8:
	CALL _lcd_clear
	LDI  R30,LOW(1)
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r26,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r26,y
     out  udr,r26
	ADIW R28,1
	RET
__put_G3:
	put:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0xE9
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	SBIW R30,1
	LDD  R26,Y+2
	STD  Z+0,R26
	RJMP _0xEA
_0xE9:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _putchar
_0xEA:
	ADIW R28,3
	RET
__ftoa_G3:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+8
	LDI  R30,LOW(5)
	CP   R30,R26
	BRSH _0xEB
	STD  Y+8,R30
_0xEB:
	LDI  R26,LOW(__fround_G3*2)
	LDI  R27,HIGH(__fround_G3*2)
	LDD  R30,Y+8
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETD1PF
	__GETD2S 9
	CALL __ADDF12
	__PUTD1S 9
	LDI  R16,LOW(0)
	__GETD1N 0x3F800000
	__PUTD1S 2
_0xEC:
	__GETD1S 2
	__GETD2S 9
	CALL __CMPF12
	BRLO _0xEE
	__GETD2S 2
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 2
	SUBI R16,-LOW(1)
	RJMP _0xEC
_0xEE:
	CPI  R16,0
	BRNE _0xEF
	CALL SUBOPT_0x3C
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0xF0
_0xEF:
_0xF1:
	MOV  R30,R16
	SUBI R16,1
	CPI  R30,0
	BREQ _0xF3
	__GETD2S 2
	CALL SUBOPT_0x3D
	__PUTD1S 2
	__GETD2S 9
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x3C
	CALL SUBOPT_0x3F
	__GETD2S 2
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __MULF12
	__GETD2S 9
	CALL SUBOPT_0x40
	RJMP _0xF1
_0xF3:
_0xF0:
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0xF4
	CALL SUBOPT_0x41
	RJMP _0x192
_0xF4:
	CALL SUBOPT_0x3C
	LDI  R30,LOW(46)
	ST   X,R30
_0xF5:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0xF7
	__GETD2S 9
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 9
	CALL __CFD1
	MOV  R17,R30
	CALL SUBOPT_0x3C
	CALL SUBOPT_0x3F
	__GETD2S 9
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL SUBOPT_0x40
	RJMP _0xF5
_0xF7:
	CALL SUBOPT_0x41
_0x192:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET
__ftoe_G3:
	SBIW R28,4
	CALL __SAVELOCR3
	__GETD1N 0x3F800000
	__PUTD1S 3
	LDD  R26,Y+10
	LDI  R30,LOW(5)
	CP   R30,R26
	BRSH _0xF8
	STD  Y+10,R30
_0xF8:
	LDD  R16,Y+10
_0xF9:
	MOV  R30,R16
	SUBI R16,1
	CPI  R30,0
	BREQ _0xFB
	CALL SUBOPT_0x42
	RJMP _0xF9
_0xFB:
	__GETD1S 11
	CALL __CPD10
	BRNE _0xFC
	LDI  R18,LOW(0)
	CALL SUBOPT_0x42
	RJMP _0xFD
_0xFC:
	LDD  R18,Y+10
	CALL SUBOPT_0x43
	BREQ PC+2
	BRCC PC+3
	JMP  _0xFE
	CALL SUBOPT_0x42
_0xFF:
	CALL SUBOPT_0x43
	BRLO _0x101
	CALL SUBOPT_0x44
	SUBI R18,-LOW(1)
	RJMP _0xFF
_0x101:
	RJMP _0x102
_0xFE:
_0x103:
	CALL SUBOPT_0x43
	BRSH _0x105
	__GETD2S 11
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 11
	SUBI R18,LOW(1)
	RJMP _0x103
_0x105:
	CALL SUBOPT_0x42
_0x102:
	__GETD1S 11
	__GETD2N 0x3F000000
	CALL __ADDF12
	__PUTD1S 11
	CALL SUBOPT_0x43
	BRLO _0x106
	CALL SUBOPT_0x44
	SUBI R18,-LOW(1)
_0x106:
_0xFD:
	LDI  R16,LOW(0)
_0x107:
	LDD  R30,Y+10
	CP   R30,R16
	BRLO _0x109
	__GETD2S 3
	CALL SUBOPT_0x3D
	__PUTD1S 3
	__GETD2S 11
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x45
	CALL SUBOPT_0x3F
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2S 3
	CALL __MULF12
	__GETD2S 11
	CALL __SWAPD12
	CALL __SUBF12
	__PUTD1S 11
	MOV  R30,R16
	SUBI R16,-1
	CPI  R30,0
	BRNE _0x107
	CALL SUBOPT_0x45
	LDI  R30,LOW(46)
	ST   X,R30
	RJMP _0x107
_0x109:
	CALL SUBOPT_0x46
	LDD  R26,Y+9
	STD  Z+0,R26
	CPI  R18,0
	BRGE _0x10B
	CALL SUBOPT_0x45
	LDI  R30,LOW(45)
	ST   X,R30
	NEG  R18
_0x10B:
	LDI  R30,LOW(9)
	CP   R30,R18
	BRGE _0x10C
	CALL SUBOPT_0x46
	PUSH R31
	PUSH R30
	MOV  R26,R18
	LDI  R30,LOW(10)
	CALL __DIVB21
	SUBI R30,-LOW(48)
	POP  R26
	POP  R27
	ST   X,R30
_0x10C:
	CALL SUBOPT_0x46
	PUSH R31
	PUSH R30
	MOV  R26,R18
	LDI  R30,LOW(10)
	CALL __MODB21
	SUBI R30,-LOW(48)
	POP  R26
	POP  R27
	ST   X,R30
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LDI  R30,LOW(0)
	ST   X,R30
	CALL __LOADLOCR3
	ADIW R28,15
	RET
__print_sign_G3:
    ;flags&=~F_SIGNED
    andi r17,~4
    ;_put(s,ptr_ps)
    ldd  r30,y+17
    st   -y,r30
    ldd  r30,y+19+16
    ldd  r31,y+20+16
    st   -y,r31
    st   -y,r30
    rcall put
    ;if (width) --width
    cpi  r20,0
    breq width0
    dec  r20
width0:
	RET
__print_G3:
	SBIW R28,28
	CALL __SAVELOCR6
	LDI  R16,0
_0x10D:
	LDD  R30,Y+38
	LDD  R31,Y+38+1
	ADIW R30,1
	STD  Y+38,R30
	STD  Y+38+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x10F
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x113
	CPI  R19,37
	BRNE _0x114
	LDI  R16,LOW(1)
	RJMP _0x115
_0x114:
	CALL SUBOPT_0x47
_0x115:
	RJMP _0x112
_0x113:
	CPI  R30,LOW(0x1)
	BRNE _0x116
	CPI  R19,37
	BRNE _0x117
	CALL SUBOPT_0x47
	LDI  R16,LOW(0)
	RJMP _0x112
_0x117:
	LDI  R16,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+17,R30
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x118
	LDI  R17,LOW(1)
	RJMP _0x112
_0x118:
	CPI  R19,43
	BRNE _0x119
	LDI  R30,LOW(43)
	STD  Y+17,R30
	RJMP _0x112
_0x119:
	CPI  R19,32
	BRNE _0x11A
	LDI  R30,LOW(32)
	STD  Y+17,R30
	RJMP _0x112
_0x11A:
	RJMP _0x11B
_0x116:
	CPI  R30,LOW(0x2)
	BRNE _0x11C
_0x11B:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x11D
	ORI  R17,LOW(128)
	RJMP _0x112
_0x11D:
	RJMP _0x11E
_0x11C:
	CPI  R30,LOW(0x3)
	BRNE _0x11F
_0x11E:
	CPI  R19,48
	BRLO _0x121
	CPI  R19,58
	BRLO _0x122
_0x121:
	RJMP _0x120
_0x122:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x112
_0x120:
	LDI  R21,LOW(0)
	CPI  R19,46
	BRNE _0x123
	LDI  R16,LOW(4)
	RJMP _0x112
_0x123:
	RJMP _0x124
_0x11F:
	CPI  R30,LOW(0x4)
	BRNE _0x126
	CPI  R19,48
	BRLO _0x128
	CPI  R19,58
	BRLO _0x129
_0x128:
	RJMP _0x127
_0x129:
	ORI  R17,LOW(32)
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R21,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x112
_0x127:
_0x124:
	CPI  R19,108
	BRNE _0x12A
	ORI  R17,LOW(2)
	LDI  R16,LOW(5)
	RJMP _0x112
_0x12A:
	RJMP _0x12B
_0x126:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x112
_0x12B:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x130
	CALL SUBOPT_0x48
	LD   R30,X
	CALL SUBOPT_0x49
	RJMP _0x131
_0x130:
	CPI  R30,LOW(0x45)
	BREQ _0x134
	CPI  R30,LOW(0x65)
	BRNE _0x135
_0x134:
	RJMP _0x136
_0x135:
	CPI  R30,LOW(0x66)
	BREQ PC+3
	JMP _0x137
_0x136:
	MOVW R30,R28
	ADIW R30,18
	STD  Y+6,R30
	STD  Y+6+1,R31
	CALL SUBOPT_0x48
	CALL __GETD1P
	__PUTD1S 8
	MOVW R26,R30
	MOVW R24,R22
	CALL __CPD20
	BRLT _0x138
	LDD  R26,Y+17
	CPI  R26,LOW(0x2B)
	BREQ _0x13A
	RJMP _0x13B
_0x138:
	__GETD1S 8
	CALL __ANEGF1
	CALL SUBOPT_0x4A
_0x13A:
	SBRS R17,7
	RJMP _0x13C
	LDD  R30,Y+17
	CALL SUBOPT_0x49
	RJMP _0x13D
_0x13C:
	CALL SUBOPT_0x4B
	LDD  R26,Y+17
	STD  Z+0,R26
_0x13D:
_0x13B:
	SBRS R17,5
	LDI  R21,LOW(5)
	CPI  R19,102
	BRNE _0x13F
	CALL SUBOPT_0x4C
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ST   -Y,R31
	ST   -Y,R30
	CALL __ftoa_G3
	RJMP _0x140
_0x13F:
	CALL SUBOPT_0x4C
	ST   -Y,R19
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	CALL __ftoe_G3
_0x140:
	MOVW R30,R28
	ADIW R30,18
	CALL SUBOPT_0x4D
	RJMP _0x141
_0x137:
	CPI  R30,LOW(0x73)
	BRNE _0x143
	CALL SUBOPT_0x48
	CALL __GETW1P
	CALL SUBOPT_0x4D
	RJMP _0x144
_0x143:
	CPI  R30,LOW(0x70)
	BRNE _0x146
	CALL SUBOPT_0x48
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x144:
	ANDI R17,LOW(127)
	CPI  R21,0
	BREQ _0x148
	CP   R21,R16
	BRLO _0x149
_0x148:
	RJMP _0x147
_0x149:
	MOV  R16,R21
_0x147:
_0x141:
	LDI  R21,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+16,R30
	LDI  R18,LOW(0)
	RJMP _0x14A
_0x146:
	CPI  R30,LOW(0x64)
	BREQ _0x14D
	CPI  R30,LOW(0x69)
	BRNE _0x14E
_0x14D:
	ORI  R17,LOW(4)
	RJMP _0x14F
_0x14E:
	CPI  R30,LOW(0x75)
	BRNE _0x150
_0x14F:
	LDI  R30,LOW(10)
	STD  Y+16,R30
	SBRS R17,1
	RJMP _0x151
	__GETD1N 0x3B9ACA00
	__PUTD1S 12
	LDI  R16,LOW(10)
	RJMP _0x152
_0x151:
	__GETD1N 0x2710
	__PUTD1S 12
	LDI  R16,LOW(5)
	RJMP _0x152
_0x150:
	CPI  R30,LOW(0x58)
	BRNE _0x154
	ORI  R17,LOW(8)
	RJMP _0x155
_0x154:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x191
_0x155:
	LDI  R30,LOW(16)
	STD  Y+16,R30
	SBRS R17,1
	RJMP _0x157
	__GETD1N 0x10000000
	__PUTD1S 12
	LDI  R16,LOW(8)
	RJMP _0x152
_0x157:
	__GETD1N 0x1000
	__PUTD1S 12
	LDI  R16,LOW(4)
_0x152:
	CPI  R21,0
	BREQ _0x158
	ANDI R17,LOW(127)
	RJMP _0x159
_0x158:
	LDI  R21,LOW(1)
_0x159:
	SBRS R17,1
	RJMP _0x15A
	CALL SUBOPT_0x48
	CALL __GETD1P
	__PUTD1S 8
	RJMP _0x15B
_0x15A:
	SBRS R17,2
	RJMP _0x15C
	CALL SUBOPT_0x48
	CALL __GETW1P
	CALL __CWD1
	RJMP _0x19C
_0x15C:
	CALL SUBOPT_0x48
	CALL __GETW1P
	CLR  R22
	CLR  R23
_0x19C:
	__PUTD1S 8
_0x15B:
	SBRS R17,2
	RJMP _0x15E
	__GETD2S 8
	CALL __CPD20
	BRGE _0x15F
	__GETD1S 8
	CALL __ANEGD1
	CALL SUBOPT_0x4A
_0x15F:
	LDD  R30,Y+17
	CPI  R30,0
	BREQ _0x160
	SUBI R16,-LOW(1)
	SUBI R21,-LOW(1)
	RJMP _0x161
_0x160:
	ANDI R17,LOW(251)
_0x161:
_0x15E:
	MOV  R18,R21
_0x14A:
	SBRC R17,0
	RJMP _0x162
_0x163:
	CP   R16,R20
	BRSH _0x166
	CP   R18,R20
	BRLO _0x167
_0x166:
	RJMP _0x165
_0x167:
	SBRS R17,7
	RJMP _0x168
	SBRS R17,2
	RJMP _0x169
	ANDI R17,LOW(251)
	LDD  R19,Y+17
	SUBI R16,LOW(1)
	RJMP _0x16A
_0x169:
	LDI  R19,LOW(48)
_0x16A:
	RJMP _0x16B
_0x168:
	LDI  R19,LOW(32)
_0x16B:
	CALL SUBOPT_0x47
	SUBI R20,LOW(1)
	RJMP _0x163
_0x165:
_0x162:
_0x16C:
	CP   R16,R21
	BRSH _0x16E
	ORI  R17,LOW(16)
	SBRS R17,2
	RJMP _0x16F
	CALL __print_sign_G3
	SUBI R16,LOW(1)
	SUBI R21,LOW(1)
_0x16F:
	LDI  R30,LOW(48)
	CALL SUBOPT_0x49
	CPI  R20,0
	BREQ _0x170
	SUBI R20,LOW(1)
_0x170:
	SUBI R21,LOW(1)
	RJMP _0x16C
_0x16E:
	MOV  R18,R16
	LDD  R30,Y+16
	CPI  R30,0
	BRNE _0x171
_0x172:
	CPI  R18,0
	BREQ _0x174
	SBRS R17,3
	RJMP _0x175
	CALL SUBOPT_0x4B
	LPM  R30,Z
	RJMP _0x19D
_0x175:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x19D:
	ST   -Y,R30
	LDD  R30,Y+35
	LDD  R31,Y+35+1
	ST   -Y,R31
	ST   -Y,R30
	CALL __put_G3
	CPI  R20,0
	BREQ _0x177
	SUBI R20,LOW(1)
_0x177:
	SUBI R18,LOW(1)
	RJMP _0x172
_0x174:
	RJMP _0x178
_0x171:
_0x17A:
	__GETD1S 12
	__GETD2S 8
	CALL __DIVD21U
	MOV  R19,R30
	LDI  R30,LOW(9)
	CP   R30,R19
	BRSH _0x17C
	SBRS R17,3
	RJMP _0x17D
	SUBI R19,-LOW(55)
	RJMP _0x17E
_0x17D:
	SUBI R19,-LOW(87)
_0x17E:
	RJMP _0x17F
_0x17C:
	SUBI R19,-LOW(48)
_0x17F:
	SBRC R17,4
	RJMP _0x181
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x183
	__GETD2S 12
	__CPD2N 0x1
	BRNE _0x182
_0x183:
	RJMP _0x185
_0x182:
	CP   R21,R18
	BRLO _0x186
	LDI  R19,LOW(48)
	RJMP _0x185
_0x186:
	CP   R20,R18
	BRLO _0x188
	SBRS R17,0
	RJMP _0x189
_0x188:
	RJMP _0x187
_0x189:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x18A
	LDI  R19,LOW(48)
_0x185:
	ORI  R17,LOW(16)
	SBRS R17,2
	RJMP _0x18B
	CALL __print_sign_G3
_0x18B:
_0x18A:
_0x181:
	CALL SUBOPT_0x47
	CPI  R20,0
	BREQ _0x18C
	SUBI R20,LOW(1)
_0x18C:
_0x187:
	SUBI R18,LOW(1)
	__GETD1S 12
	__GETD2S 8
	CALL __MODD21U
	__PUTD1S 8
	LDD  R30,Y+16
	__GETD2S 12
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	__PUTD1S 12
	CALL __CPD10
	BREQ _0x17B
	RJMP _0x17A
_0x17B:
_0x178:
	SBRS R17,0
	RJMP _0x18D
_0x18E:
	CPI  R20,0
	BREQ _0x190
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x49
	RJMP _0x18E
_0x190:
_0x18D:
_0x191:
_0x131:
	LDI  R16,LOW(0)
_0x112:
	RJMP _0x10D
_0x10F:
	CALL __LOADLOCR6
	ADIW R28,40
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	__PUTW2R 16,17
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G3
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LPM  R30,Z
	ST   -Y,R30
	JMP  _lcd_write_byte

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R16
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x2:
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R16
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3:
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(0)
	STS  _read_enable,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	JMP  _send

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL _send
	LDS  R30,_zob
	ST   -Y,R30
	CALL _send
	LDI  R30,LOW(187)
	ST   -Y,R30
	JMP  _send

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
	LDI  R30,LOW(20)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x7:
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x8:
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x9:
	LDI  R26,LOW(_rozsahy_text*2)
	LDI  R27,HIGH(_rozsahy_text*2)
	MOV  R30,R16
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xA:
	MOV  R30,R16
	LDI  R26,LOW(_rozsahy)
	LDI  R27,HIGH(_rozsahy)
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	ADD  R30,R26
	ADC  R31,R27
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	IN   R30,0x19
	LDI  R31,0
	__PUTW1R 16,17
	LDS  R30,_key_down
	LDS  R31,_key_down+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _send

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xF:
	ST   -Y,R30
	CALL _send
	LDI  R30,LOW(187)
	ST   -Y,R30
	JMP  _send

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x10:
	LDI  R26,LOW(_meas_data)
	LDI  R27,HIGH(_meas_data)
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x11:
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(7)
	LDI  R27,HIGH(7)
	CALL __MULW12U
	MOVW R26,R28
	ADIW R26,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x12:
	LDI  R26,LOW(_velic_text*2)
	LDI  R27,HIGH(_velic_text*2)
	LDS  R30,_zob
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x13:
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x14:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x15:
	MOV  R30,R16
	LDI  R31,0
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x16:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x18:
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	MOVW R30,R28
	ADIW R30,26
	LD   R30,Z
	CPI  R30,LOW(0x2E)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	MOV  R30,R16
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x1B:
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LD   R20,Z
	CLR  R21
	MOV  R30,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1D:
	LDI  R31,0
	STD  Y+10,R30
	STD  Y+10+1,R31
	MOV  R31,R30
	LDI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1E:
	LDI  R31,0
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R26,LOW(_exponenty*2)
	LDI  R27,HIGH(_exponenty*2)
	ANDI R30,LOW(0x7)
	ANDI R31,HIGH(0x7)
	LSL  R30
	LSL  R30
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETD1PF
	__GETW2R 20,21
	CALL __CWD2
	CALL __CDF2
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	MOVW R26,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ANDI R30,LOW(0x70)
	ANDI R31,HIGH(0x70)
	CALL __ASRW4
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETD1PF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x46FFFE00
	CALL __DIVF21
	__PUTD1S 6
	MOV  R30,R16
	LDI  R26,LOW(_meas_data)
	LDI  R27,HIGH(_meas_data)
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	__GETD2S 6
	__PUTDZ2 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	__GETW1R 20,21
	__GETD2N 0x3F800000
	CALL __CWD1
	CALL __CDF1
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	LDI  R30,LOW(8)
	STS  __en1_msk,R30
	JMP  __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x23:
	LDI  R30,LOW(12)
	ST   -Y,R30
	JMP  __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x24:
	LDI  R30,LOW(4)
	STS  __en1_msk,R30
	JMP  __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	LDI  R30,LOW(15)
	ST   -Y,R30
	JMP  __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	CALL _lcd_clear
	LDS  R26,_key_pressed
	LDS  R27,_key_pressed+1
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x27:
	LDI  R30,LOW(4)
	ST   -Y,R30
	JMP  _send

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x28:
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_cursor_on

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x29:
	MOV  R30,R16
	LDI  R31,0
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R28
	ADIW R26,4
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x2B:
	MOV  R30,R17
	LDI  R26,LOW(_rozsahy)
	LDI  R27,HIGH(_rozsahy)
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2C:
	LDI  R30,LOW(9)
	ST   -Y,R30
	CALL _send
	RJMP SUBOPT_0x27

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2D:
	ST   -Y,R30
	CALL _send
	LDS  R30,_rozsahy
	ST   -Y,R30
	JMP  _send

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2E:
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2F:
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x30:
	LDI  R31,0
	STD  Y+5,R30
	STD  Y+5+1,R31
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __MULW12U
	MOV  R30,R31
	LDI  R31,0
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	SUB  R26,R30
	SBC  R27,R31
	STD  Y+5,R26
	STD  Y+5+1,R27
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x31:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x32:
	CALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x33:
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x34:
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x35:
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _send

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x36:
	LDI  R30,LOW(0)
	STS  _read_enable,R30
	RJMP SUBOPT_0x35

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x37:
	ST   -Y,R30
	CALL _send
	LDI  R30,LOW(1)
	STS  _read_enable,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x38:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x39:
	CALL __long_delay
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3A:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3B:
	STS  __en1_msk,R30
	CALL _lcd_init1_G2
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x3C:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3D:
	__GETD1N 0x41200000
	CALL __DIVF21
	__GETD2N 0x3F000000
	CALL __ADDF12
	CALL __PUTPARD1
	JMP  _floor

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3E:
	CALL __DIVF21
	CALL __CFD1
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3F:
	MOV  R30,R17
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x40:
	CALL __SWAPD12
	CALL __SUBF12
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x41:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x42:
	__GETD2S 3
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x43:
	__GETD1S 3
	__GETD2S 11
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x44:
	__GETD2S 11
	__GETD1N 0x41200000
	CALL __DIVF21
	__PUTD1S 11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x45:
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	ADIW R26,1
	STD  Y+7,R26
	STD  Y+7+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x46:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,1
	STD  Y+7,R30
	STD  Y+7+1,R31
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x47:
	ST   -Y,R19
	LDD  R30,Y+35
	LDD  R31,Y+35+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x48:
	LDD  R26,Y+36
	LDD  R27,Y+36+1
	SBIW R26,4
	STD  Y+36,R26
	STD  Y+36+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x49:
	ST   -Y,R30
	LDD  R30,Y+35
	LDD  R31,Y+35+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4A:
	__PUTD1S 8
	LDI  R30,LOW(45)
	STD  Y+17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4B:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4C:
	__GETD1S 8
	CALL __PUTPARD1
	ST   -Y,R21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4D:
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R16,R30
	RET

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R19
	CLR  R20
	LDI  R21,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R19
	ROL  R20
	SUB  R0,R30
	SBC  R1,R31
	SBC  R19,R22
	SBC  R20,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R19,R22
	ADC  R20,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R21
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOV  R24,R19
	MOV  R25,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODB21:
	CLT
	SBRS R26,7
	RJMP __MODB211
	NEG  R26
	SET
__MODB211:
	SBRC R30,7
	NEG  R30
	RCALL __DIVB21U
	MOV  R30,R26
	BRTC __MODB212
	NEG  R30
__MODB212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1PF:
	LPM  R0,Z+
	LPM  R1,Z+
	LPM  R22,Z+
	LPM  R23,Z
	MOVW R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	MOV  R21,R30
	MOV  R30,R26
	MOV  R26,R21
	MOV  R21,R31
	MOV  R31,R27
	MOV  R27,R21
	MOV  R21,R22
	MOV  R22,R24
	MOV  R24,R21
	MOV  R21,R23
	MOV  R23,R25
	MOV  R25,R21
	MOV  R21,R0
	MOV  R0,R1
	MOV  R1,R21
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __MAXRES
	RJMP __MINRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__LSLB3:
	LSL  R30
	LSL  R30
	LSL  R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
